<?php
$explan = 'アクセスの多い順にページ名を一覧表示';
$format = "[[access]]	// 基本形
[[access(20)]]	// 表示件数を指定する場合
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function access($nmb = '', $sort = '') {
	$logdir = './data/counter';
	if (!is_dir($logdir)) { return; }
	if (! preg_match('/^\d+$/',$nmb)) {
		$sort = $nmb;
		$nmb = '';
	}
	if (!$nmb) {
		$nmb = 10;
	}
	$tmpdir = opendir($logdir);
	$log_list = array();
	$access = array();
	while ($file = readdir($tmpdir)) {
		if (preg_match('/(^[a-zA-Z0-9]+)\.cgi$/',$file,$matched)) {
			$log_list[] = $file;
			$access[$matched[1]] = filesize($logdir . '/' . $file);
		}
	}
	closedir($tmpdir);
	if (!$sort || $sort == 'descend') {
		arsort($access);
		$sort = 'descend';
	} else {
		asort($access);
		$sort = 'ascend';
	}
	$str = '';
	$count = 0;
	$end = '';
	foreach ($access as $key=>$val) {
		if (!file_exists('./data/' . $key . '.cgi')) {
			continue;
		}
		if (!$val || ($sort == 'descend' && $end && $val < $end) || ($sort == 'ascend' && $end && $val > $end)) {
			break;
		}
		list($log) = file('./data/' . $key . '.cgi');
		$tmp = explode('<>',$log);
		$hash = array('noform'=>$key);
		if (req('sort')) {
			$hash['sort'] = req('sort');
		}
		$link = script_link($hash);
		list($name) = explode('&&',$tmp[2]);
		$str .= "<li><a href=\"$link\">" . $name . "</a>($val)</li>\n";
		$count++;
		if ($count >= $nmb) {
			$end = $val;
		}
	}
	if ($str) {
		$str = "<ol>\n" . $str . "</ol>\n";
	}
	return $str;
}
?>