<?php
global $bbs_help;
$explan = "掲示板を作成する
■ファイルアップロード
■返信
■過去ログ生成
■隠しパラメータ送信によるスパム投稿対策
■スライドロックによるスパム投稿対策機能搭載
オプションは[[bbs('lock=1|max_log=100|item=thread')]]のように指定
<h3>使用できるタグ</h3>
!perm_tag!
<h3>指定できるオプション</h3>
<dl><dt>form</dt><dd>form=up（フォームを上に表示）　form=down（フォームを下に表示）</dd></dl>
<dl><dt>item</dt><dd>デフォルトの記事表示順を指定
item=time（投稿順）　item=thread（スレッドごとに表示）</dd></dl>
<dl><dt>tag</dt><dd>使用できるタグを指定
tag=pre:span　複数指定する場合は:(コロン)で区切る</dd></dl>
<dl><dt>max_log</dt><dd>現行ログの保存数。これを超えると過去ログに移動。
例　max_log=50</dd></dl>
<dl><dt>max_past</dt><dd>過去ログに保存する記事数。これを超えると過去ログファイルを新たに作成。
例　max_past=100</dd></dl>
<dl><dt>page_line</dt><dd>1ページに表示する記事数。これを超えると次のページに表示
例　page_line=10</dd></dl>
<dl><dt>lock</dt><dd>スライダで投稿ボタンをロックする　lock=1で表示する
例　lock=1</dd></dl>
<dl><dt>nameless</dt><dd>投稿者名未入力で投稿した場合、表示される名前を指定。'id'にすると、日付とIPアドレスを元にしたIDを表示
例　nameless=id</dd></dl>";
$bbs_help = $explan;
$format = "[[bbs('lock=1|nameless=id')]]
";
date_default_timezone_set('Asia/Tokyo');
////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function bbs($option = '') {
	global $img_ext,$bbs_help,$end,$script;
	global $title_, $writer_,$comment_,$date_,$id,$bbs_dir,$log,$id_path,$slide_lock;
	global $perm_tag_list,$hide_form;
	if (isset($_REQUEST['hide_form'])) {
		$hide_form = req('hide_form');
		setcookie("bbs_hide_form_" . article_id(), req('hide_form'), time() + 3600*24);
	} elseif (isset($_COOKIE['bbs_hide_form_' . article_id()])) {
		$hide_form = $_COOKIE['bbs_hide_form_' . article_id()];
	}
	if (req('res') || (req('hashed') && req('bbs_pass'))) { $hide_form = 0; }
	$perm_tag_list = array('span','pre');		// 使えるタグはここで指定する
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			$option[$tmp2[0]] = $tmp2[1];
		}
	} else {
		unset($option);
	}
	if (!isset($option['form'])) { $option['form'] = 'up'; }	// フォームの表示位置
	if (!isset($option['item'])) { $option['item'] = 'time'; }	// ログの保存数
	if (!isset($option['tag'])) { $option['tag'] = join(':',$perm_tag_list); }	// ログの保存数
	if (!isset($option['lock'])) { $option['lock'] = ''; }	// スライドロック表示
	if (!isset($option['nameless'])) { $option['nameless'] = '名無し'; }	// スライドロック表示
	//if ($option['nameless'] == 'id') { $option['nameless'] = user_id(); }
	if ($option['lock']) { $slide_lock = 1; } else { $slide_lock = 0; }
	$perm_tag_list = explode(':',$option['tag']);
	$item = $option['item'];
	if (req('item')) { $item = req('item'); }
	if (!isset($option['max_log'])) { $option['max_log'] = 100; }	// ログの保存数
	if (!isset($option['max_past'])) { $option['max_past'] = 100; }	// 過去ログの最大数
	if (!isset($option['page_line'])) { $option['page_line'] = 10; }	// 1ページあたりの記事数
	$str = '';
	if (req('bbs_help')) {
		$hash = array('plugin'=>'bbs','id'=>$id,'bbs_help'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
		$str .= "<h2 id=\"bbs_help\">bbs.phpのヘルプ</h2>";
		$bbs_help = preg_replace('/>\n+/',">\n",$bbs_help);
		$tmp = explode("\n",$bbs_help);
		foreach ($tmp as $_) {
			$mat = $trans = '';
			if (preg_match('/<dt>([^<]+)<\/dt>/',$_,$mat)) {
				if (isset($mat[1]) && isset($option[$mat[1]])) {
					$trans = " (現在の設定は" . $mat[1] . '=' . $option[$mat[1]] . ')';
				}
				$_ = preg_replace('/<dt>([^<]+)<\/dt>/',"<b>" . $mat[1] . "</b>" . $trans,$_);
			}
			if (!preg_match('/>$/',$_)) {
				$str .= $_ . "<br />\n";
			} else {
				$str .= $_ . "\n";
			}
		}
		$str = str_replace("\n","|n|",$str);
		$str = str_replace("!perm_tag!",join(',',$perm_tag_list),$str);
		return $str;
	}
	$id = article_id();
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (!$id) { return; }
	$id_dir = article_dir($id);
	if ($id_dir && !is_dir($id_dir)) { mkdir($id_dir); }
	$bbs_dir = join('/',array($id_dir,'bbs'));
	if (! is_dir($bbs_dir)) { mkdir($bbs_dir); }
	$id_path = join('/',array($id_dir,'bbs','bbs.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		$last = end($log);
		$last = rtrim($last);
	}
	if (req('bbs_admin')) {
		$login_time = 30;
		$mes = '';
		if (! file_exists($bbs_dir)) { mkdir($bbs_dir); }
		if (! file_exists($bbs_dir. '/login')) { mkdir($bbs_dir. '/login'); }
		$login_dir = $bbs_dir. '/login';
		$tmpdir = opendir($login_dir);
		while ($file = readdir($tmpdir)) {
			if (preg_match('/^\w{10}_/',$file) && filemtime($login_dir . '/' . $file) + 60 * $login_time < time()) {
				unlink($login_dir . '/' . $file);
			}
		}
		closedir($tmpdir);
		$hash = array();
		foreach (array_keys($_REQUEST) as $key) {
			if (preg_match('/^bbs_admin/',$key)) { continue; }
			if (preg_match('/^(comment_|mod_|del_|pass)/',$key)) { continue; }
			$hash[$key] = req($key);
		}
		$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
		$hash['bbs_admin'] = 1;
		if (req('bbs_admin_login')) {
			$hash['bbs_admin_login'] = req('bbs_admin_login');
			$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash,'bbs') . "\">再読み込み</a>";
		}
		if (!req('bbs_admin_login')) {
			if (! req('pass')) {
				$hash = array();
				foreach (array_keys($_REQUEST) as $key) {
					$hash[$key] = req($key);
				}
				$str .= script_form($hash,'bbs');
				if (isset($_COOKIE['bbs_admin_pass'])) {
					$cpass = $_COOKIE['bbs_admin_pass'];
				} else {
					$cpass = '';
				}
				$str .= "<input type=\"password\" name=\"pass\" value=\"$cpass\" size=\"12\">";
				$str .= " <input type=\"submit\" name=\"login\" value=\"ログイン\">";
				$str .= "</form>\n";
				return $str;
			} else {
				global $crypt_pass, $cookietime;
				if (decrypt(req('pass'), $crypt_pass) === 'no') {
					error("パスワードが認証できません");
				} else {
					$login_id = random_str(10);
					$hash['bbs_admin_login'] = $login_id;
					file_put_contents(join('/',array($login_dir, $login_id . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
					// クッキーの場合、エポック時間はどうなるのか？
					setcookie("bbs_admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
					setcookie("bbs_cpass", req('pass'), time() + 3600*24);		// アクセス権限を管理者レベルにするためのクッキー
				}
				$hash['pass'] = '';
			}
		} else {
			$login_path = join('/',array($login_dir, req('bbs_admin_login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi'));
			$lhash = array('plugin'=>'bbs','id'=>req('id'),'noform'=>req('noform'),'sort'=>req('sort'),'bbs_admin'=>1);
			$relogin = script_link($lhash,'bbs');
			if (! file_exists($login_path) ) {
				error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
			} else {
				if (filemtime($login_path) + 60 * $login_time < time()) {
					unlink($login_path);
					error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
				} else {
					file_put_contents($login_path,'',LOCK_EX);
				}
			}
		}
		foreach (array_keys($_REQUEST) as $key) {
			if (preg_match('/^del_(\w+$)/',$key,$match)) {
				$del_id = $match[1];
				$new_log = array();
				foreach ($log as $line) {
					$tmp = explode('<>',$line);
					if ($tmp[0] != $del_id) {
						$new_log[] = $line;
					} else {
						$mes .= '<strong>[' . $tmp[2] . ']</strong> の記事を削除しました。';
					}
				}
				$log = $new_log;
				file_put_contents($id_path,$log,LOCK_EX);
				break;
			} elseif (preg_match('/^mod_(\w+$)/',$key,$match)) {
				$mod_id = $match[1];
				$new_log = array();
				foreach ($log as $line) {
					$tmp = explode('<>',$line);
					if ($tmp[0] == $mod_id) {
						$tmp[4] = req('comment_' . $mod_id);
						$tmp[4] = str_replace("\r\n","\n",$tmp[4]);
						$tmp[4] = str_replace("\r","\n",$tmp[4]);
						$tmp[4] = str_replace("\n",'<br />',$tmp[4]);
						$line = join('<>',$tmp);
						$mes .= '<strong>[' . $tmp[2] . ']</strong> の記事を修正しました。';
					}
					$new_log[] = $line;
				}
				$log = $new_log;
				file_put_contents($id_path,$log,LOCK_EX);
			}
		}
		if (file_exists($bbs_dir . '/' . 'bbs_spamlog.cgi')) {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_spam'=>1);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash) . "#bbs_block\">拒否投稿</a>";
		}
		$str .= "<div style=\"color:crimson\">$mes</div>\n";
		$str .= script_form($hash,'bbs');
		$str .= "<table border=\"1\" cellspacing=\"0\" cellpadding=\"4\">\n";
		$str .= "<tr><th>日時</th><th>タイトル</th><th>投稿者</th><th>コメント</th><th style=\"white-space:nowrap;\">修正<br />削除</th></tr>\n";
		$hash['bbs_admin'] = 1;
		foreach (array_reverse($log) as $line) {
			$tmp = explode('<>',$line);
			$comment = $tmp[4];
			$comment = str_replace('<br />',"\n",$comment);
			$str .= "<tr><td style=\"font-size:80%;\">" . $tmp[1] . "</td><td>" . $tmp[2] . "</td><td>" . $tmp[3] . "</td><td><textarea name=\"comment_" . $tmp[0] . "\">" . $comment . "</textarea></td>";
			$str .= "<td><input type=\"submit\" name=\"mod_" . $tmp[0] . "\" value=\"修正\" style=\"font-size:80%;\">";
			$hash['del_' . $tmp[0]] = 1;
			$str .= "<br /><input type=\"submit\" name=\"del_" . $tmp[0] . "\" value=\"削除\" style=\"font-size:80%;\"></td>";
			unset($hash['del_' . $tmp[0]]);
			$str .= "</tr>\n";
		}
		$str .= "</table>\n";
		$str .= "</form>\n";
		$str = str_replace("\n","|n|",$str);
		return $str;
	} elseif (req('show_spam')) {
		$hash = array('plugin'=>'bbs');
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$str .= "<div><a href=\"" . script_link($hash) . "\">戻る</a></div>\n";
		$spam_log = file($bbs_dir . '/' . 'bbs_spamlog.cgi');
		if (count($spam_log) > 100) {
			array_shift($spam_log);
			file_put_contents($bbs_dir . '/' . 'bbs_spamlog.cgi',$spam_log,LOCK_EX);
		}
		$spam_log = array_reverse($spam_log);
		$count = 0;
		foreach ($spam_log as $line) {
			$count++;
			if ($count % 2) { $back_color = " style=\"background-color:#eeeeee;\""; } else { $back_color = ''; }
			$tmp = explode('<>',$line);
			$tmp[1] = 1 * $tmp[1];
			if (preg_match('/^\d+$/',$tmp[6])) {
				$block = $tmp[6] . '秒';
			} elseif ($tmp[6]) {
				$block = $tmp[6];
			} else {
				$block = '投稿IDなし';
			}
			if (mb_strlen($tmp[4]) > 140) {
				$comment = jtruncate($tmp[4],140) . '...';
			} else {
				$comment = $tmp[4];
			}
			$comment = str_replace("<","&lt;",$comment);
			$comment = str_replace(">","&gt;",$comment);
			$str .= "<tr$back_color><td style=\"font-size:80%;\">" . date("Y/m/d H:i:s", $tmp[1]) . "</td><td>" . $tmp[2] . "</td><td>" . $tmp[3] . "</td><td>" . $comment . "</td><td>" . $block . "</td></tr>\n";
			$agent = user_agent($tmp[9]);
			if (is_array($agent)) { $agent = join(',',$agent); }
			$str .= "<tr$back_color><td>" . $tmp[7] . "</td><td>" . $tmp[8] . "</td><td colspan=\"3\"><a title=\"" . $tmp[9] . "\">" . $agent . "</a></td></tr>\n";
		}
		if ($str) {
			$thead = "<caption id=\"bbs_block\">ブロックした投稿</caption>";
			$thead .= "<tr><th>時間</th><th style=\"white-space:nowrap;\">タイトル</th><th style=\"white-space:nowrap;\">投稿者</th><th>内容</th><th style=\"white-space:nowrap;\">拒否</th></tr>\n";
			$thead .= "<tr><th>IPアドレス</th><th>ホスト</th><th colspan=\"3\">エージェント</th></tr>\n";
			$str = "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">$thead$str</table>\n";
		}
		$str = str_replace("\n","|n|",$str);
		return $str;
	}
	if (req('bbs_keyword') && req('search')) {
		$hit_list = array();
		$hit_count = 0;
		$result = '';
		$tmp_key = req('bbs_keyword');
		$tmp_key = str_replace('　',' ',$tmp_key);
		$tmp_key = preg_replace('/\s+/',' ',$tmp_key);
		$tmp_key = preg_replace('/^\s+/','',$tmp_key);
		$tmp_key = preg_replace('/\s+$/','',$tmp_key);
		$key_list = explode(' ',$tmp_key);
		$tmpdir = opendir($bbs_dir);
		while ($file = readdir($tmpdir)) {
			$titles = $ids = $tms = array();
			if (preg_match('/^bbs(_\d+)?\.cgi$/',$file)) {
				$log = file($bbs_dir . '/' . $file);
				$log = array_reverse($log);
				$line_nmb = 1;
				foreach ($log as $line) {
					$hit = 1;
					foreach ($key_list as $k) {
						if (!preg_match('/(.{0,30})' . $k . '(.{0,30})/is',$line,$matched)) {
							$hit = 0;
							break;
						}
					}
					if ($hit) {
						$tmp = explode('<>',$line);
						if (!isset($mat[$tmp[0]])) {
							$mat[$tmp[0]] = $matched[0] . " $file $line_nmb";
						} else {
							$mat[$tmp[0]] .= $matched[0] . " $file $line_nmb";
						}
						$titles[$tmp[0]] = $tmp[2];
						$tms[$tmp[0]] = $tmp[1];
						$hit_list[] = $tmp[0];
						$hit_count++;
					}
					$line_nmb++;
				}
				foreach ($titles as $key=>$val) {
					$mat[$key] = str_replace('<','&lt;',$mat[$key]);
					$mat[$key] = str_replace('>','&gt;',$mat[$key]);
					$mat[$key] = keyword_coloring($mat[$key],req('bbs_keyword'),'color:crimson');
					$hash = array('plugin'=>'bbs','noform'=>$id,'sort'=>req('sort'),'id2'=>$key,'bbs_keyword'=>req('bbs_keyword'));
					if (req('item')) { $hash['item'] = req('item'); }
					if ($file != 'bbs.cgi') {
						$hash['show_past'] = 1;
						$hash['file'] = $file;
					}
					$result .= "<li><a href=\"" . script_link($hash) . "#bbs_$key" . "\">[" . $val . "]</a>&nbsp;&nbsp;<br /><span style=\"font-size:80%;\">" . $mat[$key] . "</span></li>\n";
				}
			}
		}
		closedir($tmpdir);
		if ($result) { $result = "<ul>$result</ul>\n"; }
		$result = $hit_count . '件ヒット' . $result;
		$form = form();
		$str .= $form . $result;
		return $str;
	}
	if (req('show_past')) {
		$file_nmb = 1;
		while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
			$file_nmb++;
		}
		if (req('past_nmb')) {
			$past_nmb = req('past_nmb');
		} else {
			$past_nmb = $file_nmb - 1;
		}
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		if (req('id2')) { $past_path = $bbs_dir . '/' . req('file'); }
		$log = file($past_path);
		$log = array_reverse($log);
		if ($item == 'thread') {
			$thread = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				$line_[$tmp[0]] = $line;
				$ptitle = preg_replace('/^Re:\s*/','',$tmp[2]);
				if (!isset($thread[$ptitle])) { $thread[$ptitle] = array(); }
				array_push($thread[$ptitle],$tmp[0]);
			}
			$new_log = array();
			foreach ($thread as $ptitle=>$val) {
				foreach ($val as $_) {
					$new_log[] = $line_[$_];
				}
			}
			$log = $new_log;
		}
		if (req('id2')) {
			$count = 0;
			foreach ($log as $line) {
				$tmp =explode('<>',$line);
				if ($tmp[0] == req('id2')) {
					$past_nmb = intval($count / $option['page_line']);
					break;
				}
				$count++;
			}
		}
		$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$indx = "<a href=\"" . script_link($hash) . "\">戻る</a>&nbsp;<strong>過去ログ</strong>&nbsp;";
		$nmb = 1;
		$show_next_id = 0;
		for ($i=$file_nmb-1; $i>=1; $i--) {
			if ($i == $past_nmb) {
				$indx .= "<b>[$nmb]</b> \n";
			} else {
				$hash = array('plugin'=>'bbs','id'=>$id,'past_nmb'=>$i,'show_past'=>1);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('item')) { $hash['item'] = req('item'); }
				$link = script_link($hash) . "#next_page";
				if (!$show_next_id) {
					$indx .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a> \n";
					$show_next_id = 1;
				} else {
					$indx .= "<a href=\"$link\">[" . $nmb . "]</a> \n";
				}
			}
			$nmb++;
		}
		if ($item == 'time') {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>'1','item'=>'thread');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= " <strong style=\"font-size:80%;\">投稿順に表示</strong> <a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">スレッドごとに表示</a>";
		} else {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>'1','item'=>'time');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= " <a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">投稿順に表示</a> <strong style=\"font-size:80%;\">スレッドごとに表示</strong>";
		}
		$str .= $indx;
		$com = '';
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			list($id,$date,$title,$name,$comment,$hashed) = $tmp;
			if (isset($tmp[6])) { $rewrite = $tmp[6]; }
			$com .= "<li id=\"bbs_" . $id . "\"><strong>$title</strong>&nbsp;$date&nbsp;$name<br />";
			$attach = '';
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (strpos($file,$id) !== false && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$ext = pathinfo($file,PATHINFO_EXTENSION);
					if (in_array($ext,$img_ext)) {
						list($image_w, $image_h) = getimagesize($bbs_dir . "/$file");
						$width = 500;
						$proportion = $image_w / $image_h;
						$height = $width / $proportion;
						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
						if($proportion < 1){
							$height = $width;
							$width = $width * $proportion;
							$width = intval($width * 0.8);
							$height = intval($height * 0.8);
						}
						if ($width > $image_w) { $width = $image_w; }
						$attach .= "<br /><img src=\"" . $bbs_dir . "/$file\" width=\"$width\" alt=\"$file\" title=\"$file\" onclick=\"cmanImgPop(this,'')\" />\n";
						$oname = $bbs_dir . '/' . $file . '.oname';
						$org = $file;
						if (file_exists($oname)) { list($org) = file($oname); }
						$hash = array('mode'=>'download', 'file'=>$bbs_dir . '/' . $file, 'name'=>urlencode($org));
						$link = script_link($hash);
						$attach .= "<br /><a href=\"$link\">$org</a>\n";
					}
				}
			}
			closedir($tmpdir);
			if (req('id2') == $tmp[0] && req('bbs_keyword')) { $comment = keyword_coloring($comment,req('bbs_keyword'),'color:#0000cc'); }
			$com_line = preg_split('/<br( \/)?>/',$comment);
			$tmp_list = array();
			foreach ($com_line as $line) {
				if (preg_match('/^(&gt;|>)/',$line)) {
					$line = "<span style=\"border-radius:5px;padding:0.2em;background-color:#f0fafa;color:#444444;\">$line</span>";
				}
				$tmp_list[] = $line;
			}
			$comment = join('<br />',$tmp_list);
			$com .= "$comment\n$attach<hr /></li>\n";
		}
		if ($com) { $com = "<ul>$com</ul>\n"; }
		$str .= $com;
		$indx2 = str_replace('name="next_page"','',$indx);
		$indx2 = str_replace('id="next_page"','',$indx2);
		$str .= $indx2;
		$str = str_replace("\n","|n|",$str);
		return $str;
	}
	if ((req('posted') || req('bbs_delete')) && req('plugin') == 'bbs') {
		$req = '';
		foreach ($_REQUEST as $key=>$val) { $req .= "$key → $val\n"; }
		$req .= "--------------------------------------------\n";
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			$post_id_file = $bbs_dir . '/' . req('post_id') . '.cgi';
			if (! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
				spam_log('ひらがな無し');
				error('コメントにひらがなが含まれていません');
			}
			if (req('email')) {
				spam_log('ダミー');
				error('不正な投稿です');
			}
			if (!req('post_id') || !file_exists($post_id_file)) {
				spam_log();
				error('不正な投稿です' . $post_id_file . 'が存在しません');
			} elseif (!req('rewrite') && !req('delete') && filemtime($post_id_file) + 8 > time()) {
				spam_log(time() - filemtime($post_id_file));
				error('もう少し時間をおいてから投稿してください。');
			} elseif ($option['lock'] && !req('sliderInput')) {
				spam_log('slidelock無視');
				error('スライドロックを解除してください');
			} else {
				unlink($post_id_file);
			}
			if (!is_dir($bbs_dir)) { mkdir($bbs_dir); }
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace(">\n",">|n|",$comment);
			$comment = str_replace("\n","<br />",$comment);
			$title = req('title');
			if (req('writer')) {
				$writer = '<strong>' . strip_tags(req('writer')) . '</strong>';
			} else {
				$writer = '';
			}
			$tmp = explode('<>',$last);
			$id2 = $tmp[0];
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[4] && $tm == $tmp[1]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$title || preg_match('/^無題\d*$/',$title)) {
					foreach ($log as $line) {
						$tmp = explode('<>',$line);
						if (preg_match('/^無題(\d*)?$/',$tmp[2],$mat)) {
							if ($mat[1] && is_numeric($mat[1])) {
								$title = '無題' . ($mat[1] + 1);
							} else {
								$title = '無題1';
							}
						}
					}
					if (!$title) { $title = '無題'; }
				}
				if (!$writer) {
					if ($option['nameless'] == 'id') {
						$writer = user_id();
					} else {
						$writer = $option['nameless'];
					}
				}
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[0] == req('id2') && $tmp[5] == req('hashed')) {
							$id2 = $tmp[0];
							if (req('bbs_delete')) {
								$tmpdir = opendir($bbs_dir);
								while ($file = readdir($tmpdir)) {
									if (preg_match('/^' . $id2 . '/',$file)) {
										unlink($bbs_dir . '/' . $file);
									}
								}
								closedir($tmpdir);
								continue;
							} else {
								$hashed = $tmp[5];
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($id2,$tm,$title,$writer,$comment,$hashed,'再編集'));
							}
						}
						$new_log[] = $line . "\n";
					}
					file_put_contents($id_path,$new_log,LOCK_EX);
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$id2 = random_str(10);
					$line = join('<>',array($id2,$tm,$title,$writer,$comment,$hashed)) . "\n";
					file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
				}
			}
			if ($_FILES['upfile']["error"] == UPLOAD_ERR_OK) {
				$tmp_name = $_FILES['upfile']["tmp_name"];
				$t_name = $_FILES['upfile']["name"];	// とりあえず元のファイル名から拡張子を取るだけ
				$ext = pathinfo($t_name, PATHINFO_EXTENSION);
				if (! is_dir($bbs_dir)) {
					mkdir($bbs_dir);
				}
				$up_path = $bbs_dir . '/' . $id2 . '.' . $ext;
				if (file_exists($up_path)) {
					$del_file = 1;
					for ($i=1;$i<=5;$i++) {
						$tmp_path = $bbs_dir . '/' . $id2 . "_$i" . '.' . $ext;
						if (!file_exists($tmp_path)) {
							$up_path = $tmp_path;
							$del_file = 0;
							break;
						}
					}
					if ($del_file) {
						unlink($up_path);
					}
				}
				move_uploaded_file($tmp_name, $up_path);
				// 画像ファイルの場合サムネールを作成
				if (in_array($ext,$img_ext)) { thumb($up_path,'100'); }
				$onfile = $up_path . '.oname';
				file_put_contents($onfile,$t_name,LOCK_EX);
			}
		}
	} elseif (req('del_file')) {
		if (decrypt(req('bbs_pass'), req('hashed')) == 'yes') {
			$del_file = $bbs_dir . '/' . req('del_file');
			if (file_exists($del_file)) { unlink($del_file); }
			$thumb_file = preg_replace('/(\..{2,4}$)/','thumb$1',$del_file);
			if (file_exists($thumb_file)) { unlink($thumb_file); }
			$oname_file = $del_file . '.oname';
			if (file_exists($oname_file)) { unlink($oname_file); }
		} else {
			error('編集パスワードが違います');
		}
	}
	$log = array();
	if (is_dir($bbs_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $option['max_log']) {
			$past_log = array_splice($log,0,(count($log) - $option['max_log']));
			$file_nmb = 1;
			while (1) {
				$past_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path);
				if (!file_exists($past_path) || count(file($past_path)) < $option['max_past']) {
					file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
					break;
				}
				$file_nmb++;
			}
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if ($log) {
		$log = array_reverse($log);	// 新しい順に表示するのに固定
		if ($item == 'thread') {
			$thread = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				$line_[$tmp[0]] = $line;
				$ptitle = preg_replace('/^Re:\s*/','',$tmp[2]);
				if (!isset($thread[$ptitle])) { $thread[$ptitle] = array(); }
				array_push($thread[$ptitle],$tmp[0]);
			}
			$new_log = array();
			foreach ($thread as $ptitle=>$val) {
				foreach ($val as $_) {
					$new_log[] = $line_[$_];
				}
			}
			$log = $new_log;
		}
		$line_nmb = 0;
		if (! req('page')) {
			$page = 0;
		} else {
			$page = req('page');
		}
		$end = intval((count($log) - 1)/$option['page_line']);
		if (req('id2')) {
			$count = 0;
			foreach ($log as $line) {
				$tmp =explode('<>',$line);
				if ($tmp[0] == req('id2')) {
					$page = intval($count / $option['page_line']);
					break;
				}
				$count++;
			}
		}
		$indx = '';
		if ($end > 0) {
			$show_next_id = 0;
			for ($i=0; $i<=$end; $i++) {
				if ($i == $page) {
					$indx .= "<b>[" . ($i+1) . "]</b> \n";
				} else {
					$hash = array('plugin'=>'bbs','id'=>$id,'page'=>$i);
					if (req('noform')) { $hash['noform'] = req('noform'); }
					if (req('sort')) { $hash['sort'] = req('sort'); }
					if (req('item')) { $hash['item'] = req('item'); }
					$link = script_link($hash) . "#next_page";
					if (!$show_next_id) {
						$indx .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . ($i+1) . "]</a> \n";
						$show_next_id = 1;
					} else {
						$indx .= "<a href=\"$link\">[" . ($i+1) . "]</a> \n";
					}
				}
			}
		}
		$past_path = preg_replace('/\.cgi$/','_1.cgi',$id_path);
		if (file_exists($past_path)) {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>1);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$indx .= "<a href=\"" . script_link($hash) . "\">過去ログ</a>";
		}
		if ($end) {
			if ($item == 'time') {
				$hash = array('plugin'=>'bbs','id'=>$id,'item'=>'thread');
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				$indx .= " <strong style=\"font-size:80%;\">投稿順に表示</strong> <a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">スレッドごとに表示</a>";
			} else {
				$hash = array('plugin'=>'bbs','id'=>$id,'item'=>'time');
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				$indx .= " <a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">投稿順に表示</a> <strong style=\"font-size:80%;\">スレッドごとに表示</strong>";
			}
		}
		if ($indx) { $indx = "<div style=\"margin-left:1em;\">$indx</div>\n"; }
		if (req('id2') && req('posted')) {
			$hash = array('plugin'=>'bbs');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= "<a href=\"" . script_link($hash) . "\">戻る</a>";
		}
		$str .= $indx . "<ul style=\"list-style-type: none;padding:1em;\">\n";
		$last_title = $back_color = '';
		foreach ($log as $line) {
			if ($line_nmb < $page * $option['page_line'] || $line_nmb >= ($page + 1) * $option['page_line']) {
				$line_nmb++;
				continue;
			}
			$tmp = explode('<>',$line);
			$id2 = $tmp[0];
			$tmp[5] = rtrim($tmp[5]);
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('plugin'=>'bbs','id'=>$id,'hashed'=>$tmp[5],'id2'=>$id2);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			} elseif ($id) {
				$hash['noform'] = $id;
			}
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('page')) { $hash['page'] = req('page'); }
			$edit_link = script_link($hash);
			$tmp[5] = rtrim($tmp[5]);
			$ptitle = preg_replace('/^Re:\s*/','',$tmp[2]);
			$style = 'margin:0.3em;';
			if ($item == 'thread' && $last_title && $last_title !== $ptitle) {
				if ($back_color) {
					$back_color = '';
				} else {
					$back_color = "background-color:#eeeeee;";
				}
				$str .= "</ul>\n<ul style=\"list-style-type: none;padding:1em;$back_color\">\n";
			}
			$last_title = $ptitle;
			$new = '';
			if (strtotime($tmp[1]) + 3600*24*3 > time()) {
				$new = "<span style=\"color:crimson;font-weight:bold;font-size:80%;\">new</span> ";
			}
			if (req('hashed') && req('hashed') == $tmp[5] && !req('bbs_pass') && !req('posted')) {
				$str .= "<li id=\"bbs_" . $tmp[0] . "\" style=\"$style\">";
			} else {
				$str .= "<li id = \"bbs_" . $tmp[0] . "\" style=\"$style\">";
			}
			$str .= "$new<strong>" . $tmp[2] . "</strong>&nbsp;<span style=\"font-size:80%;\">" . $tmp[1] . "</span> " . $tmp[3];
			$hash = array('plugin'=>'bbs','id'=>$id,'id2'=>$id2,'res'=>1);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			} elseif ($id) {
				$hash['noform'] = $id;
			}
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('page')) { $hash['page'] = req('page'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$res_link = script_link($hash);
			$str .= "&nbsp;&nbsp;<a href=\"$res_link\">返信</a>";
			if ($tmp[5]) {
				$str .= "&nbsp;&nbsp;<a href=\"$edit_link#bbs_$id2\">編集</a>\n";
			}
			$str .= "<br />\n";
			if (req('id2') == $tmp[0] && req('bbs_keyword')) { $tmp[4] = keyword_coloring($tmp[4],req('bbs_keyword'),'background-color:#998822'); }
			$tmp2 = explode('<br />',$tmp[4]);
			$tmp_list = array();
			foreach ($tmp2 as $line) {
				if (preg_match('/^(&gt;|>)/',$line)) {
					$line = "<span style=\"border-radius:5px;padding:0.2em;background-color:#f0fafa;color:#444444;\">$line</span>";
				}
				$tmp_list[] = $line;
			}
			$str .= join('<br />',$tmp_list);
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^' . $id2 . '/',$file) && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$ext = pathinfo($file,PATHINFO_EXTENSION);
					if (in_array($ext,$img_ext)) {
						list($image_w, $image_h) = getimagesize($bbs_dir . "/$file");
						$width = 500;
						$proportion = $image_w / $image_h;
						$height = $width / $proportion;
						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
						if($proportion < 1){
							$height = $width;
							$width = $width * $proportion;
							$width = intval($width * 0.8);
							$height = intval($height * 0.8);
						}
						if ($width > $image_w) { $width = $image_w; }
						$file_path = $bbs_dir . "/$file";
						$dl = '';
						if (file_exists($file_path . '.count')) {
							$dl = " title=\"" . filesize($file_path . '.count') . "dl\"";
						}
						$str .= "<br /><img src=\"" . $bbs_dir . "/$file\" width=\"$width\" alt=\"$file\" title=\"$file\" onclick=\"cmanImgPop(this,'')\" />\n";
					} else {
						$oname = $bbs_dir . '/' . $file . '.oname';
						$org = $file;
						if (file_exists($oname)) { list($org) = file($oname); }
						$sjis_org = mb_convert_encoding($org,'SJIS','UTF-8');
						$file_path = $bbs_dir . '/' . $file;
						$hash = array('mode'=>'download', 'file'=>$file_path, 'name'=>urlencode($sjis_org));
						$link = script_link($hash);
						$dl = '';
						if (file_exists($file_path . '.count')) {
							$dl = "&nbsp;" . filesize($file_path . '.count') . 'dl';
						}
						$str .= "<br /><a href=\"$link\">$org</a>$dl<br />\n";
					}
				}
			}
			closedir($tmpdir);

//			if (req('id2') == $tmp[0] && req('bbs_keyword')) { $tmp[4] = keyword_coloring($tmp[4],req('bbs_keyword'),'background-color:#998822'); }
//			$tmp2 = explode('<br />',$tmp[4]);
//			$tmp_list = array();
//			foreach ($tmp2 as $line) {
//				if (preg_match('/^(&gt;|>)/',$line)) {
//					$line = "<span style=\"border-radius:5px;padding:0.2em;background-color:#f0fafa;color:#444444;\">$line</span>";
//				}
//				$tmp_list[] = $line;
//			}
//			$str .= join('<br />',$tmp_list);

			if (req('hashed') && req('hashed') == $tmp[5] && !req('bbs_pass') && !req('posted')) {
				$hash = array('plugin'=>'bbs','id'=>$id,'hashed'=>req('hashed'),'id2'=>$id2);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('page')) { $hash['page'] = req('page'); }
				$str .= script_form_file($hash,'bbs');
				$str .= "&nbsp;&nbsp;<span style=\"font-size:80%;color:#0066dd;\">編集パスワードを入力してください</span>&nbsp;<input type=\"text\" name=\"bbs_pass\" value=\"\" style=\"width:140px;\" /><input id=\"bbs\" type=\"submit\" value=\"編集\" />";
				$str .= "</form>\n";
			} elseif (req('hashed') && req('hashed') == $tmp[5] && req('bbs_pass') && ! password_verify(req('bbs_pass'),req('hashed'))) {
				if ($tmp[5]) { $str .= "&nbsp;<span style=\"color:crimson\">パスワードが違います</span>"; }
			}
			$str .= "<hr />\n</li>\n";
			$comment_[$tmp[5]] = $tmp[4];
			$title_[$tmp[5]] = $tmp[2];
			$writer_[$tmp[5]] = $tmp[3];
			$date_[$tmp[5]] = $tmp[1];
			$line_nmb++;
		}
		$str .= "</ul>\n";
		$indx2 = str_replace('name="next_page"','',$indx);
		$indx2 = str_replace('id="next_page"','',$indx2);
		$str .= $indx2;
	}
	if ($hide_form) {
		$link = $script . "?plugin=bbs";
		//foreach ($_REQUEST as $key=>$val) {
		foreach (array('id','page','sort','item','noform') as $key) {
			if (req($key)) {
				$link .= "&amp;${key}=" . req($key);
			}
		}
		$link .= "&amp;hide_form=0";
		//$form = "<div style=\"padding-left:1em;\"><a href=\"$link\">■フォームを表示する</a></div>\n";
		//$form .= form();
	} else {
		//$form = form();
	}
	$form = form();
	$str = str_replace("\n","|n|",$str);
	$vars = get_defined_vars();
	
	if (!isset($option['form']) || !$option['form'] || $option['form'] == 'up') {
		return $form . $str;
	} elseif ($option['form'] == 'down') {
		return $str . $form;
	}
}

function form() {
	global $title_, $writer_,$comment_,$date_,$id,$bbs_dir,$log,$end,$id_path,$slide_lock,$img_ext,$script,$hash,$hide_form;
	if (!file_exists($bbs_dir)) { mkdir($bbs_dir); }
	$tenpu_list = array();
	$tmpdir = opendir($bbs_dir);
	while ($file = readdir($tmpdir)) {
		if (req('id2') && preg_match('/^' . req('id2') . '/',$file)) {
			if (!preg_match('/thumb\./',$file) && !preg_match('/\.oname/',$file)) {
				$tenpu_list[] = $file;
			}
		}
		if (! preg_match('/^\w{12}\.cgi$/',$file)) { continue; }
		if (filemtime($bbs_dir . '/' . $file) < time() - 60 * 20) {
				// 古いIDファイル(作成から20分経過)は削除
				unlink($bbs_dir . '/' . $file);
		}
	}
	closedir($tmpdir);
	$title = $writer = '';
	$comment = '';
	$post_id = random_str(12);
	$hash = array('plugin'=>'bbs','id'=>$id);
	if (req('id2') && req('bbs_pass') && !req('posted')) { $hash['id2'] = req('id2'); }
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('page')) { $hash['page'] = req('page'); }
	if (req('item')) { $hash['item'] = req('item'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	$hash['page'] = 0;
	if ($slide_lock) {
		$form = "<div id=\"bbs\" class=\"notprint\">" . script_form_file($hash,'bbs','slidelock');
	} else {
		$form = "<div id=\"bbs\" class=\"notprint\">" . script_form_file($hash,'bbs');
	}
	if (!$hide_form) {
		$link = $script . "?plugin=bbs";
		foreach ($_REQUEST as $key=>$val) {
			if ($key != 'posted' && $key != 'hide_form' && $key != 'plugin' && $key != 'hide_form' && $key != 'hashed' && $key != 'id2' && $key != 'res') {
				$link .= "&amp;${key}=$val";
			}
		}
		$link .= "&amp;hide_form=1";
		$form .= "<div style=\"padding-left:1em;\"><a href=\"$link\">■フォームを隠す</a></div>\n";
	}
	$rewrite = 0;
	if (req('hashed') && req('bbs_pass')) {
		if (password_verify(req('bbs_pass'),req('hashed'))) {
			$comment = $comment_[req('hashed')];
			$title = $title_[req('hashed')];
			$writer = $writer_[req('hashed')];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . req('hashed') . "\" />\n";
			$rewrite = 1;
		}
	} elseif (req('res')) {
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			if ($tmp[0] == req('id2')) {
				$title = $tmp[2];
				$comment = $tmp[4];
				if (!preg_match('/^Re:/',$title)) { $title = "Re:" . $title; }
				$tmp2 = explode('<br />',$comment);
				$tmp_ar = array();
				foreach ($tmp2 as $_) { $tmp_ar[] = '&gt;' . $_; }
				$comment = join('<br />',$tmp_ar);
				break;
			}
		}
	}
	$form .= "<input type=\"hidden\" name=\"post_id\" value=\"" . $post_id . "\" />\n";
	if (!file_exists($bbs_dir . '/' . $post_id . '.cgi')) {
		file_put_contents($bbs_dir . '/' . $post_id . '.cgi','',LOCK_EX);
	}
	$comment = str_replace("<br />","|n|",$comment);
	if ($rewrite) {
		$del_button = "&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"bbs_delete\" value=\"削除\" />";
	} else {
		$del_button = '';
	}
	$hash = array('plugin'=>'bbs','id'=>$id);
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	$form .= "<table border=\"0\" cellpadding=\"3\" style=\"margin:1em;\">\n";
	$help_link = "<a href=\"" . script_link($hash,'bbs') . "&amp;bbs_help=1#bbs_help\">ヘルプ</a>";
	$form .= "<tr><td>タイトル</td><td><input type=\"text\" name=\"title\" value=\"" . $title . "\" style=\"width:300px;\" /></td></tr>";
	$form .= "<tr><td style=\"text-align:right;\">投稿者</td><td><input type=\"text\" name=\"writer\" value=\"" . $writer . "\" style=\"width:140px;\" />&nbsp;&nbsp;&nbsp;編集パスワード&nbsp;<input type=\"text\" name=\"password\" style=\"width:140px;\" /></td></tr>\n";
	$form .= "<tr><td style=\"text-align:right;\">コメント</td><td><textarea name=\"comment\" cols=\"40\" rows=\"3\">$comment</textarea></td></tr>\n";
	if ($rewrite && $tenpu_list) {
		$str = '';
		foreach ($tenpu_list as $file) {
			$ext = pathinfo($file,PATHINFO_EXTENSION);
			$hash['id2'] = req('id2');
			$hash['del_file'] = $file;
			$hash['bbs_pass'] = req('bbs_pass');
			$hash['hashed'] = req('hashed');
			$link = script_link($hash);
			$str .= "<a href=\"$link\">削除</a>";
			if (in_array($ext,$img_ext)) {
				$thumb = str_replace(".$ext","thumb.$ext",$file);
				if (file_exists($bbs_dir . '/' . $thumb)) {
					$str .= "<img src=\"${bbs_dir}/$thumb\" /> ";
				} else {
					$str .= "<img src=\"${bbs_dir}/$file\"  /> ";
				}
			} else {
				$str .= "$file ";
			}
			
		}
		$form .= "<tr><td colspan=\"2\">$str</td></tr>\n";
	}
	$form .= "<tr><td style=\"text-align:right;\">添付</td><td><input type=\"file\" name=\"upfile\" value=\"\" /><input type=\"text\" name=\"email\" value=\"\" style=\"display:none;\"></td></tr>\n";
	$form .= "<tr><td colspan=\"2\"><input id=\"submit\" type=\"submit\" name=\"posted\" value=\"投稿\" />$del_button</td></tr>\n";
	$form .= "</table>\n";
	$form .= "</form>\n";
	if (file_exists($id_path)) {
		if ($hide_form) {
			$link = $script . "?plugin=bbs";
			foreach (array('id','page','sort','item','noform') as $key) {
				if (req($key)) {
					$link .= "&amp;${key}=" . req($key);
				}
			}
			$link .= "&amp;hide_form=0";
			$form = "<div style=\"padding-left:1em;\"><a href=\"$link\">■フォームを表示する</a></div>\n";
			$form .= "<div style=\"margin-top:1em;\">\n" . script_form_file($hash,'bbs');
		} else {
			$form .= "<div style=\"margin-top:1em;\">\n" . script_form_file($hash,'bbs');
		}
		$bbs_keyword = req('bbs_keyword');
		if (req('clear')) { $bbs_keyword = ''; }
		$form .= "キーワード&nbsp;<input type=\"text\" name=\"bbs_keyword\" value=\"$bbs_keyword\" style=\"width:200px;\" />";
		$form .= "&nbsp;<input type=\"submit\" name=\"search\" value=\"検索する\" />";
		if ($bbs_keyword) {
			$form .= "&nbsp;&nbsp;<input type=\"submit\" name=\"clear\" value=\"クリア\" />";
		}
		$form .= "</form>\n";
		$hash['bbs_admin'] = 1;
		$admin_link = script_link($hash,'bbs');
		$form .= "<div style=\"float:right;font-size:80%\">$help_link&nbsp; &nbsp;<a href=\"$admin_link\">管理者用</a></div>";
		$form .= "</div>\n";
	}
	$form .= "</div>\n";
	$form = str_replace("\n","|n|",$form);
	return $form;
}


function user_id() {
	global $bbs_dir;
	$ip = $_SERVER['REMOTE_ADDR'];
	$timestamp = date("Y-m-d");
	if (file_exists($bbs_dir . '/' . 'bbs_seed.cgi')) {
		$secret = file_get_contents($bbs_dir . '/' . 'bbs_seed.cgi');
	} else {
		$secret = random_str(10);
		file_put_contents($bbs_dir . '/' . 'bbs_seed.cgi',$secret,LOCK_EX);
	}
	$id_hash = hash_hmac("sha256", $timestamp.$ip, $secret);
	$id_base64 = base64_encode($id_hash);
	$id = substr($id_base64, 0, 10);
	return $id;
}


function spam_log($sec = '') {
	global $bbs_dir;
	$comment = req('comment');
	$comment = str_replace("\r\n","\n",$comment);
	$comment = str_replace("\r","\n",$comment);
	$comment = tag_convert($comment);
	$comment = str_replace("\n","<br />",$comment);
	$remote_addr = $remote_host = $user_agent = '';
	if (isset($_SERVER['REMOTE_ADDR'])) { $remote_addr = $_SERVER['REMOTE_ADDR']; }
	if (isset($_SERVER['REMOTE_HOST'])) { $remote_host = $_SERVER['REMOTE_HOST']; }
	if (isset($_SERVER['HTTP_USER_AGENT'])) { $user_agent = $_SERVER['HTTP_USER_AGENT']; }
	$line = join('<>',array('',time(),req('title'),req('writer'),$comment,req('hashed'),$sec,$remote_addr,$remote_host,$user_agent)) . "\n";
	$spam_path = $bbs_dir . './bbs_spamlog.cgi';
	if (file_exists($spam_path)) { $log = file($spam_path); }
	if (count($log) >= 100) {
		array_shift($log);
		file_put_contents($spam_path,$log,LOCK_EX);
	}
	file_put_contents($spam_path,$line,FILE_APPEND | LOCK_EX);
}


function user_agent($user_agent) {
	if (preg_match('/Windows\s*NT\s*([0-9.]+)/',$user_agent,$match)) {
		if ($match[1] == 6.2) {
			$os = 'Windows 8';
		} elseif ($match[1] == 6.1) {
			$os = 'Windows 7';
		} elseif ($match[1] == 10) {
			$os = 'Windows 10';
		}
	}
	return array($os);
}

?>