<?php
// [[calendar();]]
$explan = 'カレンダーを表示し、予定などを保存します。';
$format = '
[[calendar]]	// 引数を省略すると今月のカレンダーを表示
[[calendar(2016,11)]]	// 指定した月を表示するには、年と月を入れる
[[calendar(201802)]]	// こういう表記でもOK
';
// article_dir(article_id())	プラグインで使用するファイルの保存先
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
function calendar ($year = '', $month = '') {
	global $req,$place;
	$week_color = array('日'=>'crimson','月'=>'','火'=>'','水'=>'','木'=>'','金'=>'','土'=>'blue');
	$holiday_color = '#ff0066';
	//global $script;
	if ($year && !$month) {
		if (strlen($year) >= 6) {
			$tmp = $year;
			$year = substr($year,0,4);
			$month = substr($tmp,4,2);
		}
	}
	$id = article_id();
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	$id_dir = article_dir($id);
	$id_path = join('/',array($id_dir,'calendar.cgi'));
	$comment = array();
	if (file_exists($id_path)) {
		$log = file($id_path);
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			$comment[$tmp[0]] = $tmp[1];
		}
	}
	if (req('posted') && req('plugin') == 'calendar' && req('id') == article_id()) {
		if (!is_dir($id_dir)) { mkdir($id_dir); }
		$d = sprintf("%04d-%02d-%02d",req('year'),req('month'),req('day'));
		$com = req('comment');
		$com = str_replace("\r\n","\n",$com);
		$com = str_replace("\r","\n",$com);
		$com = tag_convert($com);
		if (preg_match('/^\s+$/',$com)) { $com = ''; }
		$com = str_replace("\n","<br />",$com);
		$comment[$d] = $com;
		if (!$com) { unset($comment[$d]); }
		ksort($comment);
		$str = "";
		foreach ($comment as $key=>$val) {
			$val = rtrim($val);
			$str .= "$key<>$val\n";
		}
		file_put_contents($id_path,$str,LOCK_EX);
	}
	if (req('year')) { $year = req('year'); }
	if (req('month')) { $month = req('month'); }
	if (empty($year) && empty($month)) {
		$year = date('Y');
		$month = date('n');
	}
	if (req('id') && req('last_exst')) {
		if ($comment) {
			$last_key = '';
			$last = '';
			foreach (array_keys($comment) as $key) {
				$tmp = explode('-',$key);
				//if ($tmp[0] >= req('year') && $tmp[1] >= req('month')) {
				if (sprintf("%04d%02d",$tmp[0],$tmp[1]) >= sprintf("%04d%02d",req('year'),req('month'))) {
					if ($last_key) {
						list($year,$month) = explode('-',$last_key);
					} else {
						list($year,$month) = array(req('year'),req('month'));
					}
					$last = 1;
					break;
				} else {
					$last_key =$key;
				}
			}
			if (!$last) { list($year,$month) = $tmp; }
		}
	}
	if (req('id') && req('next_exst')) {
		$count = 0;
		foreach (array_keys($comment) as $key) {
			$tmp = explode('-',$key);
			if (sprintf("%04d%02d",$tmp[0],$tmp[1]) <= sprintf("%04d%02d",req('year'),req('month'))) {
				if (isset(array_keys($comment)[$count+1])) {
					list($year,$month) = explode('-',array_keys($comment)[$count+1]);
				} else {
					list($year,$month) = array(req('year'),req('month'));
				}
			} elseif (sprintf("%04d%02d",$tmp[0],$tmp[1]) > sprintf("%04d%02d",req('year'),req('month'))) {
				list($year,$month) = explode('-',$key);
				break;
			}
			$count++;
		}
	}
	$form = '';
	if (req('day')) {
		$day = req('day');
		$date = sprintf("%04d-%02d-%02d",$year,$month,req('day'));
		if (!isset($comment[$date])) { $comment[$date] = ''; }
		$holiday = get_holiday($year,$month,$day);
		if (!$holiday) {
			$holiday = '';
		} else {
			$holiday = "<span style=\"color:$holiday_color;\">($holiday)</span>";
		}
		$hash = array('plugin'=>'calendar','id'=>$id,'year'=>$year,'month'=>$month,'day'=>req('day'),'show_form'=>1);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if ($req['sort']) { $hash['sort'] = $req['sort']; }
		$edit_link = script_link($hash);
		$edit_link = "&nbsp;<a href=\"$edit_link#calendar$id\">編集</a>";
		if (!$comment[$date] || req('show_form')) {
			$edit_link = '';
		}
		$week_name = week_name($year,$month,$day);
		if ($week_name == '日') {
			$week_name = "<span style=\"color:" . $week_color[$week_name] . ";\">$week_name</span>";
		} elseif ($week_name == '土') {
			$week_name = "<span style=\"color:" . $week_color[$week_name] . ";\">$week_name</span>";
		}
		$form .= "<ul style=\"margin:0;\"><li>${year}年${month}月${day}日(" . $week_name . ")" . "$holiday$edit_link<br />\n";
		$form .= "" . $comment[$date] . "</li></ul>\n";
		if (!$comment[$date] || req('show_form')) {
			$form .= "<table style=\"margin-top:0;\">\n";
			$form .= "<tr><td style=\"vertical-align:top;\">";
			$hash = array('plugin'=>'calendar','year'=>$year,'month'=>$month,'day'=>$day,'id'=>$id);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if ($req['sort']) { $hash['sort'] = $req['sort']; }
			$form .= script_form($hash,'calendar');
			$form .= "<input type=\"submit\" name=\"posted\" style=\"padding:0.2em;\" value=\"投稿\" /></td></tr>\n";
			$com = $comment[$date];
			$com = str_replace("<br />","\n",$com);
			$form .= "<tr><td><textarea name=\"comment\">" . $com . "</textarea>\n";
			$form .= "</form>\n</td></tr>\n</table>\n";
		}
	}
	$last_year = $year;
	$last_month = $month - 1;
	if ($last_month < 1) {
		$last_month += 12;
		$last_year--;
	}
	$next_year = $year;
	$next_month = $month + 1;
	if ($next_month > 12) {
		$next_month -= 12;
		$next_year++;
	}
	$last_year = sprintf("%04d",$last_year);
	$next_year = sprintf("%04d",$next_year);
	$hash = array('plugin'=>'calendar','id'=>$id,'year'=>$year,'month'=>$month);
	$link = script_link($hash);
	$hash['year'] = $last_year;
	$hash['month'] = $last_month;
	$last_link = script_link($hash);
	$hash['year'] = $next_year;
	$hash['month'] = $next_month;
	$next_link = script_link($hash);
	$add = '';
	if (req('noform')) { $add .= "&amp;noform=" . req('noform'); }
	if ($req['sort']) { $add .= "&amp;sort=" . $req['sort']; }
	$link .= $add;
	$tomonth_link = $link;
//	$tomonth_link .= "&amp;show=" . sprintf("%04d-%02d",$year,$month);
	$last_link .= $add;
	$next_link .= $add;
	if (!req('day')) {
		if (isset($place) && $place == 'menu') {
			$lists = '';
			foreach ($comment as $key=>$val) {
				if (preg_match('/^' . sprintf("%04d-%02d",$year,$month) . '/',$key)) {
					list($yy,$mm,$dd) = explode('-',$key);
					$wk = week_name($yy,$mm,$dd);
					if ($wk == '日' || $wk == '土') { $wk = "<span style=\"color:" . $week_color[$wk] . ";\">($wk)</span>"; } else { $wk = "($wk)"; }
					$holiday = get_holiday($yy,$mm,$dd);
					if (! $holiday) { 
						$holiday = '';
					} else {
						$holiday = "<span style=\"color:$holiday_color;\">($holiday)</span>";
					}
					$lists .= "<tr><td><a href=\"$link&amp;day=$dd#calendar$id\">" . $key . $wk . $holiday . "</a><br />";
					$tmp = explode('<br />',$val);
					$title = str_replace('<br />',"\n",$val);
					$bef = strlen($val);
					$s_str = jtruncate($tmp[0],60);
					$aft = strlen($s_str);
					if ($bef > $aft) { $s_str .= '...'; }
					$lists .= "<span title=\"$title\">" . $s_str . "</span></td></tr>\n";
				}
			}
			if ($lists) {
				$lists = "<table>\n$lists</table>\n";
			}
			$form .= $lists;
		} else {
			$form .= "<ul>\n";
			foreach ($comment as $key=>$val) {
				if (preg_match('/^' . sprintf("%04d-%02d",$year,$month) . '/',$key)) {
					list($yy,$mm,$dd) = explode('-',$key);
					$wk = week_name($yy,$mm,$dd);
					if ($wk == '日' || $wk == '土') { $wk = "<span style=\"color:" . $week_color[$wk] . ";\">($wk)</span>"; } else { $wk = "($wk)"; }
					$holiday = get_holiday($yy,$mm,$dd);
					if (! $holiday) { 
						$holiday = '';
					} else {
						$holiday = "<span style=\"color:$holiday_color;\">($holiday)</span>";
					}
					// dlを使う場合
	//				$form .= "<dl><dt><a href=\"$link&amp;day=$dd#calendar\">" . $key . $wk . $holiday . '</a></dt><dd>' . $val . "</dd></dl>\n";
					// ulを使う場合
					$form .= "<li style=\"padding:0.3em;\"><a href=\"$link&amp;day=$dd#calendar$id\">" . $key . $wk . $holiday . "</a><br />";
					$tmp = explode('<br />',$val);
					$title = str_replace('<br />',"\n",$val);
					$bef = strlen($val);
					$s_str = jtruncate($tmp[0],60);
					$aft = strlen($s_str);
					if ($bef > $aft) { $s_str .= '...'; }
					$form .= "<span title=\"$title\">" . $s_str . "</span></li>\n";
				}
			}
			$form .= "</ul>\n";
		}
	}

	//月末の取得
	//$l_day = date('j', mktime(0, 0, 0, $month + 1, 0, $year));
	// 2038年対策済み
	$obj = date_create("$year-$month-01");
	$l_day = date_format($obj,"t");
	//初期出力
	$html = <<<EOM
<table class="calendar">
	<thead>
		<tr>
			<td colspan="2"><a href="$tomonth_link&amp;last_exst=1#calendar$id" title="前の記事がある月へ">|&lt;</a>&nbsp;<a href="$last_link#calendar$id" title="前月へ">&lt;</a></td>
			<th colspan="3"><a href="$tomonth_link#calendar$id" id="calendar$id">{$year}年{$month}月</a></th>
			<td colspan="2"><a href="$next_link#calendar$id" title="翌月へ">&gt;</a>&nbsp;<a href="$tomonth_link&amp;next_exst=1#calendar$id" title="次の記事がある月へ">&gt;|</a></td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<th class="sun">日</th>
			<th>月</th>
			<th>火</th>
			<th>水</th>
			<th>木</th>
			<th>金</th>
			<th class="sat">土</th>
		</tr>\n
EOM;
	$lc = 0;
	$html = str_replace("\t",'',$html);

	// 月末分繰り返す
	for ($i = 1; $i < $l_day + 1;$i++) {
		$classes = array();
		$class   = '';
 
		// 曜日の取得
		//$week = date('w', mktime(0, 0, 0, $month, $i, $year));
		$obj = date_create("$year-$month-$i");
		$week = (int)date_format($obj, 'w');
 
		// 曜日が日曜日の場合
		if ($week == 0) {
			//$html .= "\t\t<tr>\n";
			$html .= "<tr>\n";
			$lc++;
		}
 
		// 1日の場合
		if ($i == 1) {
			if($week != 0) {
				//$html .= "\t\t<tr>\n";
				$html .= "<tr>\n";
				$lc++;
			}
			$html .= repeatEmptyTd($week);
		}
 
		if ($week == 6) {
			$classes[] = 'sat';
		} else if ($week == 0) {
			$classes[] = 'sun';
		}
 
		if ($i == date('j') && $year == date('Y') && $month == date('n')) {
			// 現在の日付の場合
			$classes[] = 'today';
		}
		$holiday = holiday($year, $month, $i);
		$holiday = mb_convert_encoding($holiday,'utf-8','euc-jp');
 
		if (count($classes) > 0) {
			$class = ' class="'.implode(' ', $classes).'"';
		}
		$d = $i;
		$title = '';
		$date = sprintf("%04d-%02d-%02d",$year,$month,$i);
		if (isset($comment[$date]) && $comment[$date]) {
			$d = "<b>$i</b>";
			$title = $comment[$date];
			$title = str_replace("<br />","\n",$title);
			$title = strip_tags($title);
			$title = " title=\"$title\"";
		}
		if ($id) {
			if ($holiday) {
				if ($title) {
					$title = preg_replace('/title="([\w\W]*?)"/','title="(' . $holiday . ")\n" . '$1"',$title);
				} else {
					$title =" title=\"($holiday)\"";
				}
				if (req('day') == $i) {
					$html .= '<td style="color:crimson;background-color:#ffffdd;"><a style="color:crimson;" href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				} else {
					$html .= '<td style="color:crimson"><a style="color:crimson;" href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				}
			} else {
				if (req('day') == $i) {
					$html .= '<td' . $class . ' style="background-color:#ffffdd;"><a' . $class . ' href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				} else {
					$html .= '<td' . $class . '><a' . $class . ' href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				}
			}
		} else {
			if ($holiday) {
				$html .= '<td style="color:crimson"><a title="' . $holiday . '">'.$d.'</td>'."\n";
			} else {
				$html .= '<td'.$class.'>'.$d.'</td>'."\n";
			}
		}
 
		// 月末の場合
		if ($i == $l_day) {
			$html .= repeatEmptyTd(6 - $week);
			$week = 6;
		}
		// 土曜日の場合
		if ($week == 6) {
			//$html .= "\t\t</tr>\n";
			$html .= "</tr>\n";
		}
	}
	//$html .= "\t</tbody>\n";
	$html .= "</tbody>\n";
	$html .= "</table>\n";
	
	if (isset($place) && $place == 'menu') {
		$html = "<table border=\"0\"><tr><td style=\"vertical-align:top;\">$html</td></tr><tr><td style=\"vertical-align:top;\">" . $form . "</td></tr></table>\n";
	} else {
		$html = "<table border=\"0\"><tr><td style=\"vertical-align:top;\">$html</td><td style=\"vertical-align:top;\">" . $form . "</td></tr></table>\n";
	}
	$html = str_replace("\n","/n/",$html);
	return $html;
}
 
function repeatEmptyTd($n = 0) {
	//return str_repeat("\t\t<td> </td>\n", $n);
	return str_repeat("<td>&nbsp;</td>\n", $n);
}

?>