<?php
$explan = 'commentプラグインに記事の再編集機能を追加
改行も有効にした';
$format = "[[comment2]]	// 基本形
[[comment2('order=up|max_log=10|show_days=90')]]	// フォームを上に配置
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function comment2($order = '',$max_log = '') {
	global $current_time,$new_day;
	if (! $max_log) { $max_log = 20; }	// ログの保存数
	if (gettype($order) == 'integer') {
		$max_log = $order;
		$order = '';
	}
	if (strpos($order,'=') != false) {
		$tmp = explode('|',$order);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			if (isset($tmp2[1])) { $option[$tmp2[0]] = $tmp2[1]; }
		}
		$order = '';
	}
	if (!isset($option['show_days'])) { $option['show_days'] = 0; }
	if (isset($option['max_log'])) { $max_log = $option['max_log']; } else { $max_log = 20; }
	if (isset($option['order'])) { $order = $option['order']; } 
	$str = '';
	$id = article_id();
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (file_exists('./frontid')) {
		list($id) = file('./frontid');
	}
	$id_dir = article_dir($id);
	$id_path = join('/',array($id_dir,'comment2.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		$last = end($log);
		$last = rtrim($last);
	}

	if ((req('posted') || req('comment2_delete')) && req('plugin') == 'comment2') {
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			if (!is_dir($id_dir)) { mkdir($id_dir); }
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace("\n","<br />",$comment);
			$writer = req('writer');
			$tmp = explode('<>',$last);
			for ($i=0;$i<=2;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[2] && $tm == $tmp[0]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$writer) { $writer = '名無し'; }
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[3] == req('hashed')) {
							if (req('comment2_delete')) {
								continue;
							} else {
								$hashed = $tmp[3];
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($tm,$writer,$comment,$hashed));
							}
						}
						$new_log[] = $line . "\n";
					}
					file_put_contents($id_path,$new_log,LOCK_EX);
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$line = join('<>',array($tm,$writer,$comment,$hashed)) . "\n";
					file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
				}
			}
		}
	}
	
	$log = array();
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $max_log) {
			$log = array_slice($log,-1*$max_log);
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	
	if ($log) {
		$str .= "<ul style=\"list-style-type: square;\">\n";
		if ($order == 'up') {
			$log = array_reverse($log);
		}
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			$datetime1 = date_create($tmp[0]);
			$datetime2 = date_create($current_time);
			if (gettype($datetime1) == 'object' && gettype($datetime2) == 'object') {
				$interval = date_diff($datetime1, $datetime2);
				$dif_days = $interval->format('%R%a');
				$dif_days = intval($dif_days);
				if ($option['show_days'] && ($dif_days > $option['show_days'])) {
					continue;
				}
			}
			$tmp[3] = rtrim($tmp[3]);
			for ($i=0;$i<=3;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('plugin'=>'comment2','id'=>$id,'hashed'=>$tmp[3]);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			}
			if (req('sort')) {
				$hash['sort'] = req('sort');
			}
			$edit_link = script_link($hash);
			$tmp[3] = rtrim($tmp[3]);
			if (req('hashed') && req('hashed') == $tmp[3] && !req('comment2_pass') && !req('posted')) {
				$str .= "<li id=\"comment2\" style=\"margin:0.5em;\">" . $tmp[2] . "&nbsp;-&nbsp;" . $tmp[1] . "&nbsp;-&nbsp;<span style=\"font-size:80%;\">" . $tmp[0] . "</span>";
			} else {
				$str .= "<li style=\"margin:0.5em;\">" . $tmp[2] . "&nbsp;-&nbsp;" . $tmp[1] . "&nbsp;-&nbsp;<span style=\"font-size:80%;\">" . $tmp[0] . "</span>";
			}
			if (req('hashed') && req('hashed') == $tmp[3] && !req('comment2_pass') && !req('posted')) {
				$hash = array('plugin'=>'comment2','id'=>$id,'hashed'=>req('hashed'));
				if (req('noform')) {
					$hash['noform'] = req('noform');
				}
				if (req('sort')) {
					$hash['sort'] = req('sort');
				}
				$str .= script_form($hash,'comment2');
				$str .= "&nbsp;&nbsp;<span style=\"font-size:80%;color:#0066dd;\">編集パスワードを入力してください</span>&nbsp;<input type=\"text\" name=\"comment2_pass\" value=\"\" style=\"width:140px;\" /><input id=\"comment2\" type=\"submit\" value=\"編集\" />";
				$str .= "</form>\n";
			} elseif (req('hashed') && req('hashed') == $tmp[3] && req('comment2_pass') && ! password_verify(req('comment2_pass'),req('hashed'))) {
				if ($tmp[3]) { $str .= "&nbsp;<a href=\"$edit_link#comment2\" style=\"white-space:nowrap;\">編集</a>" . "&nbsp;<span style=\"color:crimson\">パスワードが違います</span>"; }
			} else {
				if ($tmp[3]) { $str .= "&nbsp;<a href=\"$edit_link#comment2\" style=\"white-space:nowrap;\">編集</a>"; }
			}
			$str .= "</li>\n";
			$comment_[$tmp[3]] = $tmp[2];
			$writer_[$tmp[3]] = $tmp[1];
			$date_[$tmp[3]] = $tmp[0];
		}
		$str .= "</ul>\n";
	}
	$writer = '';
	$comment = '';
	$hash = array('plugin'=>'comment2','id'=>$id,'plugin'=>'comment2',);
	$form = script_form($hash,'comment2');
	$rewrite = 0;
	if (req('hashed') && req('comment2_pass')) {
		if (password_verify(req('comment2_pass'),req('hashed'))) {
			$comment = $comment_[req('hashed')];
			$writer = $writer_[req('hashed')];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . req('hashed') . "\" />\n";
			$rewrite = 1;
		}
	}
	if (req('noform')) { $form .= "<input type=\"hidden\" name=\"noform\" value=\"" . req('noform') . "\" />\n"; }
	if (req('sort')) { $form .= "<input type=\"hidden\" name=\"sort\" value=\"" . req('sort') . "\" />\n"; }
	$comment = str_replace("<br />","|n|",$comment);
//	$form .= "<input id=\"comment2\" type=\"submit\" name=\"posted\" value=\"投稿\" />";
	if ($rewrite) {
		$form .= "&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"comment2_delete\" value=\"削除\">";
	}
//	$form .= "<br />\n";
	$form .= "<table cellpadding=\"2\">\n";
	$form .= "<tr><td style=\"text-align:right;\">投稿者</td><td><input type=\"text\" name=\"writer\" value=\"" . $writer . "\" style=\"width:140px;\" />&nbsp;&nbsp;&nbsp;編集パスワード&nbsp;<input type=\"text\" name=\"password\" style=\"width:140px;\" />&nbsp;&nbsp;&nbsp;&nbsp;<input id=\"comment2\" type=\"submit\" name=\"posted\" value=\"投稿\" /></td></tr>\n";
	$form .= "<tr><td style=\"text-align:right;\">コメント</td><td><textarea name=\"comment\" cols=\"40\" rows=\"3\">$comment</textarea></td></tr>\n";
	$form .= "</table>\n";
	$form .= "</form>";
//	$vars = get_defined_vars();
//	$str .= "<pre>" . print_r($vars,true) . "</pre>";
//	foreach ($vars as $key=>$val) {
//		if (gettype($val) == 'string') {
//			$form .= "$key" . '→' . $val . "<br />";
//		} else {
//			foreach ($val as $val2) {
//				if (gettype($val) == 'string') {
//					$form .= "$key" . '→' . $val . '→' . $val2 . "<br />";
//				}
//			}
//		}
//	}
	if (!$order || $order == 'down') {
		return $str . $form;
	} elseif ($order == 'up') {
		return $form . $str;
	}
	
}
?>