<?php
global $comment3_help;
$explan = 'comment2プラグインにファイル添付機能を追加';
$format = "[[comment3]]	// 基本形
[[comment3('up')]]	// フォームを上に配置
";
$comment3_help = "
<h3>使用できるタグ</h3>
!perm_tag!
<h3>指定できるオプション</h3>
<dl><dt>tag</dt><dd>使用できるタグを指定
tag=pre,span　複数指定する場合は,(カンマ)で区切る</dd></dl>
<dl><dt>max_log</dt><dd>現行ログの保存数。これを超えると過去ログに移動。
例　max_log=50</dd></dl>
<dl><dt>max_past</dt><dd>過去ログに保存する記事数。これを超えると過去ログファイルを新たに作成。
例　max_log=50</dd></dl>
<dl><dt>order</dt><dd>フォームの表示位置。
例　max_past=100</dd></dl>
<dl><dt>page_line</dt><dd>1ページに表示する記事数。これを超えると次のページに表示
例　page_line=10</dd></dl>
";
////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function comment3($order = '',$max_log = '') {
	global $img_ext,$comment3_help,$tag_list;
	if (! $max_log) { $max_log = 100; }	// ログの保存数
	$max_past = 100;					// 過去ログの最大数
	if (gettype($order) == 'integer') {
		$max_log = $order;
		$order = '';
	}
	if (strpos($order,'=') != false) {
		$tmp = explode('|',$order);
		$option = array();
		$order = '';
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			if (isset($tmp2[1])) {
				$option[$tmp2[0]] = $tmp2[1];
				if ($tmp2[0] == 'order') {
					$order = $tmp2[1];
				}
			}
		}
	}
	if (!isset($option['order'])) { $option['order'] = 'up'; }	// フォームの表示位置
	if (!isset($option['max_log'])) { $option['max_log'] = 100; }	// ログの保存数
	if (!isset($option['max_past'])) { $option['max_past'] = 100; }	// ログの保存数
	if (!isset($option['tag'])) { $option['tag'] = 'pre,span'; }	// ログの保存数
	if (!isset($option['page_line'])) { $option['page_line'] = 10; }	// ログの保存数
	$page_line = $option['page_line'];
	$str = '';
	$id = article_id();
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (file_exists('./frontid')) {
		list($id) = file('./frontid');
	}
	$id_dir = article_dir($id);
	$id_path = join('/',array($id_dir,'comment3.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		$last = end($log);
		$last = rtrim($last);
	}

	if (req('comment3_help')) {
		$hash = array('plugin'=>'comment3','id'=>$id,'comment3_help'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$str .= "<a href=\"" . script_link($hash,'comment3') . "\">戻る</a>";
		$str .= "<h2 id=\"comment3_help\">comment3.phpのヘルプ</h2>";
		$comment3_help = preg_replace('/>\n+/',">\n",$comment3_help);
		$tmp = explode("\n",$comment3_help);
		foreach ($tmp as $_) {
			$mat = $trans = '';
			if (preg_match('/<dt>([^<]+)<\/dt>/',$_,$mat)) {
				if (isset($mat[1]) && isset($option[$mat[1]])) {
					$trans = " (現在の設定は" . $mat[1] . '=' . $option[$mat[1]] . ')';
				}
				$_ = preg_replace('/<dt>([^<]+)<\/dt>/',"<b>" . $mat[1] . "</b>" . $trans,$_);
			}
			if (!preg_match('/>$/',$_)) {
				$str .= $_ . "<br />\n";
			} else {
				$str .= $_ . "\n";
			}
		}
		$str = str_replace("\n","|n|",$str);
		$str = str_replace("!perm_tag!",$option['tag'],$str);
		return $str;
	}


	if (req('show_past')) {
		$file_nmb = 1;
		while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
			$file_nmb++;
		}
		if (req('past_nmb')) {
			$past_nmb = req('past_nmb');
		} else {
			$past_nmb = $file_nmb - 1;
		}
		$hash = array('plugin'=>'comment3','id'=>$id,'show_past'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }

		$str .= "<a href=\"" . script_link($hash) . "\">戻る</a>&nbsp;<strong>過去ログ</strong>&nbsp;";
		$nmb = 1;
		$show_next_id = 0;
		for ($i=$file_nmb-1; $i>=1; $i--) {
			if ($i == $past_nmb) {
				$str .= "<b>[$nmb]</b> \n";
			} else {
				$hash = array('plugin'=>'comment3','id'=>$id,'past_nmb'=>$i,'show_past'=>1);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				$link = script_link($hash) . "#next_page";
				if (!$show_next_id) {
					$str .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a> \n";
					$show_next_id = 1;
				} else {
					$str .= "<a href=\"$link\">[" . $nmb . "]</a> \n";
				}
			}
			$nmb++;
		}
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		$log = file($past_path);
		$log = array_reverse($log);
		$com = '';
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			list($id,$date,$name,$comment,$hashed) = $tmp;
			if (isset($tmp[5])) { $rewrite = $tmp[5]; }
			$com .= "<li>$date&nbsp;$name<br />";
			$tmpdir = opendir($id_dir);
			while ($file = readdir($tmpdir)) {
				if (strpos($file,$id) !== false && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$ext = pathinfo($file,PATHINFO_EXTENSION);
					if (in_array($ext,$img_ext)) {
						list($image_w, $image_h) = getimagesize($id_dir . "/$file");
						$width = 500;
						$proportion = $image_w / $image_h;
						$height = $width / $proportion;
						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
						if($proportion < 1){
							$height = $width;
							$width = $width * $proportion;
							$width = intval($width * 0.8);
							$height = intval($height * 0.8);
						}
						$com .= "<a href=\"" . $id_dir . "/$file\"><img src=\"" . $id_dir . "/$file\" width=\"$width\" alt=\"$file\" /></a><br />\n";
					} else {
						$oname = $id_dir . '/' . $file . '.oname';
						$org = $file;
						if (file_exists($oname)) { list($org) = file($oname); }
						$hash = array('mode'=>'download', 'file'=>$id_dir . '/' . $file, 'name'=>urlencode($org));
						$link = script_link($hash);
						$com .= "<a href=\"$link\">$org</a><br />\n";
					}
				}
			}
			closedir($tmpdir);
			$com .= "$comment\n<hr /></li>\n";
		}
		if ($com) { $com = "<ul>$com</ul>\n"; }
		$str .= $com;
		$str = str_replace("\n","|n|",$str);
		return $str;
	}
	if ((req('posted') || req('comment3_delete')) && req('plugin') == 'comment3') {
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			if (!is_dir($id_dir)) { mkdir($id_dir); }
			$tag_list = explode(',',$option['tag']);
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace("\n","<br />",$comment);
			$writer = req('writer');
			$tmp = explode('<>',$last);
			$id2 = $tmp[0];
			for ($i=0;$i<=3;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[3] && $tm == $tmp[1]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$writer) { $writer = '名無し'; }
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[0] == req('id2') && $tmp[4] == req('hashed')) {
							$id2 = $tmp[0];
							if (req('comment3_delete')) {
								$tmpdir = opendir($id_dir);
								while ($file = readdir($tmpdir)) {
									if (preg_match('/^' . $id2 . '/',$file)) {
										unlink($id_dir . '/' . $file);
									}
								}
								closedir($tmpdir);
								continue;
							} else {
								$hashed = $tmp[4];
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($id2,$tm,$writer,$comment,$hashed,'再編集'));
							}
						}
						$new_log[] = $line . "\n";
					}
					file_put_contents($id_path,$new_log,LOCK_EX);
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$id2 = random_str(10);
					$line = join('<>',array($id2,$tm,$writer,$comment,$hashed)) . "\n";
					file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
				}
			}

			// すでにアップロードしたファイルがある場合は削除しておく
			$tmpdir = opendir($id_dir);
			while ($file = readdir($tmpdir)) {
				// 同じ記事に複数のcomment3が設置されている場合の対策 100秒以上経過しているファイルのみ削除
				if (strpos($file,$id2) !== false && filemtime($id_dir . '/' . $file) + 100 < time()) {
					unlink($id_dir . '/' . $file);
				}
			}
			closedir($tmpdir);
			
			if ($_FILES['upfile']["error"] == UPLOAD_ERR_OK) {
				$tmp_name = $_FILES['upfile']["tmp_name"];
				$t_name = $_FILES['upfile']["name"];	// とりあえず元のファイル名から拡張子を取るだけ
				$ext = pathinfo($t_name, PATHINFO_EXTENSION);
				if (! is_dir($id_dir)) {
					mkdir($id_dir);
				}
				$up_path = $id_dir . '/' . $id2 . '.' . $ext;
				move_uploaded_file($tmp_name, $up_path);
				// 画像ファイルの場合サムネールを作成
				if (in_array($ext,$img_ext)) { thumb($up_path,'100'); }
				$onfile = $up_path . '.oname';
				file_put_contents($onfile,$t_name,LOCK_EX);
			}
		}
	}
	$log = array();
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $max_log) {
			$past_log = array_splice($log,0,(count($log) - $max_log));
			$file_nmb = 1;
			while (1) {
				$past_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path);
				if (!file_exists($past_path) || count(file($past_path)) < $max_past) {
					file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
					break;
				}
				$file_nmb++;
			}
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if ($log) {
		$log = array_reverse($log);	// 新しい順に表示するのに固定
		//$page_line = 10;	// 1ページあたりの記事数
		$line_nmb = 0;
		if (! req('page')) {
			$page = 0;
		} else {
			$page = req('page');
		}
		$end = intval((count($log) - 1)/$page_line);
		$indx = '';
		if ($end > 0) {
			$show_next_id = 0;
			for ($i=0; $i<=$end; $i++) {
				if ($i == $page) {
					$indx .= "<b>[" . ($i+1) . "]</b> \n";
				} else {
					$hash = array('plugin'=>'comment3','id'=>$id,'page'=>$i);
					if (req('noform')) { $hash['noform'] = req('noform'); }
					if (req('sort')) { $hash['sort'] = req('sort'); }
					$link = script_link($hash) . "#next_page";
					if (!$show_next_id) {
						$indx .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . ($i+1) . "]</a> \n";
						$show_next_id = 1;
					} else {
						$indx .= "<a href=\"$link\">[" . ($i+1) . "]</a> \n";
					}
				}
			}
		}
		$past_path = preg_replace('/\.cgi$/','_1.cgi',$id_path);
		if (file_exists($past_path)) {
			$hash = array('plugin'=>'comment3','id'=>$id,'show_past'=>1);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= "<a href=\"" . script_link($hash) . "\">過去ログ</a>";
		}
		if ($indx) { $indx = "<div style=\"margin-left:1em;\">$indx</div>\n"; }
		$str .= $indx . "<ul style=\"list-style-type: square;\">\n";
		foreach ($log as $line) {
			if ($line_nmb < $page * $page_line || $line_nmb >= ($page + 1) * $page_line) {
				$line_nmb++;
				continue;
			}
			$tmp = explode('<>',$line);
			$id2 = $tmp[0];
			$tmp[4] = rtrim($tmp[4]);
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('plugin'=>'comment3','id'=>$id,'hashed'=>$tmp[4],'id2'=>$id2);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			}
			if (req('sort')) {
				$hash['sort'] = req('sort');
			}
			if (req('page')) {
				$hash['page'] = req('page');
			}
			$edit_link = script_link($hash);
			$tmp[4] = rtrim($tmp[4]);
			if (req('hashed') && req('hashed') == $tmp[4] && !req('comment3_pass') && !req('posted')) {
				$str .= "<li id=\"comment3\" style=\"margin:0.5em;\">" . "<span style=\"font-size:80%;\">" . $tmp[1] . "</span>" . $tmp[2];
			} else {
				$str .= "<li style=\"margin:0.5em;\">" . "<span style=\"font-size:80%;\">" . $tmp[1] . "</span>" . $tmp[2];
			}
			if ($tmp[4]) {
				$str .= "&nbsp;&nbsp;<a href=\"$edit_link#comment3\" style=\"white-space:nowrap;\">編集</a>\n";
			}
			$str .= "<br />\n";
			$tmpdir = opendir($id_dir);
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^' . $id2 . '/',$file) && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$ext = pathinfo($file,PATHINFO_EXTENSION);
					if (in_array($ext,$img_ext)) {
						list($image_w, $image_h) = getimagesize($id_dir . "/$file");
						$width = 500;
						$proportion = $image_w / $image_h;
						$height = $width / $proportion;
						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
						if($proportion < 1){
							$height = $width;
							$width = $width * $proportion;
							$width = intval($width * 0.8);
							$height = intval($height * 0.8);
						}
						$str .= "<a href=\"" . $id_dir . "/$file\"><img src=\"" . $id_dir . "/$file\" width=\"$width\" alt=\"$file\" /></a><br />\n";
					} else {
						$oname = $id_dir . '/' . $file . '.oname';
						$org = $file;
						if (file_exists($oname)) {
							list($org) = file($oname);
						}
						$hash = array('mode'=>'download', 'file'=>$id_dir . '/' . $file, 'name'=>urlencode($org));
						$link = script_link($hash);
						$str .= "<a href=\"$link\">$org</a><br />\n";
					}
				}
			}
			closedir($tmpdir);
			if (req('hashed') && req('hashed') == $tmp[4] && !req('comment3_pass') && !req('posted')) {
				$str .= $tmp[3];
			} else {
				$str .= $tmp[3];
			}
			if (req('hashed') && req('hashed') == $tmp[4] && !req('comment3_pass') && !req('posted')) {
				$hash = array('plugin'=>'comment3','id'=>$id,'hashed'=>req('hashed'),'id2'=>$id2);
				if (req('noform')) {
					$hash['noform'] = req('noform');
				}
				if (req('sort')) {
					$hash['sort'] = req('sort');
				}
				if (req('page')) {
					$hash['page'] = req('page');
				}
				$str .= script_form_file($hash,'comment3');
				$str .= "&nbsp;&nbsp;<span style=\"font-size:80%;color:#0066dd;\">編集パスワードを入力してください</span>&nbsp;<input type=\"text\" name=\"comment3_pass\" value=\"\" style=\"width:140px;\" /><input id=\"comment3\" type=\"submit\" value=\"編集\" />";
				$str .= "</form>\n";
			} elseif (req('hashed') && req('hashed') == $tmp[4] && req('comment3_pass') && ! password_verify(req('comment3_pass'),req('hashed'))) {
				if ($tmp[4]) { $str .= "&nbsp;<span style=\"color:crimson\">パスワードが違います</span>"; }
			}
			$str .= "<hr />\n</li>\n";
			$comment_[$tmp[4]] = $tmp[3];
			$writer_[$tmp[4]] = $tmp[2];
			$date_[$tmp[4]] = $tmp[1];
			$line_nmb++;
		}
		$str .= "</ul>\n";
	}
	$writer = '';
	$comment = '';
	$hash = array('plugin'=>'comment3','id'=>$id);
	if (req('id2')) { $hash['id2'] = req('id2'); }
	if (req('page')) { $hash['page'] = req('page'); }
	$form = "<div id=\"comment3\">" . script_form_file($hash,'comment3');
	$rewrite = 0;
	if (req('hashed') && req('comment3_pass')) {
		if (password_verify(req('comment3_pass'),req('hashed'))) {
			$comment = $comment_[req('hashed')];
			$writer = $writer_[req('hashed')];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . req('hashed') . "\" />\n";
			$rewrite = 1;
		}
	}
	if (req('noform')) { $form .= "<input type=\"hidden\" name=\"noform\" value=\"" . req('noform') . "\" />\n"; }
	if (req('sort')) { $form .= "<input type=\"hidden\" name=\"sort\" value=\"" . req('sort') . "\" />\n"; }
	$comment = str_replace("<br />","|n|",$comment);
	if ($rewrite) {
		$form .= "&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"comment3_delete\" value=\"削除\">";
	}
//	$form .= "<br />\n";

	//$hash = array('plugin'=>'comment3','id'=>$id);
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('sort')) { $hash['sort'] = req('sort'); }
	$form .= "<table cellpadding=\"2\">\n";
	$form .= "<tr><td style=\"text-align:right;\">投稿者</td><td><input type=\"text\" name=\"writer\" value=\"" . $writer . "\" style=\"width:140px;\" />&nbsp;&nbsp;&nbsp;編集パスワード&nbsp;<input type=\"text\" name=\"password\" style=\"width:140px;\" />&nbsp;&nbsp;&nbsp;&nbsp;<input id=\"comment2\" type=\"submit\" name=\"posted\" value=\"投稿\" />";
	$help_link = "<a href=\"" . script_link($hash,'comment3') . "&amp;comment3_help=1#comment3_help\">ヘルプ</a>";
	$form .= " &nbsp; $help_link</td></tr>\n";
	$form .= "<tr><td style=\"text-align:right;\">コメント</td><td><textarea name=\"comment\" cols=\"40\" rows=\"3\">$comment</textarea></td></tr>\n";
	$form .= "<tr><td style=\"text-align:right;\">添付</td><td><input type=\"file\" name=\"upfile\" value=\"\" /></td></tr>\n";
	$form .= "</table>\n";
	$form .= "</form>\n";
	$form .= "</div>\n";
	$form = str_replace("\n","|n|",$form);
	$str = str_replace("\n","|n|",$str);
	$vars = get_defined_vars();
	
	if (!$order || $order == 'down') {
		return $str . $form;
	} elseif ($order == 'up') {
		return $form . $str;
	}
}

?>