<?php
$explan = "プラグインの一覧と説明、使用例を表示する。
説明は\$explan、使用例は\$formatで指定する。
<pre>[[plugins]]</pre>と記述する。
<pre>[[plugins('com')]]</pre>のように引数を入れると、検索して該当するプラグインのみ表示する。
正規表現も使用できる。
";

function plugins($keyword = '') {
	global $script;
	$str = '';
	if (!$keyword) { $str .= "<div>インストールされているプラグインの一覧です。</div>\n"; }
	$str = str_replace("\n","<br />\n",$str);
	$files = scandir('./plugin');
	$count = 0;
	$ini_list = array();
	$name_list = array();
	foreach ($files as $file) {
		if (!is_file(join('/',array('./plugin',$file)))) { $count++;	continue; }
		if (preg_match('/^\.{1,2}$/',$file)) {
			unset($files[$count]);
		} elseif ($keyword && preg_match('/^\/.+\/$/',$keyword) && !preg_match($keyword,$file)) {
			unset($files[$count]);
		} elseif ($keyword && !preg_match('/^\/.+\/$/',$keyword) && strpos($file,$keyword) === false) {
			unset($files[$count]);
		} else {
			$explan = '';
			$format = '';
			require_once join('/',array('./plugin',$file));
			if (!$explan || !$format) {
				$cont = file(join('/',array('./plugin',$file)));
				$new_cont = array();
				foreach ($cont as $line) {
					if (preg_match('/function\s+.+\(/',$line)) {
						break;
					} else {
						$new_cont[] = $line;
					}
				}
				$cont = $new_cont;
			}
			if (!$explan) {
				$ptn1 = '/explan\s*?=\s*?"([\s\S]+?)"/';
				$ptn2 = "/explan\s*?=\s*?'([\s\S]+?)'/";
				foreach (array($ptn1,$ptn2) as $ptn) {
					if (preg_match($ptn,join('',$cont),$matched)) {
						if (isset($matched[1])) {
							$explan = $matched[1];
							break;
						}
					}
				}
			}
			if (!$format) {
				$ptn1 = '/format\s*?=\s*?"([\s\S]+?)"/';
				$ptn2 = "/format\s*?=\s*?'([\s\S]+?)'/";
				foreach (array($ptn1,$ptn2) as $ptn) {
					if (preg_match($ptn,join('',$cont),$matched)) {
						if (isset($matched[1])) {
							$format = $matched[1];
							break;
						}
					}
				}
			}
			if (isset($explan)) {
				$exp[$count] = $explan;
			} else {
				$exp[$count] = '説明なし';
			}
			if (isset($format)) {
				$form[$count] = $format;
			} else {
				$form[$count] = '';
			}
			$name = preg_replace('/\.php$/','',$file);
			
			if (preg_match("/^[a-zA-Z]/", $name)) {
				$ini = strtoupper(mb_substr($name,0,1));
			} else if (preg_match("/^\d/", $name)) {
				$ini = mb_substr($name,0,1);
				$ini = '数';
			} else {
				$ini = mb_substr($name,0,1) . '-';
			}
			if (! isset($name_list[$ini])) {
				$name_list[$ini] = '';
			}
			$ex = strip_tags($exp[$count]);
			$ex = preg_split('/\s+/',$ex);
			$hash = array('show_plg'=>$name);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$link = script_link($hash);
			$name_list[$ini] .= "<dl><dt><a href=\"$link#plugin_$name\">" . $name . "</a>" . "</dt><dd>" . $ex[0] . "</dd></dl>\n";
		}
		$count++;
	}
	foreach (array_keys($name_list) as $ini) {
		$str .= '<b>[' . $ini . ']</b>' . $name_list[$ini];
	}
	foreach ($files as $key=>$val) {
		$name = preg_replace('/\.php$/','',$val);
		if (req('show_plg') != $name && req('plugin') != $name) { continue; }
		$str .= "<h1><a name=\"plugin_$name\" id=\"plugin_$name\">" . $name . "</a></h1>";
		if (isset($exp[$key])) {
			$exp[$key] = str_replace(">\n",">",$exp[$key]);
			$exp[$key] = str_replace("\n","<br />\n",$exp[$key]);
			$str .= $exp[$key];
		}
		if (isset($form[$key]) && $form[$key]) {
			$form[$key] = rtrim($form[$key]);
			$frm = explode("\n",$form[$key]);
			$str .= "<h2>使用例</h2>";
			foreach ($frm as $_) {
				if (!$_) { continue; }
				// <pre>タグだと長い行が枠からはみ出す場合があるので、＜div＞タグに変更
				$str .= "<div style=\"background-color:#ddeeff;padding:0.5em;border-radius:8px;margin-top:1em;margin-bottom:1em;\">";
			//	$str .= "<pre>";
				$str .= $_ . "\n";
				$str .= "</div>";
				preg_match('/\[\[([^]]+)\]\]?/',$_,$matched);
				if ($matched) {
					$code = '$tmp = ' . $matched[1];
					if (!preg_match('/;\s?$/',$code)) {
						$code .= ';';
					}
					if (!preg_match('/\(.*\);\s?$/',$code)) {
						$code = preg_replace('/;\s?$/','();',$code);
					}
					
					try {
						eval ($code);
					} catch(Exception $e) {
						$str .= 'プラグインの実行に失敗';
					}
					if (is_array($tmp)) {
						$str .= join('',$tmp);
					} else {
						$str .= $tmp;
					}
				}
			}
		}
	}
	$str = str_replace(array("\r\n","\r","\n"), '|n|', $str);
	return $str;
}
?>