<?php
error_reporting(-1);
$start_s = time(); list($start_ms) = explode(' ',microtime());
date_default_timezone_set('Asia/Tokyo');
$dt = new DateTime();
$current_time = $dt->format('Y-m-d H:i:s');
require './init.php';
require './lib/holiday.php';
$img_ext = array('jpg','JPG','bmp','BMP','gif','GIF','png','PNG');	// 画像ファイルの拡張子リスト　この拡張子のファイルはサムネール作成
$title = $t_title;
$debug = '';

$history = <<<EOF
ver.1.0		2016.12.26	とりあえず完成。
ver.1.01	2017.01.12	別名が索引メニューで表示されていなかったのを修正。
ver.1.02	2017.01.17	記事を編集するとバックアップを作成するように修正。
						合わせてdiff(差分表示)プラグインを追加。
ver.1.03	2017.01.23	カテゴリーの色がそろわないケースがあるのを修正。
ver.1.04	2017.01.24	投稿フォームの「プレビュー」ボタンを押したときのプレビュー表示を調整。
ver.1.05	2017.01.31	誰でも投稿可モードの場合、管理者パスワードで記事をロックできるようにした。
						誰でも投稿可モードで使用できるタグを設定できるようにした。
ver.1.06	2017.02.27	記事中のURLをオートリンクできるようにした。
ver.1.07	2017.03.01	プラグインの記述を間違えて致命的なエラーが出る場合、プラグインの実行をキャンセルしてエラーメッセージを表示するようにした。
ver.1.08	2017.03.22	外部スタイルシートをブラウザ表示用と印刷用に分割。
ver.1.09	2017.04.10	古い履歴ファイルを削除するよう修正。
ver.1.10	2017.12.28	プラグインが配列形式で値を返す場合、2個目の要素を記事末尾に追加するように修正。(脚注プラグイン対応)
ver.1.11	2018.05.25	PHP7.2.0対応
ver.1.12	2018.06.12	検索結果で該当記事がない場合、フォームが消えるのを修正。
ver.1.13	2018.07.09	カウンター機能で、同じホストからの連続アクセスをカウントしないオプションを追加。
ver.1.131	2020.03.11	\$post_mode でだれでも編集可能モードにしてロックすると、管理者パスワードでないと編集できなくなってしまうバグを修正。
ver.1.132	2020.03.12	記事に管理者モードを追加
ver.1.133	2020.03.17	管理者モードが解除できないバグを修正。bbsプラグインにスライドロック機能追加。
ver.1.134	2020.03.18	headerに記述したJavaScriptを外部ファイルに移動。
ver.1.135	2020.03.23	bbs、comment、comment2、comment3プラグイン修正。
ver.1.136	2020.03.24	bbs、recentプラグイン修正。
ver.1.137	2020.03.25	comment2プラグイン修正。
ver.1.138	2020.03.31	tag_convert関数修正。calendarプラグイン修正。
EOF;

$history = explode("\n",$history);
$version = 0;
foreach ($history as $i) {
	if (preg_match('/ver\.([\d\.]+)/',$i,$matched) ) {
		$ver = $matched[1];
		if ($ver > $version) { $version = $ver ; }
	}
}
time_check('更新履歴抽出');

if (!is_dir($datadir)) { mkdir($datadir); }
$listdir = join('/',array($datadir,'list'));
if (!is_dir($listdir)) { mkdir($listdir); }
$pulldown = pulldown(1);
$message = $jump = '';
if (!$crypt_pass) {
	file_put_contents('./reset.txt',"\$crypt_pass=$crypt_pass\n",FILE_APPEND | LOCK_EX);
	if (file_exists('./config.cgi')) {
		$message .= reload_config();
		$jump = "$script?alert=$message";
		if (req('noform')) { $jump .= "&noform=" . req('noform'); }
		if (req('sort')) { $jump .= "&sort=" . req('sort'); }
		file_put_contents('./reset.txt',"\$jump=$jump\n",FILE_APPEND | LOCK_EX);
		redirect($jump);
		exit();
	} else {
		$title = '初期設定';
		create_pass();
		exit();
	}
}
if (req('mode') == 'download') {
	download();
	exit();
}
if (req('prev_pdf')) {
	$url = "http://" . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];
	$url = str_replace('&prev_pdf=1','',$url);
	mpdf_preview($url,'');
	exit;
}
if (req('mode') === 'history') {
	$title = $t_title . "(更新履歴)";
	history();
	exit();
} elseif (req('mode') === 'admin') {
	$title = $t_title . "(管理者用)";
	admin();
}
if (req('login')) {
	$req['login'] = req('login');
} else {
	$req['login'] = '';
}
if (! req('sort')) {
	if ($index_type == 1) {
		$req['sort'] = 'other';
	} elseif ($index_type == 2) {
		$req['sort'] = 'index';
	} elseif ($index_type == 3) {
		$req['sort'] = 'category';
	} elseif ($index_type == 4) {
		$req['sort'] = 'new';
	} elseif ($index_type == 5) {
		$req['sort'] = 'name';
	} else {
		$req['sort'] = 'category';
	}
} else {
	$req['sort'] = req('sort');
}
term();
exit();



function term() {
	global $script,$datadir,$listdir,$perm_tag_list,$rep_width,$access_level,$color_list,$category_list,$cat_belong,$yougo_log,$yougo,$yougoid,$yougotm,$req,$return,$url,$page,$count,$show_new,$new_day,$category_nmb,
	$current_time,$dt,$tm_sort_list,$name_sort_list,$category_sort_list,$dpl_list,$skin,$auto_link,$crypt_pass,$amode_list,$current_back_color,$admin_back_color,$post_mode;
	
	if (req('cssmemo')) { cssmemo(); }
	$category_list = array();	// カテゴリーに登録されている記事の数を調べるために使用(各記事のカテゴリーをすべて保存　重複も有り)
	$cat_belong = array();		// カテゴリー名をキーとする連想配列　カテゴリーが登録されている記事の数を値として保存
	$category_file = join('/',array($listdir,'category_list.cgi'));		// カテゴリーリストを保存するファイルのパス
	// カテゴリーリストファイルが存在する場合は読み込む
	if (file_exists($category_file)) {
		list($line) = file($category_file,FILE_IGNORE_NEW_LINES);
		$tmp = explode('<>',$line);
		foreach ($tmp as $_) {
			$tmp2 = explode('<|>',$_);
			if (isset($tmp2[0])) { $cat = $tmp2[0]; } else { $cat = ''; }
			if (isset($tmp2[1])) { $nmb = $tmp2[1]; } else { $nmb = ''; }
			if ($cat) {
				$category_list[] = $cat;
				$cat_belong[$cat] = $nmb;
			}
		}
	}

	$yougo_log = array();
	// 一覧ファイル作成済みの場合は読み込み
	$tm_sort_file = join('/',array($listdir,'tm_sort_list.cgi'));
	$name_sort_file = join('/',array($listdir,'name_sort_list.cgi'));
	$category_sort_file = join('/',array($listdir,'category_sort_list.cgi'));
	if (file_exists($name_sort_file)) {
		$name_sort_list = file($name_sort_file);
	} else {
		$name_sort_list = array();
	}
	// Menuページが存在するか調べる
	$use_menu = 0;
	foreach ($name_sort_list as $line) {
		$tmp = explode('<>',$line);
		if ($tmp[2] == 'Menu') {
			$use_menu = 1;
			$menu_id = $tmp[0];
			if (!req('sort')) {
				$req['sort'] = 'menu';
			}
			break;
		}
	}
	if ( ( $req['sort'] == 'new' || $req['sort'] == 'other' || $req['sort'] == 'menu') && file_exists($tm_sort_file)) {
		$tm_sort_list = file($tm_sort_file);
		$yougo_log = to_old_format($tm_sort_list);
	} elseif ($req['sort'] == 'index' && file_exists($name_sort_file)) {
		$yougo_log = to_old_format($name_sort_list);
	} elseif ($req['sort'] == 'category' && file_exists($category_sort_file)) {
		$category_sort_list = file($category_sort_file);
		$yougo_log = to_old_format($category_sort_list);
	} else {
		// 作成されていない場合、個別ファイルをすべて読み込み
		read_logs();
	}
	$mes = '';	// メッセージ表示用変数初期化
	if (filemtime('./init.php') + 20 > time()) { $mes .= req('alert'); }
	// カテゴリー名をキーとする連想配列$catを作成　$cat['カテゴリー名']でカテゴリーの番号を取得するため
	$nmb = 0;
	foreach ($category_list as $cat) {
		$category_nmb[$cat] = $nmb;
		$nmb++;
	}
	global $edited_id;
	$edited_id = '';	// 編集された記事のIDを保存する$edited_idを初期化
	$new_id = '';
	
	// 投稿ボタンが押されたら
	if (req('post')) {
		$new_id = post();
	// 記事削除
	} elseif (req('delete')) {
		$id_path = $datadir . '/' . req('edit') . '.cgi';
		list($log) = file($id_path,FILE_IGNORE_NEW_LINES);
		$tmp = explode('<>',$log);
		if ($post_mode && isset($tmp[6]) && $tmp[6]) {
			if (!req('lockpass')) {
				error("編集パスワードを入力して下さい");
			} elseif (decrypt(req('lockpass'),$tmp[6]) != 'yes' && decrypt(req('lockpass'),$crypt_pass) != 'yes') {
				error("編集パスワードが違います");
			}
		}
		unlink($id_path);
		$counter_path = $datadir . '/counter/' . req('edit') . '.cgi';
		if (file_exists($counter_path)) { unlink($counter_path); }
		$counter_ip_path = $counter_path;
		$counter_ip_path = preg_replace('/\.cgi$/','_ip.cgi',$counter_ip_path);
		if (file_exists($counter_ip_path)) { unlink($counter_ip_path); }
		list($id,$tm,$com,$name,$ip) = array('','','','','');
		
		// 記事専用ディレクトリ内のファイルとディレクトリも削除する
		$deldir = join('/',array($datadir,req('edit')));
		if (is_dir($deldir)) {
			// ディレクトリ内のファイルをすべて削除
			$mes .= delete_dir($deldir);
		}

	// 添付ファイル削除
	} elseif (req('del_img')) {
		$del_path = $datadir . '/' . req('del_img');
		$del_thum_path = preg_replace('/(\..{2,4}$)/','thumb$1',$del_path);
		if (file_exists($del_path)) {
			unlink($del_path);
			if (file_exists($del_path . '.oname')) { unlink($del_path . '.oname'); }
			if (file_exists($del_path . '.count')) { unlink($del_path . '.count'); }
		}
		if (file_exists($del_thum_path)) { unlink($del_thum_path); }
	}
	
	// 追加、編集した場合は個別ログを読み込んだ上で、一覧ファイルを作成する
	if (req('post') || req('delete')) {
		read_logs();
		make_list();
		if ( $req['sort'] == 'new' || $req['sort'] == 'other' || $req['sort'] == 'menu') {
			$yougo_log = to_old_format($tm_sort_list);
		} elseif ($req['sort'] == 'index') {
			$yougo_log = to_old_format($name_sort_list);
		} elseif ($req['sort'] == 'category') {
			$yougo_log = to_old_format($category_sort_list);
		}
	}
	
	// 部分編集した場合は該当パートにスクロールする
	if (req('post') && req('edit') && req('part')) {
		$jump = $script . "?edit=" . req('edit') . "&part=" . req('part') . "&sort=" . $req['sort'] . "&login=" . req('login') . "#PART" . req('part');
		redirect($jump);
	}
	$ip = $_SERVER['SERVER_NAME'];
	$name = '';
	$dpl_list = array();		// 名前が重複している記事をチェックするためのの2次元配列　$dpl_list[記事名][番号]にIDを保存します
	$log_exst = 0;
	if ($yougo_log) { $log_exst = 1; }
	$amode_list = array();
	foreach ($yougo_log as $line) {
		$tmp = explode('<>',$line);
		list($id,$tm,$dm,$name,$amode) = $tmp;
		if ($amode) { $amode_list[$id] = 1; }
		if (strpos($name,'&&') !== false) {
			$names = explode('&&',$name);
			foreach ($names as $nm) { $dpl_list[$nm][] = $id; }
		} else {
			$dpl_list[$name][] = $id;
		}
	}
	
	// 編集モードでログを開いている場合、フォーム表示用の値を取得
	if (req('edit') && ! req('delete')) {
		// ログから$commentを抽出。commentパラメータがあれば置き換えてフォーム表示用に変換
		if (req('edit')) {
			list($log) = file($datadir . '/' . req('edit') . '.cgi',FILE_IGNORE_NEW_LINES);
			$tmp = explode('<>',$log);
			list($id,$tm,$name,$category,$comment,$ip) = $tmp;
			if (isset($tmp[6])) { $lock = $tmp[6]; }
			if (isset($tmp[7])) { $amode = $tmp[7]; }
		}
		if (isset($_REQUEST['comment'])) { $comment = $_REQUEST['comment']; }
		if (isset($_REQUEST['name'])) { $name = $_REQUEST['name']; }
		if (isset($_REQUEST['admin_mode'])) { $amode = $_REQUEST['admin_mode']; }
	} elseif (req('bbs_preview')) {
		$comment = req('comment');
		// マジッククォート対策
		if (get_magic_quotes_gpc()) {
			$comment = stripslashes($comment);
		}
		$name = req('name');
		if (isset($_REQUEST['admin_mode'])) { $amode = $_REQUEST['admin_mode']; } else { $amode = ''; }
	} else {
		$comment = '';
	}
	
	// 表示が更新順でなければ$sortに用語名を入れ、用語名で全体のログをソート
	if ($req['sort'] == 'name' || $req['sort'] == 'index') {
		$sort = array();
		foreach ($yougo_log as $line) {
			$tmp = explode('<>',$line);
			if (isset($tmp[2])) { $sort[] = $tmp[2]; }
		}
		array_multisort($sort,SORT_DESC,SORT_STRING,$yougo_log);
	} elseif ($req['sort'] == 'category') {
		$sort = array();
		$sort2 = array();
		foreach ($yougo_log as $line) {
			$tmp = explode('<>',$line);
			if (isset($tmp[3])) { $sort[] = $tmp[3]; }
			if (isset($tmp[2])) { $sort2[] = $tmp[2]; }
		}
		// カテゴリーでソートし、さらに記事名でソートする
		array_multisort($sort,SORT_DESC,SORT_STRING,$sort2,SORT_DESC,SORT_STRING,$yougo_log);
	}
	$form = '';
	$preview_str = '';
		
	// プレビューボタンを押した場合
	if (req('bbs_preview')) { $preview_str = preview(); }
	if (req('edit')) {
		if (req('delete')) {
			$form .= show_form('','','','','','','','');
		} else {
			$lock = req('lock');
			if (!req('bbs_preview')) {
				list($line) = file($datadir . '/' . $id . '.cgi',FILE_IGNORE_NEW_LINES);
				$tmp = explode('<>',$line);
				list($id,$tm,$name,$category,$comment,$ip) = $tmp;
				if (isset($tmp[6])) {
					$lock = $tmp[6];
				} else {
					$lock = '';
				}
				if (isset($tmp[7])) {
					$amode = $tmp[7];
				} else {
					$amode = '';
				}
				if (isset($_REQUEST['admin_mode'])) {
					$amode = $_REQUEST['admin_mode'];
				}
				$comment = str_replace('<br />',"\n",$comment);
				$comment = str_replace('<br>',"\n",$comment);
				$comment = str_replace('/n/',"\n",$comment);
				$form .= show_form($id,$tm,$comment,$name,$ip,$category,$lock,$amode);
			} else {
				$category = req('category_1');
				if (req('category')) { $category = req('category'); }
				$form .= show_form($id,$tm,$comment,$name,$ip,$category,$lock,$amode);
			}
		}
	} elseif ($new_id) {
		if (!req('bbs_preview')) {
			list($line) = file($datadir . '/' . $new_id . '.cgi',FILE_IGNORE_NEW_LINES);
			$tmp = explode('<>',$line);
			$tm = $tmp[1];
			$comment = $tmp[4];
			$category = $tmp[3];
			$name = $tmp[2];
			$ip = $tmp[5];
			if (isset($tmp[6])) {
				$lock = $tmp[6];
			} else {
				$lock = '';
			}
			if (isset($tmp[7])) {
				$amode = $tmp[7];
			} else {
				$amode = '';
			}
			$comment = str_replace('<br />',"\n",$comment);
			$comment = str_replace('<br>',"\n",$comment);
			$comment = str_replace('/n/',"\n",$comment);
		}
		$form .= show_form($new_id,$tm,$comment,$name,$ip,$category,$lock,$amode);
	} elseif (req('bbs_preview')) {
	//	if (isset($_REQUEST['admin_mode'])) {
			$amode = $_REQUEST['admin_mode'];
	//	}
		$form .= show_form('',time_str(''),$comment,$name,$ip,req('category'),req('cryptlockpass'),$amode);
	} elseif (req('newform')) {
		$form .= show_form('',time_str(''),'','','','','','');
	}

	$yougo_log = array_reverse($yougo_log);
	$html = '';
	$editview_str = '';
	if (req('keyword')) {
		$keyword = req('keyword');
	} else {
		$keyword = '';
	}
	if (req('clear')) {
		$keyword = '';
		$_REQUEST['keyword'] = '';
	}
	$keyword = str_replace('　',' ',$keyword);
	$keyword = preg_replace('/^\s+/','',$keyword);
	$keyword = preg_replace('/\s+$/','',$keyword);
	$key_list = array_filter(explode(' ',$keyword));
	$index2 = '';
	$return = 10;		// 次ページに繰り越す記事数
	if ($req['sort'] == 'other') { $return = 20; }
	$nmb = 0;
	if (req('page')) {
		$page = req('page');
	} else {
		$page = 0;
	}
	$count = -1;
	foreach ($yougo_log as $line) {
		$count++;
		$tmp = explode('<>',$line);
		list($id,$tm,$name,$category,$amode) = $tmp;
		// 管理者専用記事の場合、管理者モードでない場合削除
		if ($amode == 1 && (!isset($_COOKIE['admin_pass']) || !$_COOKIE['admin_pass']) && !req('nocal')) {
			unset($yougo_log[$count]);
			continue;
		}

		// キーワードが指定されている場合、ヒットしないリストを削除
		if ($keyword) {
			$hit = 1;
			list($tmp) = file($datadir . '/' . $id . '.cgi');
			foreach ($key_list as $key) {
				// 大文字小文字を区別しないstristrを使用
				if (stristr($tmp,$key) === false) {
					$hit = 0;
				}
			}
			if (!$hit) {
				unset($yougo_log[$count]);
				continue;
			}
		} elseif (req('title_keyword')) {
			list($line) = file($datadir . '/' . $id . '.cgi');
			$tmp = explode('<>',$line);
			if ($tmp[2] != req('title_keyword')) {
				unset($yougo_log[$count]);
				continue;
			}
		}
		// カテゴリーが指定されている場合、カテゴリーが違うリストを削除
		if (req('category_filter')) {
			$categorys = explode('&&',$category);
			$hit = 0;
			foreach ($categorys as $cat) {
				if (req('category_filter') === $cat) {
					$hit = 1;
					break;
				}
			}
			if (!$hit) {
				unset($yougo_log[$count]);
				continue;
			}
		}
		if ( req('sort') == 'category' && req('ini') ) {
			if (req('ini') != 'カテゴリーなし' && strpos($category,req('ini')) === false) {
				unset($yougo_log[$count]);
				continue;
			}
		}
	}

	// ページ指定がなく、記事IDのみ指定された場合の対策
	$count = 0;
	foreach ($yougo_log as $line) {
		$tmp = explode('<>',$line);
		$id = $tmp[0];
		$amode = '';
		if (isset($tmp[6])) {
			$amode = $tmp[6];
			$amode = str_replace(array("\r\n","\r","\n"), '', $amode);
		}
		if ($amode == 1 && $access_level != 4 && !req('nocal')) { continue; }
		if ($id == req('noform') || $id == req('edit') || $id == $edited_id || $id == $new_id) {
			$page = intval($count/$return);
			break;
		}
		$count++;
	}
	$exs_frontpage = 0;
	foreach ($yougo_log as $nmb=>$line) {
		$tmp = explode('<>',$line);
		if ($req['sort'] == 'menu' && isset($tmp[2]) && $tmp[2] == 'FrontPage' && !req('noform')) {
			unset($yougo_log[$nmb]);
			array_unshift($yougo_log,$line);
			$exs_frontpage = 1;
			break;
		}
	}

	// 各用語リストについて処理
	$editview_list = array();
	$count = -1;
	$nmb = 0;
	time_check('ログについての処理開始');
	foreach ($yougo_log as $line) {
		$count++;
		$nmb++;
		$tmp = explode('<>',$line);
		list($id,$tm,$title) = $tmp;
		$path = $datadir . '/' . $id . '.cgi';		$pathtest = $id;

		// 指定されたページ範囲内の記事でなければスキップ
		if ( $nmb > $page * $return && $nmb <= ($page + 1) * $return ) {
		} else {
			if (req('noform') != $id && req('edit') != $id) { continue; }
		}
		$show = 0;
		if (req('noform') == $id) { $show = 1; }
		if (req('noform') == 'all') { $show = 1; }
		if (req('edit') == $id) { $show = 1; }
		if (req('post') && $new_id == $id) { $show = 1; }
		if (!req('noform') && $count == 0 && ($req['sort'] == 'other' || $req['sort'] == 'menu') && ! req('bbs_preview') && ! req('post') && !req('login') && !$exs_frontpage) { $show = 1; }
		if (req('newform')) { $show = 0; }
		if (!req('noform') && !req('edit') && $tmp[2] == 'FrontPage') { $show = 1; }
		if (file_exists($path)) { list($log) = file($path); } else { $log = ''; }
		$tmp = explode('<>',$log);
		$comment = '';
		$name = '';
		if (isset($tmp[4])) { $comment = $tmp[4]; }
		if (isset($tmp[2])) { $name = $tmp[2]; }
		if (isset($tmp[3])) {
			$category = $tmp[3];
		} else {
			$category = '';
		}
		// 検索キーワード部分を色づけ
		if ($keyword) { $comment = keyword_coloring($comment,$keyword); }

		// $yougoが登録されている場合、用語置換を行う
		$yougo_skip = 0;
		if (!req('post') && req('noform') != 'all' && req('noform') != $id && req('edit') != $id) { $yougo_skip = 1; }
		if ($count == 0 ) { $yougo_skip = 0; }
		if (isset($yougo) && ! $yougo_skip ) {
			$key_list2 = array_keys($yougo);
			usort( $key_list2 , function($a,$b) { return strlen( $b ) - strlen( $a ); } );
			$trans_list = array();
			$trans_count = 0;

			// 置換しない部分をあらかじめ別の文字列に置き換えておき、用語置換終了後元に戻す。
			$ptn0 = '/<(span|div) class="notrans">([^<]+)<\/(span|div)>?/';
			$ntrcount = 0;
			$notrans = array();
			while (preg_match($ptn0,$comment,$matched)) {
				$notrans[$ntrcount] =$matched[2];
				$comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$comment,1);
				$ntrcount++;
			}

			// <a>タグ内も置き換えを避ける
			$ptn0 = '/(<a[^>]*>[^<]+<\/a>?)/';
			while (preg_match($ptn0,$comment,$matched)) {
				$notrans[$ntrcount] =$matched[1];
				$comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$comment,1);
				$ntrcount++;
			}

			// <img>タグ内も置き換えを避ける
			$ptn0 = '/(<img[^>]*>?)/';
			while (preg_match($ptn0,$comment,$matched)) {
				$notrans[$ntrcount] =$matched[1];
				$comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$comment,1);
				$ntrcount++;
			}

			// <pre>タグ内も置き換えを避ける
			$ptn0 = '/(<pre>(?!<\/pre>)*.*?<\/pre>)/';
			while (preg_match($ptn0,$comment,$matched)) {
				$notrans[$ntrcount] =$matched[1];
				$comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$comment,1);
				$ntrcount++;
			}

			// プラグイン部分置き換え
			$prgcount = 0;
			$plugin = array();
			$ptn0 = '/\[\[([^]]+)\]\]?/';
			while (preg_match($ptn0,$comment,$matched)) {
				$plugin[$prgcount] =$matched[1];
				$comment = preg_replace($ptn0,'<plugin' . $prgcount . '>',$comment,1);		//file_put_contents('./plugin_counttest.log',"\$plugin[$prgcount]=" . $plugin[$prgcount] . "\n",FILE_APPEND | LOCK_EX);
				$prgcount++;
			}
			// [ページ名|コーナー名]パターンの置き換え
			$title_corner_count = 0;
			$title_corner = array();
			$ptn0 = '/\[\[([^|]+\|[^]]+)\]\]?/';
			while (preg_match($ptn0,$comment,$matched)) {
				//list($title,$corner) = explode('|',$matched[1]);
				$title_corner[$title_corner_count] = $matched[1];
				$comment = preg_replace($ptn0,'<title_corner'  . $title_corner_count . '>',$comment,1);
			}

			// 改修メモ 用語置換に引っかからないように、<span style="notrans"></span>で囲まれた部分をいったん別の文字列に置き換え、
			// 用語置換が終わった後元に戻すという処理だが、
			// preg_matchで該当箇所の文字列を取得してさらにpreg_replaceで文字列を置き換えているが、イマイチスマートじゃない。
			list($midashi_str,$comment,$midashi) = midashi($comment,$id);
			foreach ($key_list2 as $key) {
				if ($key == $name) { continue; }
				if (strpos($name,'&&') !== false) {
					$names = explode('&&',$name);
					$contin = 0;
					foreach ($names as $_) {
						if ($key == $_) { $contin = 1;
							break;
						}
					}
					if ($contin) { continue; }
				}
				
				if (strpos($comment,$key) !== false && !preg_match('/[^\s\S]/',$yougo[$key])) {
					if (isset($yougoid[$key]) && file_exists($datadir . '/' . $yougoid[$key] . '.cgi')) {
						list($line) = file($datadir . '/' . $yougoid[$key] . '.cgi');
						$tmp = explode('<>',$line);
						if (isset($tmp[4])) { $yougo[$key] = $tmp[4]; }
					}
				} else {
					continue;	// $commentに含まれていない用語はスキップ
				}
				$title = $yougo[$key];
				if (strlen($title) > strlen(jtruncate($title,1000))) {
					$title = jtruncate($title,1000) . '...';
				}
				if (isset($dpl_list[$key]) && count($dpl_list[$key]) > 1) {
					$title = '';
					$com_nmb = 1;
					foreach ($dpl_list[$key] as $_) {
						list($log) = file(join('/',array($datadir,$_ . '.cgi')));
						$tmp = explode('<>',$log);
						$com = $tmp[4];
						if (strlen($com) > strlen(jtruncate($com,300))) {
							$com = jtruncate($com,300) . '...';
						}
						$title .= "($com_nmb)" . $com . "|n|------------------------------------------|n|";
						$com_nmb++;
					}
					// とりあえず検索にしておく　後で改修予定
					$url = "./${script}?noform=all";
					$url .= "&amp;title_keyword=" . urlencode($key) . "&amp;search=1";
					if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
				} else {
					if (isset($yougoid[$key])) {
						$url = "./${script}?noform=" . $yougoid[$key] . '&amp;noindex=' . req('noindex');
					} else {
						$url = "./${script}?noindex=" . req('noindex');
					}
					if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
				}
				$title = str_replace('<br />',"|n|",$title);
				$title = str_replace('"','”',$title);
				$title = strip_tags($title);
				$title = $key . '|n|' . $title;
				$title = jtruncate($title,1024);
				$tmp = trans($comment,$key,$trans_count);
				if ($tmp) {
					$comment = $tmp[0];
					$trans_list[$trans_count] = '<a class="pup" href="' . $url . '" title="' . $title . '">' . $tmp[1] . '</a>';
					$trans_count++;
				}
			}
			if ($auto_link) { $comment = auto_link($comment); }
			$trans_count = 0;
			foreach ($trans_list as $trans) {
				$comment = str_replace('<trans' . $trans_count . '>',$trans,$comment);
				$trans_count++;
			}
			if ($notrans) {
				foreach (array_keys($notrans) as $key) {
					$comment = str_replace('<notrans' . $key . '>',$notrans[$key],$comment);
				}
			}
			if ($title_corner) {
				$title_list = array_flip($key_list2);
				foreach (array_keys($title_corner) as $key) {
					list($title_,$corner) = explode('|',$title_corner[$key]);
					$str = '';
					if (array_key_exists($title_,$title_list)) {
						
						if (isset($yougoid[$title_]) && file_exists($datadir . '/' . $yougoid[$title_] . '.cgi')) {
							list($line) = file($datadir . '/' . $yougoid[$title_] . '.cgi');
							$tmp = explode('<>',$line);
							if (isset($tmp[4])) { $yougo[$title_] = $tmp[4]; }
							$com = $tmp[4];
							
							list($dum0,$dum1,$corner_list) = midashi($com,$yougoid[$title_]);
							$corner_count = 0;
							foreach ($corner_list as $crn) {
								if (strpos($crn,$corner) !== false) {
									$midashi_count = $corner_count;
									file_put_contents('./test.txt',"\$midashi_count=$midashi_count\n",FILE_APPEND | LOCK_EX);
									break;
								} else {
									file_put_contents('./test.txt',"該当せず\$crn=$crn\n",FILE_APPEND | LOCK_EX);
								}
								$corner_count++;
							}
							if (strlen($com) > strlen(jtruncate($com,1000))) {
								$com = jtruncate($com,1000) . '...';
							}
							$com = str_replace('<br />',"|n|",$com);
							$com = str_replace('"','”',$com);
							$com = strip_tags($com);
							//$com = $key . '|n|' . $com;
							$url = "./${script}?noform=" . $yougoid[$title_] . '&amp;noindex=' . req('noindex');
							if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
							$url .= '#midashi' . $yougoid[$title_] . $midashi_count;
							$str = '<a class="pup" href="' . $url . '" title="' . $com . '">' . $title_ . '/' . $corner . '</a>';
						}
					}
					if ($str) { $comment = str_replace('<title_corner' . $key . '>',$str,$comment); }
				}
			}
			if ($midashi) {
				foreach (array_keys($midashi) as $key) {
					$midashi[$key] = preg_replace('/(<h[1234])/','$1 id="midashi' . $id . $key . '"',$midashi[$key]);
					$comment = str_replace('<midashi' . $key . '>',$midashi[$key],$comment);
				}
			}
			$show = 0;
			if (req('noform') == $id) { $show = 1; }
			if (req('noform') == 'all') { $show = 1; }
			if (req('edit') == $id) { $show = 1; }
			if (req('post') && $new_id == $id) { $show = 1; }
			if (!req('noform') && $count == 0 && ($req['sort'] == 'other' || $req['sort'] == 'menu') && ! req('bbs_preview') && !req('post') && req('login') != $id) { $show = 1;file_put_contents('./frontid',$id,LOCK_EX); }
			if (req('newform')) { $show = 0; }
			if ($plugin && $show) {
				foreach (array_keys($plugin) as $key) {
					$tmp = explode('(',$plugin[$key]);
					$pipath = './plugin/' . $tmp[0] . '.php';
					if ( ! preg_match('/^[a-zA-Z0-9_]+$/',$tmp[0])) {
						$str = '[[' . $plugin[$key] . ']]';
					} elseif (file_exists($pipath)) {
						require_once $pipath;
						if (chk_plugin($plugin[$key]) != 'error') {
							$code = '$str = ' . $plugin[$key];
							if (!preg_match('/;\s?$/',$code)) { $code .= ';'; }
							if (!preg_match('/\(.*\);\s?$/',$code)) { $code = preg_replace('/;\s?$/','();',$code); }
							try {
								eval ($code);
							} catch(Exception $e) {
								$str .= 'プラグインの実行に失敗';
							}
						} else {
							$str = '[[' . $plugin[$key] . ']]プラグインの記述が間違っています';
						}
					} else {
						$str = '<div style="background-color:#cccccc"><span style="color:red;">plugin error</span>&nbsp;[[' . $plugin[$key] . ']]</div>';
					}
					if (is_array($str)) {
						list($str1,$str2) = $str;
						$comment = str_replace('<plugin' . $key . '>',$str1,$comment) . $str2;
					} else {
						$comment = str_replace('<plugin' . $key . '>',$str,$comment);
					}
				}
			}
			if (file_exists('./frontid')) { unlink('./frontid'); }
		}

		// プレビュー用に$commentを整形
		$comment = str_replace(array("\r\n","\r","\n"), '/n/', $comment);
		$comment = str_replace('&lt;!--','<!--',$comment);
		$comment = str_replace('--&gt;','-->',$comment);
		$comment = str_replace('/n/','',$comment);
		$comment = str_replace("    ","&nbsp;&nbsp;&nbsp;&nbsp;",$comment);
		$comment = str_replace("\t","&nbsp;&nbsp;&nbsp;&nbsp;",$comment);
		$comment = str_replace('|n|',"\n",$comment);
		$comment_80 = $comment;
		if ($id == req('edit')) {
			$tmp_com = '';
			$comment_list = explode('<|>',$comment);
			$pnmb = 0;
			if (count($comment_list) > 1) {
				$url = "$script?edit=" . req('edit') . "&amp;hide_thum=" . req('hide_thum') . "&amp;sort=" . $req['sort'];
				foreach (array('keyword','category_filter','login') as $key) {
					if (req($key)) { $url .= "&amp;$key=" . urlencode(req($key)); }
				}
				if (isset($req['login']) && $req['login']) { $url .= "&amp;login=" . $req['login']; }
				foreach ($comment_list as $com) {
					$tmp_com .= "<div><a name=\"PART$pnmb\" id=\"PART$pnmb\" href=\"$url&amp;part=$pnmb\">部分編集</a></div>\n";
					$tmp_com .= $com;
					$pnmb++;
				}
			} else {
				$tmp_com .= $comment;
			}
			$comment = $tmp_com;
		}
		$comment = str_replace('<|>','',$comment);
		$comment = str_replace('|n|',"\n",$comment);
		$editview_str = '';
		
		// プレビューを表示
		if (! req('edit') || req('edit') == $id) {
			$show = 0;
			if (req('noform') == $id) { $show = 1; }
			//if (req('noform') == 'all' && $req['sort'] != 'index') { $show = 1; }
			if (req('noform') == 'all') { $show = 1; }
			if (req('edit') == $id) { $show = 1; }
			if (req('post') && $new_id == $id) { $show = 1; }
			if (!req('noform') && $count == 0 && ($req['sort'] == 'other' || $req['sort'] == 'menu') && ! req('bbs_preview') && ! req('post')) {$show = 1; }
			if (req('newform')) { $show = 0; }
			if ($show) {
				if ($category) {
					if (isset($category_nmb[$category])) {
						$col = category_color($category);
						$show_cat = "<span style=\"border-radius:5px;padding:0.1em 0.4em;margin-bottom:0.4em;font-weight:bold;background-color:$col;color:" . text_color($col) . ";\">$category</span>&nbsp;&nbsp;";
					} elseif(strpos($category,'&&') !== false) {
						$cats = explode('&&',$category);
						$show_cat = '';
						foreach ($cats as $cat) {
							if (isset($category_nmb[$cat])) {
								$col = category_color($cat);
								$show_cat .= "<span style=\"border-radius:5px;padding:0.1em 0.4em;margin-bottom:0.4em;font-weight:bold;background-color:$col;color:" . text_color($col) . ";\">$cat</span>&nbsp;&nbsp;";
							}
						}
					} else {
						$show_cat = "<span style=\"padding:0.1em 0.4em;margin-bottom:0.4em;font-weight:bold;\">$category</span>&nbsp;&nbsp;";
					}
				} else {
					$show_cat = '';
				}
				$new = '';
				if (gettype($tm) == 'integer') {
					if (time() - $tm < $new_day*3600*24) { $new = "<span style=\"color:crimson;\">new</span>"; }
				} else {
					$datetime1 = date_create($tm);
					$datetime2 = date_create($current_time);
					if (gettype($datetime1) == 'object' && gettype($datetime2) == 'object') {
						$interval = date_diff($datetime1, $datetime2);
						if ($interval->format('%R%a days') < $new_day) { $new = "<span style=\"color:crimson;\">new</span>"; }
					}
				}
				
				$editview_str .= "<div style=\"text-align:right;\">" . $show_cat . date2("Y年m月d日 H:i",$tm) . "&nbsp;<span class=\"notprint\">&nbsp;&nbsp;";
				$edit_url = "$script?edit=$id&amp;page=" . req('page') . "&amp;hide_thum=" . req('hide_thum') . "&amp;keyword=" . urlencode(req('keyword'));
				if ($req['sort']) { $edit_url .= "&amp;sort=" . $req['sort']; }
				if ($req['login']) { $edit_url .= "&amp;login=" . $req['login']; }
				if (req('category_filter')) { $edit_url .= "&amp;category_filter=" . urlencode(req('category_filter')); }
				$editview_str .= "<a href=\"$edit_url\">編集</a></span>";
				if ($new) { $editview_str .= "<div style=\"float:left;\">$new</div>"; }
				$editview_str .= "</div>\n";
				if ($access_level != 4 && $amode && !req('nocal')) {
					$editview_str .= "<div>表示できません</div>\n";
				} else {
					
					$other_name = '';
					if (strpos($name,'&&') !== false) {
						$list = explode('&&',$name);
						$i = 0;
						$name = array_shift($list);
						$other_name = join('&nbsp;&nbsp;',$list);
					}
					if ($other_name) {
						$other_name = '<div>別名：' . $other_name . "</div>\n";
					}
					$editview_str .= "<div class=\"title\">$name</div>";
					if (isset($midashi_str) && $midashi_str) {
						$tmp = "<div class=\"notprint\" style=\"background-color:#ffeef8;padding:0.3em;margin:0.5em;\"><div onclick=\"obj=document.getElementById('open" . $count . "').style; obj.display=(obj.display=='none')?'block':'none';\"><a style=\"cursor:pointer;\">アウトライン</a></div>\n";
						$midashi_str = "$tmp<div id=\"open" . $count . "\" style=\"display:none;clear:both;\">$midashi_str</div>\n</div>\n";
						$editview_str .= "<div>$midashi_str$other_name$comment</div>\n";
					} else {
						$editview_str .= "<div>$other_name$comment</div>\n";
					}
				}
				global $use_counter;
				if ($use_counter) {
					if (req('noform') == $id) { counter($id); }
					if (file_exists($datadir . '/counter/' . $id . '.cgi')) { $editview_str .= "<div class=\"notprint\" style=\"font-size:80%;text-align:right;\">counter:" . number_format(filesize($datadir . '/counter/' . $id . '.cgi')) . "</div>"; }
				}
			}
		}
		if ($editview_str) {
			$editview_list[] = $editview_str;
			if (count($editview_list) > 10 && $req['sort'] == 'index') { continue; }
		}
		if (strpos($name,'&&') !== false) { list($name) = explode('&&',$name); }
		$ttl = "[$name]";
		$pup = '';
		if ($req['sort'] == 'other') {
			if (strlen($name) > 30) {
				$dot = '';
				if (strlen($name) > strlen(jtruncate($name,30))) { $dot = '...'; }
				$ttl = '[' . jtruncate($name,30) . "${dot}]";
				$pup = jtruncate($name,100);
			}
		}
		$comment_80 = $comment;
		$tmp = strip_tags($comment_80);
		if ($req['sort'] == 'other') {
			$str = $ttl;
		} else {
			$str = $ttl . " " . $tmp;
		}
		$len = 72;
		$len = intval($rep_width / 9);
		$tmp = jtruncate($str,intval($len*1.5));
		preg_match_all('/[a-zA-Z0-9]+/',$tmp,$match);
		$hankaku = join('',$match[0]);
		$add = intval(strlen($hankaku) / 2.5) * 2;
		$len += $add;
		$notag = jtruncate($str,$len);
		if ($req['sort'] != 'other') { $notag .= '...'; }
		if (req('edit') == $id || $edited_id == $id || (req('post') && $new_id == $id)) {
			$back = " style=\"background-color:#ffdddd\"";
		} elseif (req('noform') == $id) {
			$back = " style=\"background-color:$current_back_color\"";
		} elseif ($amode == 1) {
			$back = " style=\"background-color:#ddffff\"";
		} elseif (isset($amode_list[$id]) && $amode_list[$id]) {
			$back = " style=\"background-color:#aaffff\"";
		} else { $back = ''; }
		$url = "$script?noform=$id";
		$url_edit = "$script?edit=$id";
		if ($req['sort']) {
			$url .= "&amp;sort=" . $req['sort'];
			$url_edit .= "&amp;sort=" . $req['sort'];
		}
		foreach (array('page','hide_thum','keyword','category_filter','st_pg','login') as $key) {
			if (req($key)) {
				$url .= "&amp;$key=" . urlencode(req($key));
				$url_edit .= "&amp;$key=" . urlencode(req($key));
			}
		}
		$new = '';
		$tm = date2("Y/m/d H:i:s",$tm);
		$day = new DateTime($tm);
		$day->modify('+' . $new_day . ' days');
		if ($show_new && $day > $dt) {
			$new = "<span style=\"color:crimson;font-size:80%\">new</span>";
		}
		$index2 .= "<tr$back>";
		if ($req['sort'] != 'other') { $index2 .= "<td>$nmb</td><td><a href=\"$url_edit\">▼</a></td>"; }
		$index2 .= "<td style=\"white-space:nowrap;\">$new<a href=\"$url\" style=\"text-decoration:none;\" title=\"$pup\">$notag</a></td>";
		if ($req['sort'] != 'other') {
			$index2 .= "<td style=\"white-space:nowrap;\"><span style=\"font-size:80%\">" . date2("Y/m/d H:i",$tm) . "投稿</span></td>";
		} else {
			$index2 .= "<td style=\"white-space:nowrap;text-align:right;\"><span style=\"font-size:80%\">" . date2("Y/m/d",$tm) . "投稿</span></td>";
		}
		if ($req['sort'] != 'other') { $index2 .= "<td><a href=\"$url\" style=\"text-decoration:none;\">■</a></td>"; }
		$index2 .= "</tr>\n";
	}
	time_check('ログについての処理終了');
	$index = "<div class=\"notprint\">\n";
	$url = "$script?mode=yougo";
	if (req('keyword')) { $url .= "&amp;keyword=" . urlencode(req('keyword')); }
	if (req('category_filter')) { $url .= "&amp;category_filter=" . urlencode(req('category_filter')); }
	if (req('edit')) { $url .= "&amp;edit=" . req('edit'); }
	if ($req['login']) { $url .= "&amp;login=" . $req['login']; }
	if (!isset($_REQUEST['sort']) || !$_REQUEST['sort']) { $_REQUEST['sort'] = 'index'; }
	if ($use_menu) {
		if ($req['sort'] == 'menu') {
			$index .= "<b>メニュー</b>&nbsp;";
		} else {
			if (req('noform')) {
				$index .= "<a href=\"$url&amp;sort=menu&amp;noform=" . req('noform') . "\">メニュー</a>&nbsp;";
			} else {
				$index .= "<a href=\"$url&amp;sort=menu\">メニュー</a>&nbsp;";
			}
		}
	}
	if ($req['sort'] == 'other') {
		$index .= "<b>新着順</b>&nbsp;";
	} else {
		if (req('noform')) {
			$index .= "<a href=\"$url&amp;sort=other&amp;noform=" . req('noform') . "\">新着順</a>&nbsp;";
		} else {
			$index .= "<a href=\"$url&amp;sort=other\">新着順</a>&nbsp;";
		}
	}
	if ($req['sort'] == 'index') {
		$index .= "<b>索引</b>&nbsp;";
	} else {
		if (req('noform')) {
			$index .= "<a href=\"$url&amp;sort=index&amp;noform=" . req('noform') . "\">索引</a>&nbsp;";
		} else {
			$index .= "<a href=\"$url&amp;sort=index\">索引</a>&nbsp;";
		}
	}
	if ($req['sort'] == 'category') {
		$index .= "<b>カテゴリー</b>&nbsp;";
	} else {
		if (req('noform')) {
			$index .= "<a href=\"$url&amp;sort=category&amp;noform=" . req('noform') . "\">カテゴリー</a>&nbsp;";
		} else {
			$index .= "<a href=\"$url&amp;sort=category\">カテゴリー</a>&nbsp;";
		}
	}
	if (req('noform')) { $url .= "&amp;noform=" . req('noform'); }
	if (req('sort')) { $url .= "&amp;sort=" . req('sort'); }
	global $use_mpdf;
	if ($use_mpdf) { $index .= "<a href=\"$url&amp;prev_pdf=1\" target=\"_blank\">PDF表示</a>&nbsp;"; }
	$index0 = $index;
	$index0 .= "</div>\n";
	$show_index = '';	// 索引の際に使用
	if ( $req['sort'] == 'index' && ! req('noindex') ) {
		$show_index = show_index();
	} elseif ( $req['sort'] == 'category' && ! req('noindex') ) {
		$show_index = show_category();
	}
	$index1 = '';
	if (count($yougo_log) > $return) { $index1 = nmb_index(); }
	if ($req['sort'] != 'index' && $req['sort'] != 'category') {
		$index .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" summary=\"掲示板一覧\" style=\"width:100%;line-height:1.5;\">\n";
		$index .= "<tr><td colspan=\"2\">$index1</td></tr>\n";
		$index .= $index2;
		$index .= "</table>\n";
	}
	$index .= "<div style=\"clear:both;\">登録数：" . count($yougo_log) . "</div>\n";
	$index .= "</div>\n";
	if ($req['sort'] == 'menu') {
		list($menu_log) = file($datadir . '/' . $menu_id . '.cgi');
		$tmp = explode('<>',$menu_log);
		list($mn) = explode('<||>',$tmp[2]);
		$mn = $tmp[4];
		$id = $menu_id;

		// 置換しない部分をあらかじめ別の文字列に置き換えておき、用語置換終了後元に戻す。
		$ptn0 = '/<(span|div) class="notrans">([^<]+)<\/(span|div)>?/';
		$ntrcount = 0;
		$notrans = array();
		while (preg_match($ptn0,$mn,$matched)) {
			$notrans[$ntrcount] =$matched[2];
			$mn = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$mn,1);
			$ntrcount++;
		}

		// <a>タグ内も置き換えを避ける
		$ptn0 = '/(<a[^>]*>[^<]+<\/a>?)/';
		while (preg_match($ptn0,$mn,$matched)) {
			$notrans[$ntrcount] =$matched[1];
			$mn = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$mn,1);
			$ntrcount++;
		}

		// <img>タグ内も置き換えを避ける
		$ptn0 = '/(<img[^>]*>?)/';
		while (preg_match($ptn0,$mn,$matched)) {
			$notrans[$ntrcount] =$matched[1];
			$mn = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$mn,1);
			$ntrcount++;
		}

		// プラグイン部分置き換え
		$prgcount = 0;
		$plugin = array();
		$ptn0 = '/\[\[([^]]+)\]\]?/';
		while (preg_match($ptn0,$mn,$matched)) {
			$plugin[$prgcount] =$matched[1];
			$mn = preg_replace($ptn0,'<plugin' . $prgcount . '>',$mn,1);
			$prgcount++;
		}
		list($midashi_str,$mn,$midashi) = midashi($mn,$id);
		if (isset($key_list2)) {
			foreach ($key_list2 as $key) {
				if (strpos($name,'&&') !== false) {
					$names = explode('&&',$name);
					$contin = 0;
					foreach ($names as $_) {
						if ($key == $_) { $contin = 1; break; }
					}
					if ($contin) { continue; }
				}
				if (strpos($mn,$key) !== false && !preg_match('/[^\s\S]/',$yougo[$key])) {
					if (isset($yougoid[$key]) && file_exists($datadir . '/' . $yougoid[$key] . '.cgi')) {
						list($line) = file($datadir . '/' . $yougoid[$key] . '.cgi');
						$tmp = explode('<>',$line);
						if (isset($tmp[4])) { $yougo[$key] = $tmp[4]; }
					}
				} else {
					continue;	// $mnに含まれていない用語はスキップ
				}
				$title = $yougo[$key];
				if (strlen($title) > strlen(jtruncate($title,1000))) {
					$title = jtruncate($title,1000) . '...';
				}
				if (isset($dpl_list[$key]) && count($dpl_list[$key]) > 1) {
					$title = '';
					$com_nmb = 1;
					foreach ($dpl_list[$key] as $_) {
						list($log) = file(join('/',array($datadir,$_ . '.cgi')));
						$tmp = explode('<>',$log);
						$com = $tmp[4];
						if (strlen($com) > strlen(jtruncate($com,300))) { $com = jtruncate($com,300) . '...'; }
						$title .= "($com_nmb)" . $com . "|n|------------------------------------------|n|";
						$com_nmb++;
					}
					// とりあえず検索にしておく　後で改修予定
					$url = "./${script}?noform=all";
					$url .= "&amp;title_keyword=" . urlencode($key) . "&amp;search=1";
					if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
				} else {
					if (isset($yougoid[$key])) {
						$url = "./${script}?noform=" . $yougoid[$key] . '&amp;noindex=' . req('noindex');
					} else {
						$url = "./${script}?noindex=" . req('noindex');
					}
					if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
				}
				$title = str_replace('<br />',"|n|",$title);
				$title = str_replace('"','”',$title);
				$title = strip_tags($title);
				$title = $key . '|n|' . $title;
				$title = str_replace('|n|',"\n",$title);
				$title = preg_replace('/\s+/',"\n",$title);
				$title = jtruncate($title,1024);
				$tmp = trans($mn,$key,$trans_count);
				if ($tmp) {
					$mn = $tmp[0];
					$trans_list[$trans_count] = '<a class="pup" href="' . $url . '" title="' . $title . '">' . $tmp[1] . '</a>';
					$trans_count++;
				}
			}
		}
		$trans_count = 0;
		if (isset($trans_list)) {
			foreach ($trans_list as $trans) {
				$mn = str_replace('<trans' . $trans_count . '>',$trans,$mn);
				$trans_count++;
			}
		}
		if ($notrans) {
			foreach (array_keys($notrans) as $key) {
				$mn = str_replace('<notrans' . $key . '>',$notrans[$key],$mn);
			}
		}
		if ($midashi) {
			foreach (array_keys($midashi) as $key) {
				$midashi[$key] = preg_replace('/(<h[1234])/','$1 name="midashi' . $id . $key . '" id="midashi' . $id . $key . '"',$midashi[$key]);
				$mn = str_replace('<midashi' . $key . '>',$midashi[$key],$mn);
			}
		}

		global $place,$id;
		$id = $menu_id;
		$place = 'menu';
		if ($plugin) {
			foreach (array_keys($plugin) as $key) {
				$tmp = explode('(',$plugin[$key]);
				$pipath = './plugin/' . $tmp[0] . '.php';
				if ( ! preg_match('/^[a-zA-Z0-9_]+$/',$tmp[0])) {
					$str = '[[' . $plugin[$key] . ']]' . '認識されず';
				} elseif (file_exists($pipath)) {
					require_once $pipath;
					if (chk_plugin($plugin[$key]) != 'error') {
						$code = '$str = ' . $plugin[$key];
						if (!preg_match('/;\s?$/',$code)) { $code .= ';'; }
						if (!preg_match('/\(.*\);\s?$/',$code)) { $code = preg_replace('/;\s?$/','();',$code); }
						eval ($code);
					} else {
						$str = '[[' . $plugin[$key] . ']]プラグインの記述が間違っています';
					}
				} else {
					$str = '<div style="background-color:#cccccc"><span style="color:red;">plugin error</span>&nbsp;[[' . $plugin[$key] . ']]</div>';
				}
				$mn = str_replace('<plugin' . $key . '>',$str,$mn);
				$mn = str_replace('/n/','',$mn);
			}
		}
		$index = $index0 . $mn;
	}
	$search_str = '';
	$search_str .= "<div class=\"notprint\" style=\"padding:4px;\">";
	global $option_select,$optin_style,$option_url;
	array_unshift($category_list,'');
	$count = 0;
	foreach ($category_list as $cat) {
		$option_url[$cat] = "?mode=yougo&amp;category_filter=" . urlencode($cat) . '&amp;noform=all';
		if (req('keyword')) { $option_url[$cat] .= "&amp;keyword=" . urlencode(req('keyword')); }
		if ($req['sort']) { $option_url[$cat] .= "&amp;sort=" . $req['sort']; }
		if (req('category_filter') && req('category_filter') == $cat) { $option_select[$cat] = 1; }
		if ($cat) {
			$col = category_color($cat);
			$optin_style[$cat] = " style=\"background-color:$col;color:" . text_color($col) . "\"";
		}
		$count++;
	}
	if (! req('noindex')) {
		$search_str .= "<div style=\"float:left;vertical-align:center;\">";
		if (count($category_list) > 1 ) { $search_str .= pulldown_form2('',$category_list); }
		$search_str .= "</div>\n";
		$search_str .= "<div style=\"float:left;padding-left:0.5em;margin:0;\">";
		$search_str .= "<form action=\"$script\" method=\"post\" style=\"margin:0;vertical-align:top;\">\n";
		$search_str .= "<input type=\"hidden\" name=\"mode\" value=\"yougo\" />\n";
		$search_str .= "<input type=\"hidden\" name=\"noform\" value=\"all\" />\n";
		if (req('category_filter')) {
			$search_str .= "<input type=\"hidden\" name=\"category_filter\" value=\"" . req('category_filter') . "\" />\n";
		}
		if ($req['sort']) {
			$search_str .= "<input type=\"hidden\" name=\"sort\" value=\"" . $req['sort'] . "\" />\n";
		}
		$search_str .= "<span style=\"font-size:80%\">キーワード</span>&nbsp;<input type=\"text\" name=\"keyword\" value=\"$keyword\" style=\"width:180px;\" />&nbsp;";
		if ($keyword) {
			$search_str .= "<input type=\"submit\" name=\"search\" value=\"検索する\" />&nbsp;<input type=\"submit\" name=\"clear\" value=\"クリア\" />\n";
		} else {
			$search_str .= "<input type=\"submit\" name=\"search\" value=\"検索する\" />\n";
		}
		$search_str .= "</form>\n";
		$search_str .= "</div>\n";
		if ($keyword) {
			$search_str .= "<div style=\"clear:both;\"><span style=\"color:blue\">";
			foreach ($key_list as $key) {
				$search_str .= "【${key}】";
			}
			if ($yougo_log) {
				$search_str .= "</span>\nで検索&nbsp;<span style=\"color:crimson;\">" . count($yougo_log) . "件</span>ヒット!";
			} else {
				$search_str .= "</span>\nで検索&nbsp;該当する記事はありませんでした";
			}
			$search_str .= "</div>\n";
		}
	}
	$search_str .= "</div>\n";
//	if (!count($yougo_log)) { $search_str = ''; }
	if (!$log_exst) { $search_str = ''; }
	$new_form_link = "$script?newform=1";
	if ($req['login']) {
		$new_form_link .= "&amp;login=" . $req['login'];
	} elseif (req('login')) {
		$new_form_link .= "&amp;login=" . req('login');
	}
	if ($req['sort']) { $new_form_link .= "&amp;sort=" . $req['sort']; }
	$new_link_str = "<div><a href=\"$new_form_link\">新規作成</a></div>\n";

	// html表示開始
	foreach (array('index','other','menu','category','name','new') as $key) {
		$template[$key] = $skin;
	}
	$tmp = array();
	foreach ($template as $key=>$val) {
		if ($req['sort'] == $key) {
			if (file_exists('./tmpl/' . $val)) {
				$tmp = file('./tmpl/' . $val);
			}
		}
	}
	$tmpl = '';
	$tmpl = join("",$tmp);
	$tmpl = preg_replace('/[\s\S]*<body>\n?[\s]*/','',$tmpl);
	$tmpl = preg_replace('/<\/body>\s*<\/html>\s*$/','',$tmpl);
	$tmpl .= "</body>\n</html>\n";
	head();
	
	// 全体の枠表示
	if ($tmpl) {
		$headline = title();
		$ptn0 = '/<div[\s\S]*?[^-](color:[^;"]+)[\s\S]*?>[\s\S]*?!headline!/';
		if (preg_match($ptn0,$tmpl,$matched)) {
			$col = $matched[1];
			$ptn1 = '/([^-])color:[^;"]+/';
			$headline = preg_replace($ptn1,'$1' . $col,$headline);
		}
		$tmpl = str_replace('!headline!',$headline,$tmpl);
		$tmpl = str_replace('!menu!',$index,$tmpl);
		if ($preview_str) {
			$tmpl = str_replace('!preview!',$preview_str,$tmpl);
		} else {
			$tmpl = preg_replace('/<div id="preview"[\s\S]*?<\/div>?/','',$tmpl);
			$tmpl = preg_replace('/!preview!/','',$tmpl);
		}
		$tmpl = str_replace('!search!',$search_str,$tmpl);
		$tmpl = str_replace('!new_link!',$new_link_str . $mes,$tmpl);
		if ($form) {
			$tmpl = str_replace('!form!',$form,$tmpl);
		} else {
			$tmpl = preg_replace('/<div id="form"[\s\S]*?<\/div>?/','',$tmpl);
			$tmpl = preg_replace('/!form!/','',$tmpl);
		}
		if (preg_match('/(<div class="editview"[\s\S]*?>)[\s\S]*?!editview![\s\S]*?(<\/div>?)/',$tmpl,$matched)) {
			$pre = $matched[1];
			$cls = $matched[2];
			$editstrs = '';
			foreach ($editview_list as $list) {
				$editstrs .= $pre . $list . $cls;
			}
			$tmpl = preg_replace('/(<div class="editview"[\s\S]*?>)[\s\S]*?!editview![\s\S]*?(<\/div>?)/','!editview!',$tmpl);
			$tmpl = str_replace('!editview!',$editstrs,$tmpl);
		} else {
			$editstrs = '';
			foreach ($editview_list as $list) {
				$editstrs .= "<div>\n" . $list . "</div>\n";
			}
			$tmpl = str_replace('!editview!',$editstrs,$tmpl);
		}
		$tmpl = str_replace('!index!',$show_index,$tmpl);
		$tmpl = str_replace('!index1!',$index1,$tmpl);

		$tmpl = str_replace('!footer!',footer(),$tmpl);
		print $tmpl;
	} else {
		print title();
		print "<div style=\"margin:1em;width:1650px;\">\n";
		print "<div style=\"width:${rep_width}px;margin:1em 0.5em;border: 1px dotted #000000;padding:0.8em;float:right\">\n";
		print $preview_str;
		print "</div>\n";
		if (!req('noindex')) { print $index; }
		print $search_str;
		print $new_link_str;
		if ($mes) { print "<div style=\"color:crimson;\">" . $mes . "</div>\n"; }
		if (! req('noform')) { print $form; }
		if ($editview_str) {
			if ($amode && req('noform') == 'all') {
				print "<div style=\"width:${rep_width}px;margin:1em 0.5em 1em 0.5em;border: 1px dotted #000000;padding:0.8em;background-color:#eeffff\">\n";
			} else {
				print "<div style=\"width:${rep_width}px;margin:1em 0.5em 1em 0.5em;border: 1px dotted #000000;padding:0.8em\">\n";
			}
			print $editview_str;
			print "</div>\n";
		}
		print $show_index;
		if (! req('noindex') && $req['sort'] != 'index') {
			print "<div class=\"notprint\" style=\"text-align:center;width:${rep_width}px;\">$index1</div>";
		}
		print "</div>\n";
		print footer();
		print print_r($yougoamode,true);
	}
	$bbsdir = $datadir;
	$tmpdir = opendir($bbsdir);
	$sub_list = array();
	while ($dir = readdir($tmpdir)) {
		if (preg_match('/^\.{1,2}$/',$dir)) { continue; }
		if (is_dir($bbsdir . '/' . $dir) && preg_match('/^[0-9a-zA-Z]{8,10}$/',$dir)) {
			$sub_list[] = $dir;
		}
	}
	closedir($tmpdir);
	foreach ($sub_list as $sub) {
		$del_dir = $bbsdir . '/' . $sub;
		if (!is_dir($bbsdir . '/' . $sub)) { continue; }
		$subdir = opendir($bbsdir . '/' . $sub);
		$empty = 1;
		while ($file = readdir($subdir)) {
			if (preg_match('/^\.{1,2}$/',$file)) { continue; }
			$empty = 0;
			break;
		}
		closedir($subdir);
		$stat = stat($del_dir);
		$count = 0;
		$str = '';
		foreach (array('デバイス番号','inode 番号','inode プロテクトモード','リンク数','所有者のユーザー ID','所有者のグループ ID','デバイスの種類','バイト単位のサイズ','最終アクセス時間 ','最終修正時間 ','最終 inode 変更時間','ファイル IO のブロックサイズ','512 バイトのブロックの確保数') as $key) {
			$str .= $key . '=' . $stat[$count] . '<>';
			$count++;
		}
		if ($empty && is_dir($del_dir)) {rmdir($del_dir);}	// 空のディレクトリを削除
		if (!file_exists($del_dir . '.cgi')) {
			delete_dir($del_dir);
		}
	}
}


function read_logs() {
	global $datadir, $yougo_log, $yougo_, $yougoid, $yougonm, $yougotm, $yougoamode, $yougoip, $category_list,$req,$cat_;
	$log_list = array();
	$yougo_log = array();
	$yougoid = array();
	$yougonm = array();
	$yougotm = array();
	$yougoamode = array();
	foreach(glob($datadir . '/*.cgi') as $file){
		if(is_file($file)){
			$log_list[] = $file;
			list($line) = file($file,FILE_IGNORE_NEW_LINES);
			$yougo_log[] = $line;
			$tmp = explode('<>',$line);
			$tmp2 = explode('<||>',$tmp[2]);
			if (isset($tmp2[1])) {
				$c = $tmp2[1];
			} else {
				$c = '';
			}
			if (isset($tmp[0])) {
				$yougo_[$tmp[0]] = $tmp[2];
				if (isset($tmp[3])) {
					$tmp[3] = str_replace('　',' ',$tmp[3]);
					if (preg_match('/\s+/',$tmp[3])) {
						$cats = preg_split('/\s+/',$tmp[3]);
						foreach ($cats as $cat) {
							if ($cat) { $category_list[] = $cat; }
						}
					} else {
						if ($tmp[3]) { $category_list[] = $tmp[3]; }
					}
				}
				$yougoid[$tmp[0]] = $tmp[0];
				$yougonm[$tmp[0]] = $tmp[2];
				$cat_[$tmp[0]] = $tmp[3];
				$tmp[1] = date2("Y/m/d H:i:s",$tmp[1]);
				$yougotm[$tmp[0]] = $tmp[1];
				$yougoip[$tmp[0]] = $tmp[5];
				if (isset($tmp[7])) { $yougoamode[$tmp[0]] = $tmp[7]; } else { $yougoamode[$tmp[0]] = ''; }
			}
		}
	}
	if ($req['sort'] == 'new' || $req['sort'] == 'other') {
		$sort = array();
		foreach ($yougo_log as $line) {
			$tmp = explode('<>',$line);
			if (isset($tmp[1])) { $sort[] = $tmp[1]; }
		}
		array_multisort($sort, SORT_ASC,SORT_NUMERIC,$yougo_log);
	}
	$category_list = array_unique($category_list);
	sort($category_list);
}



function make_list() {
	global $listdir,$yougo_log, $yougo_, $cat_,$yougoid, $yougonm, $yougotm, $yougoamode, $yougoip, $category_list,$tm_sort_list,$name_sort_list,$category_sort_list;
	time_check('ソートリスト作成開始');
	$category_list = array();
	$category_belong = array();
	if (isset($yougo_log)) {
		$tm_sort_list = array();
		asort($yougotm);
		foreach ($yougotm as $key=>$val) {
			$tmp = explode('<||>',$yougo_[$key]);
			$comment = $tmp[0];
			$cat = $cat_[$key];
			if ($cat) {
				if (strpos($cat,'&&') !== false) {
					$tmp = explode('&&',$cat);
					foreach ($tmp as $_) {
						$category_list[] = $_;
					}
				} else {
					$category_list[] = $cat;
				}
			}
//			if (isset($)) {
//			
//			} else {
//				
//			}
			$tm_sort_list[] = $key . "<>$val<>" . $yougonm[$key] . "<>$cat<>" . $yougoamode[$key] . "<>\n";
		}
		file_put_contents(join('/',array($listdir,'tm_sort_list.cgi')),$tm_sort_list,LOCK_EX);
		$name_sort_list = array();
		asort($yougonm);
		foreach ($yougonm as $key=>$val) {
			$tmp = explode('<||>',$yougo_[$key]);
			$comment = $tmp[0];
			$cat = $cat_[$key];
			if (isset($cat)) {
				if (strpos($cat,'&&') !== false) {
					$tmp = explode('&&',$cat);
					foreach ($tmp as $_) {
						$category_list[] = $_;
						if (! isset($category_belong[$_])) { $category_belong[$_] = 0; }
						$category_belong[$_]++;
					}
				} else {
					$category_list[] = $cat;
					if (! isset($category_belong[$cat])) { $category_belong[$cat] = 0; }
					$category_belong[$cat]++;
				}
			}
			$name_sort_list[] = $key . "<>" . $yougotm[$key] . "<>" . $yougonm[$key] . "<>$cat<>" . $yougoamode[$key] . "\n";
		}
		file_put_contents(join('/',array($listdir,'name_sort_list.cgi')),$name_sort_list,LOCK_EX);
		$category_list = array_unique($category_list);
		sort($category_list);
		$category_list = array_filter($category_list,"strlen");
		$cat_belong = array();
		foreach ($category_list as $cat) {
			$cat_belong[] = $cat . '<|>' . $category_belong[$cat];
		}
		if ($cat_belong) { file_put_contents(join('/',array($listdir,'category_list.cgi')),join("<>",$cat_belong),LOCK_EX); }
		$sort = array();
		$category_sort_list = $name_sort_list;
		foreach ($category_sort_list as $_) {
			$tmp = explode('<>',$_);
			if (isset($tmp[3])) {
				list($cat) = explode('&&',$tmp[3]);
				$sort[] = $cat;
			}
		}
		array_multisort($sort, SORT_ASC,SORT_STRING,$category_sort_list);
		file_put_contents(join('/',array($listdir,'category_sort_list.cgi')),$category_sort_list,LOCK_EX);
	} else {
		$yougo_log = array();
	}
	time_check('ソートリスト作成終了');
}


function to_old_format($new_list) {
	global $yougo,$yougoid;
	time_check('フォーマット変換開始');
	$old_list = array();
	foreach ($new_list as $line) {
		$tmp = explode('<>',$line);
		if (isset($tmp[0])) { $id = $tmp[0]; } else { $id = ''; }
		if (isset($tmp[1])) { $tm = $tmp[1]; } else { $tm = ''; }
		if (isset($tmp[2])) { $name = $tmp[2]; } else { $name = ''; }
		if (isset($tmp[3])) { $category = $tmp[3]; } else { $category = ''; }
		if (isset($tmp[4])) { $comment = $tmp[4]; } else { $comment = ''; }
		if (isset($tmp[5])) { $ip = $tmp[5]; } else { $ip = ''; }
		if (strpos($name,'&&') !== false) {
			$names = explode('&&',$name);
			foreach ($names as $nm) {
				$yougo[$nm] = $comment;
				$yougoid[$nm] = $id;
			}
		} else {
			$yougo[$name] = $comment;
			$yougoid[$name] = $id;
		}
		$comment = rtrim($comment);
		$old_line = "$id<>$tm<>$name<>$category<>$comment<>$ip\n";
		$old_list[] = $old_line;
	}
	time_check('フォーマット変換終了');
	return $old_list;
}



function post() {
	global $datadir,$yougo_log,$img_ext,$new_id,$tag_list,$perm_tag_list,$post_mode,$edited_id,$crypt_pass;
	
	if (!req('name')) {
		error('タイトルを入力してください。');
	}
	if (!req('comment')) {
		error('コメントを入力してください。');
	} else {
		$comment = req('comment');
	}
	if (get_magic_quotes_gpc()) {
		$comment = stripslashes($comment);
	}
	
	// <pre>タグ内のタグは有効化しないことにする
	$ptn = '|(<pre[^>]*?>)([\s\S]*?)(<\/pre>)|';
	$pre = array();
	$count = 0;
	while (preg_match($ptn,$comment,$matched)) {
		$comment = preg_replace($ptn,'[pre' . $count . ']',$comment,1);
		$matched[2] = str_replace('<','&lt;',$matched[2]);
		$matched[2] = str_replace('>','&gt;',$matched[2]);
		$matched[2] = str_replace('[','&#91;',$matched[2]);
		$matched[2] = str_replace(']','&#93;',$matched[2]);
		$pre[$count] = $matched[1] . $matched[2] . $matched[3];
		$count++;
	}
	$comment = str_replace("<","&lt;",$comment);
	$comment = str_replace(">","&gt;",$comment);
	$comment = str_replace("&lt;|&gt;","<|>",$comment);
	if (!$post_mode) {
		$ptn = '/&lt;(\/?(' . join('|',$perm_tag_list) . ')(\s+.*?)?)&gt;?/';
		$ptn2 = '<$1>';
		$comment = preg_replace($ptn,$ptn2,$comment);	// 許可タグのみ戻した状態で保存する
	} else {
		$ptn = '/&lt;(\/?(' . join('|',$tag_list) . ')(\s+.*?)?)&gt;?/';
		$ptn2 = '<$1>';
		$comment = preg_replace($ptn,$ptn2,$comment);	// 許可タグのみ戻した状態で保存する
	}
	$comment = str_replace('&lt;!--','<!--',$comment);
	$comment = str_replace('--&gt;','-->',$comment);
	foreach ($pre as $key=>$val) {
		$comment = str_replace('[pre' . $key . ']',$val,$comment);
	}
	$comment = str_replace("\r\n","\n",$comment);
	$comment = str_replace("\r","\n",$comment);
	if (req('trans_br')) {
		// 閉じタグ後以外の\nのみ変換することにする
		$comment = str_replace(">\n",">/n/",$comment);
		$comment = str_replace("]]\n","]]/n/",$comment);
		$comment = str_replace("\n","<br />",$comment);
	} else {
		$comment = str_replace("\n","/n/",$comment);
	}
	$category = category_list(req('category'));
	$new_id = random_str(16);
	if (is_dir($datadir . '/' . $new_id)) {
		$new_id = random_str(16);	// 万一同名のディレクトリが存在したら、もう一度$id取得
	}
	$edited_id = $new_id;
	// $line は新規投稿された記事のデータ
	if (req('lockpass')) {
		$lock = encrypt(req('lockpass'));
	} else {
		$lock = '';
	}
	if (! $post_mode && !$lock) {
		$lock = $crypt_pass;
	}
	if (! $post_mode) {
		$amode = req('admin_mode');
	} else {
		$amode = '';
	}
	$line = join('<>',array($new_id, time_str(),req('name'),$category,$comment,$_SERVER['SERVER_NAME'],$lock,$amode)) . "\n";
	// 以下は投稿済みの記事の編集
	$id_path = $datadir . '/' . req('edit') . '.cgi';
	$edit_ok = 1;
	if (req('edit')) {
		$edited_id = req('edit');
		if (!file_exists($datadir . '/' . req('edit'))) {
			mkdir($datadir . '/' . req('edit'));
		}
		list($line) = file($id_path,FILE_IGNORE_NEW_LINES);
		$tmp = explode('<>',$line);
		list($id_,$tm,$name,$cat,$com,$ip,$lock) = $tmp;
		if (isset($tmp[7])) {
			$amode = $tmp[7];
		} else {
			$amode = '';
		}
		//if (req('admin_mode')) {
			$amode = req('admin_mode');
		//}
		if ($lock && $post_mode) {
			if (!req('lockpass')) {
				$edit_ok = 0;
				$alart = 'ロック解除パスワードを入力して下さい';
				error('ロック解除パスワードを入力して下さい');
			} elseif (decrypt(req('lockpass'),$lock) != 'yes' && decrypt(req('lockpass'),$crypt_pass) != 'yes') {
				$edit_ok = 0;
				$alart = 'ロック解除パスワードが一致しません';
				error('ロック解除パスワードが一致しません');
			}
		} else {
			if (req('lockpass')) {
				$lock = encrypt(req('lockpass'));
			}
		}
		if ($edit_ok) {
			if (req('update_time')) {
				$tm = time_str('');
			} else {
				$tm = date2("Y/m/d H:i:s",$tm);
				$tm = new DateTime($tm);
				$tm->modify('+10 seconds');
				$tm = date_format($tm,"Y/m/d H:i:s");
			}
			if (! $post_mode && !$lock) { $lock = $crypt_pass; }
			//$lock = req('lock');
			// 部分編集モードなら
			if (req('part') != '') {
				list($com) = explode('<||>',$com);
				$tmp = explode('<|>',$com);
				$nmb = 0;
				foreach ($tmp as $str) {
					if ($nmb == req('part')) {
						$tmp[$nmb] = $comment;
					}
					$nmb++;
				}
				$comment = join('<|>',$tmp);
			}
			$top = join('<>',array($id_, date2("Y/m/d H:i:s",$tm),req('name'),$category,$comment,$_SERVER['SERVER_NAME'],$lock,$amode)) . "\n";
			$id = $id_;
			if (file_exists($id_path)) { save_history($id_path); }
			file_put_contents($id_path,$top,LOCK_EX);
		}
	} else {
		$id_path = $datadir . '/' . $new_id . '.cgi';
		if (file_exists($id_path)) { save_history($id_path); }
		file_put_contents($id_path,$line, LOCK_EX);
	}
	// 更新時間記録
	list($dm,$tm) = explode('<>',$line);
	$wtime = new DateTime($tm);
	$last_path = './last_write_time.cgi';
	if (file_exists($last_path)) { list($time_str) = file($last_path); } else { $time_str = '1970/01/01 00:00:00'; }
	$ltime = new DateTime($time_str);
	if ($wtime > $ltime) { file_put_contents($last_path,$tm,LOCK_EX);touch($last_path, strtotime($tm)); }
	// 更新時間記録終了
	if ($_FILES['img']["error"] == UPLOAD_ERR_OK) {
		$tmp_name = $_FILES['img']["tmp_name"];
		if (!isset($id) && isset($new_id)) {
			$id = $new_id;
		}
		$t_name = $_FILES['img']["name"];	// とりあえず元のファイル名から拡張子を取るだけ
		$ext = pathinfo($t_name, PATHINFO_EXTENSION);
		$up_path = preg_replace('/\.html$/','.' . $ext,req('file'));
		if (! file_exists($datadir . '/' . $id)) {
			mkdir($datadir . '/' . $id);
		}
		for ($nmb=1; $nmb<100; $nmb++) {
			$up_path = $datadir . '/' . $id . '/' . $nmb . '.' . $ext;
			if ( ! file_exists($up_path) ) {
				move_uploaded_file($tmp_name, $up_path);
				$onfile = $up_path . '.oname';
				file_put_contents($onfile,$t_name,LOCK_EX);
				if (in_array($ext,$img_ext)) {
					thumb($up_path,'100');
				}
				break;
			}
		}
	}
	return($new_id);
}


function save_history($path) {
	global $max_history;
	$dir = preg_replace('/\.cgi$/','',$path);
	if (!is_dir($dir)) { mkdir($dir); }
	$back_path = join('/',array($dir,filemtime($path) . '.cgi'));
	copy($path,$back_path);
	
	// 古い履歴ファイルは削除
	$bckdir = opendir($dir);
	$bck_list = array();
	while ($file = readdir($bckdir)) {
		if (preg_match('/^\d{10}\.cgi$/',$file)) {
			$bck_list[] = $file;
		}
	}
	closedir($bckdir);
	rsort($bck_list);
	$del_list = array_splice($bck_list,$max_history);
	foreach ($del_list as $del) {
		if (file_exists($dir . '/' . $del)) {
			unlink($dir . '/' . $del);
		}
	}
}


function cssmemo() {
	head();
	$css = array (
	'画像に影'=>'box-shadow: 1px 1px 5px #000;',
	'画像に影2<>mozilla、webkit対応' => '-moz-box-shadow: 2px 2px 3px 3px #CCC;-webkit-box-shadow: 2px 2px 3px 3px #CCC;box-shadow: 2px 2px 3px 3px #CCC;',
	'画像に影3' => 'margin-top: 5px; /* 画像の上の余白*/ display: inline-block;  box-shadow: 0px 5px 15px -5px rgba(0, 0, 0, 0.8);',
	'点線で囲む' => 'border: 1px dotted #000000;',
	'ダッシュで囲む' => 'border: 1px dashed #000000;',
	);
	print "<table cellpadding=\"5\" border=\"0\">\n";
	foreach ($css as $key=>$val) {
		$tmp = explode('<>',$key);
		print "<tr><td>$tmp[0]";
		if (isset($tmp[1])) {
			print "<br />" . $tmp[1];
		}
		print "</td><td><img src=\"./img/test.png\" style=\"width:75px;$val\" /></td><td><input type=\"text\" value=\"$val\" style=\"width:500px;\" /></td></tr>\n";
	}
	print "</table>";
	print "<div>\n";
	print "<div>class指定時の見栄えの変化</div>\n";
	$base = "<div <!class!>>class指定による見栄えの変化</div>\n次の行";
	$non = str_replace('<!class!>','',$base);
	print "指定なし";
	print $non;
	print "<br /><br />\n";
	$css = file('./style.css');
	foreach ($css as $_) {
		if (preg_match('/^\s*?\.(.+?)\s/',$_,$match)) {
			$cls = $match[1];
			$tmp = str_replace('<!class!>','class="' . $cls . '" ',$base);
			print "<div>----------------------------------------------------------------------</div>\n";
			print "class=\"" . $cls . "\"";
			print $tmp;
			print "<br />\n";
		}
	}
	print "</div>\n";
	print "</body>\n</html>\n";
	exit;
}


function category_list($category) {
	$cat = req('category');
	$nmb = 1;
	$cat_list = array();
	while (req('category_' . $nmb)) {
		$cat_list[] = req('category_' . $nmb);
		$nmb++;
	}
	$cat_list_str = join('&&',$cat_list);
	if (req('last_category')) {
		if ($cat && $cat != req('last_category')) {
			$category = $cat;
		} elseif ($cat_list_str && $cat_list_str != req('last_category')) {
			$category = $cat_list_str;
		}
	} else {
		if ($cat) {
			$category = $cat;
		} elseif ($cat_list_str) {
			$category = $cat_list_str;
		}
	}
	return $category;
}


function attestation() {
	global $script,$crypt_pass,$cookietime,$req,$skin;
	
	dispos_login_file();
	$alert = '';
	if (req('login')) {
		if (file_exists('./login/' . req('login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi')) {
			file_put_contents('./login/' . req('login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi','1',FILE_APPEND | LOCK_EX);
			return;
		} else {
			if (req('newform') || req('edit') || req('bbs_preview') || req('post')) {
				$alert = '有効期限が過ぎました。再度ログインしてください';
			}
		}
	}
	if (! req('pass') || req('logout')) {
		txt("req('login')=" . req('login'));
		if (isset($_COOKIE['admin_pass'])) {
			$c_pass = $_COOKIE['admin_pass'];
		} else {
			$c_pass = '';
		}
		if (req('logout')) {
			setcookie("cpass", '', time() - 60);
		}
		$tmp = file('./tmpl/' . $skin);
		$tmpl = join("",$tmp);
		$tmpl = preg_replace('/[\s\S]*<body>\n?[\s]*/','',$tmpl);
		head();
		$headline = title();
		$ptn0 = '/<div[\s\S]*?[^-](color:[^;"]+)[\s\S]*?>[\s\S]*?!headline!/';
		if (preg_match($ptn0,$tmpl,$matched)) {
			$col = $matched[1];
			$ptn1 = '/([^-])color:[^;"]+/';
			$headline = preg_replace($ptn1,'$1' . $col,$headline);
//			if (preg_match('/[^-]color:[^;"]+/',$headline,$matched)) {
//			}
		}
		$menu = '';
		$menu .= $alert;
		$menu .= "<div style=\"text-align:center;margin:1em\">\n";
		if (req('logout')) { $menu .= "ログアウトしました。"; }
		$menu .= "<form action=\"$script\" method=\"post\">\n";
		foreach (array('newform','sort','edit','page','keyword','hide_thum','category_filter') as $key) {
			if (req($key)) {
				$menu .= "<input type=\"hidden\" name=\"$key\" value=\"" . req($key) . "\" />\n";
			}
		}
		$menu .= "パスワード&nbsp;<input type=\"password\" name=\"pass\" value=\"$c_pass\" style=\"width:120px;\" />\n";
		$menu .= "<input type=\"submit\" value=\"ログイン\" />\n";
		$menu .= "<input type=\"submit\" name=\"logout\" value=\"ログアウト\" />\n";
		$menu .= "</form></div>\n";
		$tmpl = str_replace('!headline!',$headline,$tmpl);
		$tmpl = preg_replace('/(<!-- メインカラム開始 -->)[\s\S]*(<!-- メインカラム終了 -->)/','$1' . "\n<div class=\"content\" style=\"margin-bottom:1em;\">\n$menu\n</div>\n" . '$2',$tmpl);
		$tmpl = str_replace('!menu!','',$tmpl);
		$tmpl = preg_replace('/<div id="preview"[\s\S]*?<\/div>?/','',$tmpl);
		$tmpl = preg_replace('/!preview!/','',$tmpl);
		$tmpl = preg_replace('/<div id="form"[\s\S]*?<\/div>?/','',$tmpl);
		$tmpl = preg_replace('/!form!/','',$tmpl);
		$tmpl = str_replace('!search!','',$tmpl);
		$tmpl = str_replace('!index!','',$tmpl);
		$tmpl = str_replace('!new_link!','',$tmpl);
		$tmpl = preg_replace('/(<div class="editview"[\s\S]*?>)[\s\S]*?!editview![\s\S]*?(<\/div>?)/','',$tmpl);
		$tmpl = str_replace('!footer!',footer(),$tmpl);
		print $tmpl;
		exit();
	}
	if (decrypt(req('pass'), $crypt_pass) === 'no') {
		error("パスワードが認証できません");
	} else {
		if (! file_exists('./login')) { mkdir('./login'); }
		$login_id = random_str(16);
		$req['login'] = $login_id;
		file_put_contents(join('/',array('./login', $login_id . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
		// クッキーの場合、エポック時間はどうなるのか？
		setcookie("admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
		setcookie("cpass", req('pass'), time() + 3600*24);		// アクセス権限を管理者レベルにするためのクッキー
	}
}


function show_form($id,$tm,$comment,$name,$ip,$category,$lock = '',$amode='') {
	global $script,$access_level,$color_list,$category_list,$rep_width,$datadir,$tag_list,$perm_tag_list,$req,$post_mode,$crypt_pass,$cookietime,$req;

	if ($post_mode == 0) { attestation(); }
	if (!isset($category)) { $category = ''; }
	$i = 1;
	$test = 0;
	$category_tmp = array();
	foreach ($_REQUEST as $key=>$val) {
		if (preg_match('/category_(\d+$)/',$key,$match)) { $category_tmp[] = $_REQUEST[$key]; }
	}
	// このあたりはもう少し整理が必要
	$category_str = join('&&',$category_tmp);
	if (req('category')) { $category = req('category'); }
	if (req('last_category') && $category != req('last_category')) {
		$test = 1;
	} elseif ($category_str && !req('last_category') || (req('last_category') && $category_str != req('last_category'))) {
		$category = $category_str;
		$test = 2;
	}
	$form = '<div style="clear:both;margin:6px;">';
	$form .= "\n<form action=\"$script\" method=\"post\" enctype=\"multipart/form-data\">\n";
	if (isset($req['login']) && $req['login']) {
		$form .= "<input type=\"hidden\" name=\"login\" value=\"" . $req['login'] . "\" />\n";
	}
	if (req('keyword')) { $form .= "<input type=\"hidden\" name=\"keyword\" value=\"" . req('keyword') . "\" />\n"; }
	if (!$lock && req('cryptlockpass')) { $lock = req('cryptlockpass'); }
	if ($lock) { $form .= "<input type=\"hidden\" name=\"cryptlockpass\" value=\"$lock\" />\n"; }
	if (!req('delete')) {
		if (req('edit')) {
			$form .= "<input type=\"hidden\" name=\"edit\" value=\"" . req('edit') . "\" />\n";
		} elseif ($id) {
			$form .= "<input type=\"hidden\" name=\"edit\" value=\"" . $id . "\" />\n";
		}
	}
	if (req('page')) { $form .= "<input type=\"hidden\" name=\"page\" value=\"" . req('page') . "\" />\n"; }
	if (req('category_filter')) { $form .= "<input type=\"hidden\" name=\"category_filter\" value=\"" . req('category_filter') . "\" />\n"; }
	if (req('part') != '') { $form .= "<input type=\"hidden\" name=\"part\" value=\"" . req('part') . "\" />\n"; }
	if ($req['sort'] != '') { $form .= "<input type=\"hidden\" name=\"sort\" value=\"" . $req['sort'] . "\" />\n"; }
	if ($category) { $form .= "<input type=\"hidden\" name=\"last_category\" value=\"" . str_replace('　',' ',$category) . "\" />\n"; }
	$form .= "<table border=\"0\" cellpadding=\"4\" summary=\"投稿フォーム\">\n";
	$form .= "<tr><td style=\"vertical-align:top;\"><input type=\"submit\" value=\"投　稿\" name=\"post\" /></td><td><input type=\"submit\" name=\"bbs_preview\" value=\"プレビュー\" style=\"margin-bottom:0.5em\" />";
	if ((!req('post') && !req('bbs_preview')) || req('trans_br')) {
		$tras_br_chk = ' checked';
	} else {
		$tras_br_chk = '';
	}
	$check_form = "<input$tras_br_chk type=\"checkbox\" name=\"trans_br\" value=\"1\" id=\"nline\" /><label for=\"nline\">改行を&lt;br /&gt;に変換する</label>";
	if (file_exists($datadir . '/' . $id . '.cgi')) {
		if ((!req('post') && !req('bbs_preview')) || req('update_time')) {
			$update_time_chk = ' checked';
		} else {
			$update_time_chk = '';
		}
		$check_form .= "&nbsp;&nbsp;&nbsp;<input$update_time_chk type=\"checkbox\" name=\"update_time\" value=\"1\" id=\"update_time\" /><label for=\"update_time\">タイムスタンプを更新する</label>";
	}
	if ($post_mode) {
		if ($lock) {
			$lock_chk = " placeholder=\"要パスワード\"";
			$lockstr = "&nbsp;で解除";
		} else {
			$lock_chk = '';
			$lockstr = "&nbsp;でロック";
		}
		$check_form .= "&nbsp;&nbsp;&nbsp;<span style=\"white-space:nowrap;font-size:80%;\" title=\"ここにパスワードを入力するとロックされます\">編集パスワード</span>&nbsp;
		<input type=\"text\" name=\"lockpass\" size=\"10\" style=\"width:100px;\"$lock_chk value=\"\" />$lockstr";
	} else {
		$checked = '';
		if ($amode) { $checked = ' checked'; }
		$check_form .= "&nbsp;&nbsp;&nbsp;<input type=\"checkbox\"$checked name=\"admin_mode\" value=\"1\" id=\"admin_mode\" /><label for=\"admin_mode\">管理者用</label>";
	}
	if ($access_level == 4) {
		$checked = '';
		if ((isset($amode) && $amode) || req('admin_mode')) { $checked = ' checked'; }
		$check_form .= "&nbsp;&nbsp;&nbsp;<input$checked type=\"checkbox\" name=\"admin_mode\" value=\"1\" />管理者モード&nbsp;&nbsp;&nbsp;";
	}
	//$check_form .= "<br /><span style=\"font-size:90%;\">※部分編集する場合は、分割する場所に\"&lt;|&gt;\"を挿入してください</span>&nbsp;<a href=\"$script?cssmemo=1\" target=\"_blank\">CSSメモ</a>";
	$check_form .= " <a href=\"$script?cssmemo=1\" target=\"_blank\">CSSメモ</a>";
	sort($perm_tag_list);
	if (!$post_mode) {
		$check_form .= "&nbsp;&nbsp;<a title=\"&lt;" . join('&gt;&lt;',$perm_tag_list) . "&gt;\">使用可能なタグ</a>\n";
	} else {
		$check_form .= "&nbsp;&nbsp;<a title=\"&lt;" . join('&gt;&lt;',$tag_list) . "&gt;\">使用可能なタグ</a>\n";
	}
	$form .= "</td>";
	if (req('edit')) {
		$form .= "<td style=\"text-align:right;vertical-align:top;\"><input type=\"submit\" name=\"delete\" value=\"削除する\" /></td></tr>\n";
	} else {
		$form .= "<td>&nbsp;</td></tr>\n";
	}
	if (req('name') && req('name') != $name && ! req('delete')) {
		$name = req('name');
	}
	if (req('delete')) {
		$category = '';
	}
	$form .= "<tr><td colspan=\"3\">$check_form</td></tr>\n";
	$ttitle = "別名を指定したい場合は「&&」で区切って入力してください。
記事のタイトルとして表示されるのは1番目の名称となります。
別名に対しても他記事からリンクが貼られます。";
	$form .= "<tr><td style=\"text-align:right;\"><span title=\"$ttitle\">タイトル</span></td><td colspan=\"2\"><input type=\"text\" name=\"name\" value=\"$name\" style=\"width:160px\" />&nbsp;&nbsp;<a title=\"複数のカテゴリーを指定する場合はスペースで区切ってください\">カテゴリー</a><input type=\"text\" name=\"category\" value=\"$category\" style=\"width:120px\" />&nbsp;\n";

	// $category_list 登録されているすべてのカテゴリーのリスト
	// $categorys 編集対象記事に指定されているカテゴリーのリスト
	if ($category_list) {
		$category = category_list($category);
		$categorys = explode('&&',$category);
		$category_nmb = 0;
		if (req('delete')) {
			$categorys = array('');
			$cat = '';
		}
		foreach ($categorys as $category) {
			$category_nmb++;
			$i = 0;
			$sel_col = '';
			foreach ($category_list as $cat) {
				if ($cat == $category) {
					$sel_col = " style=\"background-color:" . $color_list[$i % count($color_list)] . ";color:" . text_color($color_list[$i % count($color_list)]) . ";\"";
				}
				$i++;
			}
			$form .= "<select name=\"category_$category_nmb\"$sel_col>\n";
			$form .= "<option value=\"\"></option>\n";
			$i = 0;
			foreach ($category_list as $cat) {
				if ($cat == $category || $cat == req('category_' . $category_nmb)) {
					$form .= "<option selected=\"selected\" value=\"$cat\" style=\"background-color:" . $color_list[$i % count($color_list)] . ";color:" . text_color($color_list[$i % count($color_list)]) . ";\">$cat</option>\n";
				} else {
					$form .= "<option value=\"$cat\" style=\"background-color:" . $color_list[$i % count($color_list)] . ";color:" . text_color($color_list[$i % count($color_list)]) . ";\">$cat</option>\n";
				}
				$i++;
			}
			$form .= "</select>\n";
		}
	}
	$form .= "</td></tr>\n";
	if (req('part') != '' && strpos($comment,'<|>') !== false) {
		$tmp2 = explode('<||>',$comment);
		$comment = $tmp2[0];
		if (isset($tmp2[1])) {
			$category = $tmp2[1];
		} else {
			$category = '';
		}
		$nmb = req('part');
		$tmp = explode('<|>',$comment);
		$comment = $tmp[$nmb];	
	}
	if ($comment) {
		$rows = substr_count($comment,"\n");
		if ($rows < 7) { $rows = 7; }
		if ($rows > 30) { $rows = 30; }
	} else { $rows = 7; }
	$comment = preg_replace('/&(\w{2,4};?)/','&amp;$1',$comment);
	$form .= "<tr><td style=\"text-align:right;vertical-align:top;\"><span title=\"※部分編集する場合は、分割する場所に「&lt;|&gt;」を挿入してください\">コメント</span></td><td colspan=\"2\"><textarea name=\"comment\" cols=\"80\" rows=\"$rows\" style=\"width:" . intval($rep_width * 0.9) . "px;line-height:140%\">$comment</textarea></td></tr>\n";
	$form .= "<tr><td style=\"text-align:right;vertical-align:top;\"><span style=\"white-space:nowrap;\">添付ファイル</span><br /><span style=\"font-size:80%;\">(500MBまで)</span>";
	if (! req('hide_thum')) { $checked = ''; } else { $checked = ' checked'; }
	$form .= "<br /><input$checked id=\"HIDE_THUM\" type=\"checkbox\" name=\"hide_thum\" value=\"1\" /><label for=\"HIDE_THUM\"><span style=\"font-size:80%\">サムネールを隠す</span></label>";
	$form .= "</td>";
	$imgs = '';
	if ($id) {
		if (req('lock')) { attestation(); }
		if (is_dir($datadir . '/' . $id)) {
			$tmpdir = opendir($datadir . '/' . $id);
			$col = 0;
			$mtime = array();
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^\d+\./',$file)) {
					if (preg_match('/(oname|count)$/',$file) || preg_match('/^\d{10}/',$file)) { continue; }
					$mtime[$file] = filemtime($datadir . '/' . $id . '/' . $file);	// filemtimeはエポック以外で取得が難しいな。
				}
			}
			closedir($tmpdir);
			arsort($mtime);
			foreach(array_keys($mtime) as $file) {
				$image_info = getimagesize($datadir . '/' . $id . '/' . $file);
				$thumb_path = $datadir . '/' . $id . '/' . preg_replace('/(\..{2,4}$)/','thumb$1',$file);
				$download = 0;
				$org = '';
				if (!file_exists($thumb_path)) {
					$thumb_path = './img/clip.gif';
					$oname = $datadir . '/' . $id . '/' . $file . '.oname';
					$org = $file;
					if (file_exists($oname)) { list($org) = file($oname); }
					$sjis_org = mb_convert_encoding($org,'SJIS','UTF-8');
					$val = "&lt;a href=&quot;$script?mode=download&amp;amp;file=" . $datadir . "/" . $id . "/$file&amp;name=" . urlencode($sjis_org) . "&quot;&gt;$org&lt;/a&gt;";
					$countpath = $datadir . '/' . $id . '/' . $file . '.count';
					if (file_exists($countpath)) {
						$download = filesize($countpath);
					}
				} else {
					$show_width = intval($rep_width * 0.95);
					if ($show_width > $image_info[0]) { $show_width = $image_info[0]; }
					if (!file_exists('./lib/cmanImgPop.js')) {
						$val = "&lt;img src=&quot;" . $datadir . "/" . $id . "/$file&quot; width=&quot;" . $show_width . "&quot; alt=&quot;$file&quot; title=&quot;$file&quot; /&gt;";
					} else {
						$val = "&lt;img src=&quot;" . $datadir . "/" . $id . "/$file&quot; width=&quot;" . $show_width . "&quot; alt=&quot;$file&quot; title=&quot;$file&quot; onclick=&quot;cmanImgPop(this,'')&quot; /&gt;";
					}
					$val = "&lt;div style=&quot;margin:0.5em;&quot;&gt;" . $val . "&lt;/div&gt;";
				}
				if (!($col % 5)) { $imgs .= "</tr>\n<tr>"; }
				$tmp_wid = strlen($val) * 4;
				if ($tmp_wid . 800) { $tmp_wid = 800; }
				$imgs .= "<td style=\"vertical-align:top;\"><input type=\"text\" value=\"$val\" size=\"" . 30 . "\" style=\"font-size:75%;width:130px;\" /><br />
				<a href=\"$script?edit=" . $id . "&amp;del_img=" . $id . '/' . $file . "&amp;hide_thum=" . req('hide_thum') . "\">削除</a>";
				if (! req('hide_thum')) {
					$imgs .= "<br /><a href=\"" . $datadir . "/" . $id . "/$file\" target=\"_blank\"><img border=\"0\" src=\"" . $thumb_path . "\" alt=\"$file\n$org\" title=\"$file\n$org\" align=\"top\" /></a>";
				} else {
					$imgs .= "&nbsp;<a href=\"" . $datadir . "/" . $id . "/$file\" target=\"_blank\">$file</a>";
				}
				if ($download > 0) { $imgs .= "&nbsp;" . $download . "Download"; }
				$imgs .= "</td>";
				$col++;
			}
			if ($imgs) { $imgs = "<table summary=\"添付ファイル\"><tr>$imgs</tr></table>\n"; }
		}
	}
	if ($imgs) { $imgs .= "<br />\n"; }
	$form .= "<td colspan=\"2\">$imgs<input type=\"file\" name=\"img\" value=\"" . req('file') . "\" /></td></tr>\n";
	$form .= "</table>\n";
	$form .= "</form>\n</div>\n";
	return $form;
}


function show_index() {
	global $yougo_log,$script,$rep_width,$new_id,$show_new,$new_day,$req,$dt,$index_max,$yougoid,$amode_list,$current_back_color,$admin_back_color;
	$last_ini = '';
	$ini_list = array();
	$link = array();
	if (is_array($yougoid)) { $id_name = array_flip($yougoid); }
	$select_name = '';
	if (isset($id_name[req('noform')])) { $select_name = $id_name[req('noform')]; }
	foreach ($yougo_log as $val) {
		$tmp = explode('<>',$val);
		$name = $tmp[2];
		$names = array();
		if (strpos($name,'&&') !== false) {
			$names = explode('&&',$name);
		}
		if (! $names) {
			$names = array($name);
		}
		// 別名もメニューに表示するようにした
		foreach ($names as $name) {
			if (preg_match("/^[a-zA-Z]/", $name)) {
				$ini = strtoupper(mb_substr($name,0,1));
			} else if (preg_match("/^\d/", $name)) {
				$ini = mb_substr($name,0,1);
				$ini = '数';
			} else if (preg_match("/^[ぁ-ゞ]/u", $name,$matched)) {
			    $ini = mb_substr($name,0,1,"utf-8");
			    // カタカナに変換する場合は以下を有効に
			    if (1) { $ini = mb_convert_kana($ini,"C","UTF-8"); }
			    $ini = mb_convert_kana($ini,"k","UTF-8");
			    $ini = mb_convert_kana($ini,"K","UTF-8");
			    $ini = mb_substr($ini,0,1,"utf-8");
			    //$ini = mb_convert_kana($ini,"c","UTF-8");
	//		    $ini = 'ひらがな';
			} else if (preg_match("/^[ァ-ヾ]/u", $name,$matched)) {
				$ini = mb_substr($name,0,1,"utf-8");
				// 濁点、半濁点を除去
				$ini = mb_convert_kana($ini,"k","UTF-8");
				$ini = mb_convert_kana($ini,"K","UTF-8");
				$ini = mb_substr($ini,0,1,"utf-8");
				//$ini = 'カタカナ';
			} else if (preg_match("/^[一-龠]/", $name)) {
				$ini = substr($name,0,2);
				$ini = mb_substr($name,0,1,"utf-8");
				$ini = '漢';
			} else {
				$ini = mb_substr($name,0,1) . '-';
			}
			if (req('ini') && req('ini') != $ini) {
				continue;
			}
			if ($ini != $last_ini) {
				$ini_list[] = $ini;
				$last_ini = $ini;
			}
			if (!isset($link[$ini])) {
				$link[$ini] = array();
			}
			$new = '';
			$tm = date2("Y/m/d H:i:s",$tmp[1]);
			$day = new DateTime($tm);
			$day->modify('+' . $new_day . ' days');
			if ($show_new && $day > $dt) {
				$new = "<span style=\"color:crimson;font-size:80%\">new</span>";
			}
			$url = $script . "?mode=" . req('mode') . "&amp;noform=" . $tmp[0] . "&amp;sort=index";
			foreach (array('keyword','category_filter','ini') as $key) {
				if (req($key)) {
					$url .= "&amp;$key=" . urlencode(req($key));
				}
			}
			if (isset($req['login']) && $req['login']) {
				$url .= "&amp;login=" . $req['login'];
			}
			$short_name = $name;
			$pup = '';
			if (strlen($short_name) > 30) {
				$dot = '';
				if (strlen($short_name) > strlen(jtruncate($short_name,30))) {
					$dot = '...';
				}
				$short_name = jtruncate($name,30) . $dot;
				$pup = jtruncate($name,100);
			}
			if (req('noform') == $tmp[0]) {
				$link[$ini][]= "<span style=\"background-color:$current_back_color;white-space:nowrap;\">$new<a href=\"$url\" title=\"$pup\">" . $short_name . "</a></span>&nbsp;\n";
			} elseif (req('edit') == $tmp[0] || (req('post') && $new_id == $tmp[0])) {
				$link[$ini][] = "<span style=\"background-color:#ffeeff;white-space:nowrap;\">$new<a href=\"$url\" title=\"$pup\">" . $short_name . "</a></span>&nbsp;\n";
			} elseif (isset($amode_list[$tmp[0]]) && $amode_list[$tmp[0]]) {
				$link[$ini][] = "<span style=\"background-color:$admin_back_color;white-space:nowrap;\">$new<a href=\"$url\" title=\"$pup\">" . $short_name . "</a></span>&nbsp;\n";
			} else {
				$link[$ini][] = "<span style=\"white-space:nowrap;\">$new<a href=\"$url\" title=\"$pup\">" . $short_name . "</a>&nbsp;</span>\n";
			}
			$name_list[$ini][] = $name;
		}
	}
	$ini_list = array_unique($ini_list);
	
	// かなりださいことをやっているが...
	$new_ini_list = array();
	foreach ($ini_list as $ini) {
		if ($ini == '数') { $ini = '123'; }
		$new_ini_list[] = $ini;
	}
	$ini_list = $new_ini_list;
	sort($ini_list);
	$show_index = "<div>\n";
	foreach ($ini_list as $ini) {
		if ($ini == '123') { $ini = '数'; }
		$INI = mb_convert_kana($ini, 'RN', 'UTF-8');
		//$show_index .= "<div style=\"width:800px\"><strong>[$INI]</strong>&nbsp;";
		$show_index .= "<div style=\"clear:both;padding:2px;\">";
		if (!req('ini')) {
			$ini_url = $script . "?mode=" . req('mode') . "&amp;ini=" . urlencode($ini) . "&amp;sort=index";
		} else {
			$ini_url = $script . "?mode=" . req('mode') . "&amp;sort=index";
		}
		if (req('noform')) {
			$ini_url .= "&amp;noform=" . req('noform');
		}
		$show_index .= "<div style=\"float:left;width:auto;margin-right:3px;\"><strong><a href=\"$ini_url\">[$INI]</a></strong></div>&nbsp;";
		// 選択した記事が含まれている索引は内容を省略しない
		if (count($link[$ini]) <= $index_max || req('ini') || in_array($select_name,$name_list[$ini]) !== false) {
			$show_index .= "<div style=\"float:left;width:300px;\">" . join('',$link[$ini]) . "</div>\n";
		} else {
			$show_index .= "<div style=\"float:left;width:300px;\">" . str_repeat('.',count($link[$ini]))  . "</div>\n";
		}
		$show_index .= "</div>\n";
	}	
	$show_index .= "</div>\n";
	return $show_index;
}


function show_category() {
	global $yougo_log,$script,$rep_width,$new_id,$show_new,$new_day,$req,$dt,$index_max,$yougoid,$category_list,$color_list,$yougotm,$amode_list,$current_back_color,$admin_back_color;
	
	$last_ini = '';
	$ini_list = array();
	$link = array();
	if (is_array($yougoid)) { $id_name = array_flip($yougoid); }
	$select_name = '';
	if (isset($id_name[req('noform')])) { $select_name = $id_name[req('noform')]; }
	$show_category = '';
	$new_list = array();
	foreach ($yougo_log as $val) {
		$tmp = explode('<>',$val);
		$id = $tmp[0];
		$tm_list[$id] = $tmp[1];
		$cat = $tmp[3];
		$cats = explode('&&',$cat);
		$name = $tmp[2];
		if (strpos($name,'&&') !== false) {
			$names = explode('&&',$name);
		} else {
			$names = array($name);
		}
		foreach ($cats as $_) {
			foreach ($names as $nm) {
				$new_list[] = join('<>',array($id,$_,$nm));
			}
		}
	}
	$sort = $sort2 = array();
	foreach ($new_list as $_) {
		$tmp = explode('<>',$_);
		if (isset($tmp[1])) { $sort[] = $tmp[1]; }
		if (isset($tmp[2])) { $sort2[] = $tmp[2]; }
	}
	array_multisort($sort,SORT_ASC,SORT_STRING,$sort2,SORT_ASC,SORT_STRING,$new_list);
	$cat_list =array();
	foreach ($new_list as $_) {
		$tmp = explode('<>',$_);
		if (isset($tmp[1])) {
			$cat_name = $tmp[1];
			if (! $tmp[1]) { $cat_name = 'カテゴリーなし'; }
			$cat_list[] = $cat_name;
			$id = $tmp[0];
			$name = $tmp[2];
			if (! isset($link[$cat_name])) { $link[$cat_name] = array(); }
			$url = $script . "?mode=" . req('mode') . "&amp;noform=$id&amp;sort=category";
			foreach (array('keyword','category_filter','ini') as $key) {
				if (req($key)) { $url .= "&amp;$key=" . urlencode(req($key)); }
			}
			if (isset($req['login']) && $req['login']) { $url .= "&amp;login=" . $req['login']; }
			$new = '';
			$tm = date2("Y/m/d H:i:s",$tm_list[$id]);
			$day = new DateTime($tm);
			$day->modify('+' . $new_day . ' days');
			if ($show_new && $day > $dt) {
				$new = "<span style=\"color:crimson;font-size:80%\">new</span>";
			}
			$short_name = $name;
			$pup = '';
			if (strlen($short_name) > 30) {
				$dot = '';
				if (strlen($short_name) > strlen(jtruncate($short_name,30))) {
					$dot = '...';
				}
				$short_name = jtruncate($name,30) . $dot;
				$pup = jtruncate($name,100);
			}
			if (req('noform') == $id) {
				$link[$cat_name][] = "$new<a href=\"$url\" style=\"background-color:$current_back_color;white-space:nowrap;\" title=\"$pup\">$short_name</a> ";
			} elseif (req('edit') == $id || (req('post') && $new_id == $id)) {
				$link[$cat_name][] = "$new<a href=\"$url\" style=\"background-color:#ffeeff;white-space:nowrap;\" title=\"$pup\">$short_name</a> ";
			} elseif (isset($amode_list[$id]) && $amode_list[$id]) {
				$link[$cat_name][] = "$new<a href=\"$url\" style=\"background-color:#aaffff;white-space:nowrap;\" title=\"$pup\">$short_name</a> ";
			} else {
				$link[$cat_name][] = "$new<a href=\"$url\" style=\"white-space:nowrap;\" title=\"$pup\">$short_name</a> ";
			}
			$name_list[$cat_name][] = $name;
		}
	}
	$cat_list = array_unique($cat_list);
	$nmb = 0;
	foreach ($cat_list as $key) {
		if (!req('ini')) {
			$ini_url = $script . "?mode=" . req('mode') . "&amp;ini=" . urlencode($key) . "&amp;sort=category";
		} else {
			$ini_url = $script . "?mode=" . req('mode') . "&amp;sort=category";
		}
		if (req('noform')) { $ini_url .= "&amp;noform=" . req('noform'); }
		if (!req('ini') || req('ini') == $key) {
			if ($key == 'カテゴリーなし') {
				$show_category .= "<div><div style=\"background-color:" . "#dddddd" . ";color:" . "#000000" . ";\"><a href=\"$ini_url\">[" . $key . "]</a></div>\n";
			}	else {
				$col = category_color($key);
				$show_category .= "<div><div style=\"background-color:$col;color:" . text_color($col) . ";\"><a href=\"$ini_url\" style=\"color:" . text_color($col) . ";\">[" . $key . "]</a></div>\n";
			}
			if (req('ini') || count($link[$key]) < $index_max || in_array($select_name,$name_list[$key]) !== false) {
				$show_category .= "<div>\n";
				foreach ($link[$key] as $val) { $show_category .= $val . " "; }
				$show_category .= "</div>\n";
			}
			$show_category .= "</div>\n";
		}
		$nmb++;
	}
	return $show_category;
}


function category_color($cat) {
	global $color_list,$category_list;
	$new_cat_list = array();
	foreach ($category_list as $_) { if ($_) { $new_cat_list[] = $_; } }
	$count = 0;
	foreach ($new_cat_list as $category) {
		if ($category == $cat) { return($color_list[$count % count($color_list)]); }
		$count++;
	}
}


function merge_array($count,$merge) {
	global $order;
	$new_count = array();
	foreach ($count as $key=>$val) {
		$tmp = explode('<>',$key);
		$i = 0;
		$new_key_list = array();
		foreach ($tmp as $k) {
			if ($order[$merge] == $i) { $k = ''; }
			$new_key_list[] = $k;
			$i++;
		}
		$new_key = join('<>',$new_key_list);
		if (! isset($new_count["$new_key"])) { $new_count["$new_key"] = 0; }
		$new_count["$new_key"] += $val;
	}
	return $new_count;
}






function keyword_coloring($string,$keys) {

	// EUCに変換しないとうまくマッチしないようだ
	$euc_string = mb_convert_encoding($string,'euc-jp', 'utf-8');
	$keys = str_replace('　',' ',$keys);
	$keys = preg_replace('/\s+/',' ',$keys);
	$keys = preg_replace('/\s$/','',$keys);
	$keys = preg_replace('/^\s+/','',$keys);
	$euc_keys = mb_convert_encoding($keys,'euc-jp', 'utf-8');
	$ascii = '[\x00-\x7F]';
	$twoBytes = '[\x8E\xA1-\xFE][\xA1-\xFE]';
	$threeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';

	$key_tex_col = '#0030dd';
	$key_bg_col = '#ccffee';
	$key_list = explode(' ',$euc_keys);
	$euc_string .= "\r";
	foreach ($key_list as $key) {
		$ptn = '/^(?:' . $ascii . '|' . $twoBytes . '|' . $threeBytes . ')*?(?:' . $key . ')/';
		if (preg_match($ptn,$euc_string,$matched)) {
			$key_splits = explode($key,$euc_string);
			$new_split = "<span style=\"color:$key_tex_col;background-color:$key_bg_col\">" . $key . "</span>";
			$euc_string = join($new_split,$key_splits);
		}
	}
	$euc_string = str_replace(array("\r\n","\r","\n"), '', $euc_string);
	$string = mb_convert_encoding($euc_string,'utf-8', 'euc-jp');
	return $string;
}



function random_str($length = '') {
	if (! $length) { $length = 10 ; }
	  $salt = array_merge(range('a', 'z'), range('0', '9'), range('A', 'Z'));
    $login_id = '';
    for ($i = 0; $i < $length; $i++) {
        $login_id .= $salt[rand(0, count($salt)-1)];
    }
    return $login_id;
}



function urlparam($req,$redirect) {
	global $script;
	$first = 1;
	$url = $script;
	$used_key = array();
	foreach (array_keys($req) as $key) {
		if ($key === 'delete_do') { continue; }
		if (in_array($key, $used_key)) { continue; }
		if ($first) {
			$first = 0;
			$url .= "?$key=" . urlencode($req[$key]);
			array_push($used_key,$key);
		} else {
			if ($redirect) {
				$url .= "&$key=" . urlencode($req[$key]);
			} else {
				$url .= "&amp;$key=" . urlencode($req[$key]);
			}
			array_push($used_key,$key);
		}
	}
	foreach (array_keys($_REQUEST) as $key) {
		if ($key === 'delete_do') { continue; }
		if (in_array($key, $used_key)) { continue; }
		if ($first) {
			$first = 0;
			if (isset($req[$key])) {
				$url .= "?$key=" . urlencode($req[$key]);
				array_push($used_key,$key);
			} elseif(req($key)) {
				$url .= "?$key=" . urlencode(req($key));
				array_push($used_key,$key);
			}
		} else {
			if (isset($req[$key])) {
				if ($redirect) {
					$url .= "&$key=" . urlencode($req[$key]);
				} else {
					$url .= "&amp;$key=" . urlencode($req[$key]);
				}
				array_push($used_key,$key);
			}  elseif(req($key)) {
				if ($redirect) {
					$url .= "&$key=" . urlencode(req($key));
				} else {
					$url .= "&amp;$key=" . urlencode(req($key));
				}
				array_push($used_key,$key);
			}
		}
	}
	return $url;
}




function url_param($param) {
	$count = 0;
	$url = '';
	foreach (array_keys($param) as $_) {
		if ($param[$_]) {
			if (! $count) {
				$url .= "?" . $_ . "=" . $param[$_];
				$count++;
			} else {
				$url .= "&amp;" . $_ . "=" . $param[$_];
			}
		}
	}
	return $url;
}




function getweek_($day,$year,$month) {
	$datetime = date_create(); 
	date_date_set($datetime, $year, $month, $day); 
	//$week = array("日", "月", "火", "水", "木", "金", "土"); 
	$w = (int)date_format($datetime, 'w'); 
	return $w;
}


function getweek($day,$year,$month) {
	if ($month == 1 || $month == 2) {
		$year = $year - 1;
		$month = $month + 12;
	}
	return intval ($year + intval ($year/4) - intval ($year/100) + intval ($year/400) + intval ((13*$month+8)/5) + $day) % 7;
}





function req($key) {
	return isset($_REQUEST[$key]) ? $_REQUEST[$key] : '';
}

function head() {
	global $graph_str;
	header("Content-type: text/html; charset=UTF-8");
	$header_flag = 1;
	global $title,$white_hover,$header_flag;
	$header_flag = 1;
	$title = isset($title) ? $title : '';
	$style = '<link rel="STYLESHEET" type="text/css" media="screen" href="style.css" />
<link rel="stylesheet" type="text/css" media="print" href="print.css" />
';
	if (req('prev_pdf')) {
		$style = '<link rel="STYLESHEET" type="text/css" media="screen" href="print.css" />
';
	}
	$style .= "<link rel=\"STYLESHEET\" type=\"text/css\"  href=\"./lib/jslideLock/slidelock.css\" />\n";
	time_check('header出力');
	print <<<EOD
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Script-Type" content="text/javascript" /> 
<meta http-equiv="Content-Style-Type" content="text/css" /> 
$style
<title>$title</title>
<link rel="SHORTCUT ICON" href="../favicon.ico" />
<script type="text/javascript" src="./lib/cmanImgPop.js"></script>
<script type="text/javascript" src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="https://ajax.aspnetcdn.com/ajax/jquery.ui/1.8.21/jquery-ui.js"></script>
<script type="text/javascript" src="./lib/jslideLock/jquery.slideLock.js"></script>
<script type="text/javascript" src="./lib/jslideLock/slideLock.js"></script>
<style type="text/css">
<!--
body {
	margin-left:0px;
	margin-right:0px;
	margin-top:0px;
	margin-bottom:0px;
	font-family: "メイリオ", Meiryo, "ＭＳ Ｐゴシック", "MS PGothic", Arial, "ヒラギノ角ゴ ProN W3", "Hiragino Kaku Gothic ProN", sans-serif;
}
textarea,input {
	font-family: "メイリオ", Meiryo, "ＭＳ Ｐゴシック", "MS PGothic", Arial, "ヒラギノ角ゴ ProN W3", "Hiragino Kaku Gothic ProN", sans-serif;
}

rt {
	font-size:60%;
}

td {
	line-height:1.3em;
}
@media print{ 
	.button{ 
		display: none; 
	} 
	input{ 
		display: none; 
	} 
	div.notprint{ 
		display: none; 
	} 
	div.tab{ 
		display: none; 
	} 
	td.notprint{ 
		display: none; 
	} 
	span.notprint{ 
		display: none; 
	} 
	table.notbreak {
		display:block;
	}

}
.cal {
	font-family:Verdana,Helvetica,Arial;
}
.block {
   page-break-inside: avoid;
}
table.notbreak {
	page-break-inside: avoid;
	font-size:130%;
	
}
.tab {
  position: absolute;
  top: 3px;
  left: 6px;
  background-color: transparent;
}
-->
</style>
EOD;
	if (isset($graph_str)) { print $graph_str; }
	global $pulldown;
	print $pulldown;
	print "</head>\n";
	global $body;
	if ($body) {
		print $body;
	} else {
		print "<body>\n";
	}
}





function title() {
	global $t_gif, $header_color, $t_size, $t_wid, $t_hgt, $title, $script,$admin_mode,$datadir,$access_level,$hd_col,$hide_header;
	if ($hide_header) { return; }
	$div = '';
	$cont1 = '';
	$cont2 = '';
	$cont3 = '';
	$div = "<div class=\"notprint\" style=\"text-align:center;width:100%;\">\n";
	$logout = '';
	$logout2 = '';
	if (req('login')) {
		$logout = "&amp;logout=" . req('login');
		$logout2 = "?logout=" . req('login');
	}
	if ($t_gif) {
		$cont2 = "<img src=\"$t_gif\" width=\"$t_wid\" height=\"$t_hgt\" alt=\"$title\" />\n";
	} else {
		$cont2 = "<a href=\"$script$logout2\" style=\"text-decoration:none;color:" . text_color($hd_col) . ";font-size:$t_size;\">$title</a>\n";
	}
	if (!req('make_pdf')) {
		$cont3 .= show_clock(text_color($hd_col));
	}

	$url = $script;
	if (preg_match('/\.php$/',$url)) {
		$url .= "?prev_pdf=1";
	} else {
		$url .= "&amp;prev_pdf=1";
	}
	foreach (array_keys($_REQUEST) as $key) {
		$url .= "&amp;$key=" . urlencode($_REQUEST[$key]);
	}
	$headline = $div;
	$headline .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"4\" style=\"width:100%;\" summary=\"ヘッドライン内\"><tr>\n";
	$headline .= "<td style=\"color:" . text_color($hd_col) . ";width:33%;\">$cont1</td>\n";
	$headline .= "<td style=\"text-align:center;width:33%;\">$cont2</td>\n";
	$headline .= "<td style=\"text-align:right;vertical-align:center;width:33%;\">$cont3</td>\n";
	$headline .= "</tr></table>\n";
	$headline .= "</div>\n";
	return $headline;
}



function show_clock($txt_color) {
	$html = '<table style="float:right;width:100%;" summary="時刻表示"><tr>';
	global $hd_col,$access_level;
	$add_link = '';
	//if ($_SERVER['REMOTE_ADDR'] === '127.0.0.1' || $_SERVER['SERVER_ADDR'] === '192.0.0.125' || $_SERVER['SERVER_ADDR'] === '192.168.223.125') {
	if ($access_level >= 3) {
		$add_link .= "<a href=\"../shukei/shukei.php\" style=\"color:" . text_color($hd_col) . "\" target=\"_blank\">作業記録集計</a>";
		$add_link .= "&nbsp;&nbsp;<a href=\"../rkbyougo/yougo.php\" style=\"color:" . text_color($hd_col) . "\" target=\"_blank\">放送用語登録</a>&nbsp;&nbsp;";
		global $synch_url, $t_title;
		$html .= "<td style=\"width:70%;text-align:right;\">$add_link";
		if ($access_level == 4 && $_SERVER['REMOTE_ADDR'] === '127.0.0.1') {
			$html .= "<a href=\"$synch_url\" target=\"_blank\" style=\"color:$txt_color;\">サーバーの$t_title</a>";
		}
		$html .= "</td>";
	}
	$html .= <<<EOM
<td style="text-align:right;"><form action="#" method="post" style="margin:0">
<input type="text" name="time" size="40" style="width:250px;color:$txt_color;background-color:transparent;border-style : none;" />
<script type="text/javascript">
<!--
function time() {
  var weekDayList = [ "日", "月", "火", "水", "木", "金", "土" ] ;
  date = new Date();
  year = date.getYear();
  mon  = date.getMonth()+1;
  day  = date.getDate();
  week = weekDayList[ date.getDay() ] ;
  hour = date.getHours();
  min  = date.getMinutes();
  sec  = date.getSeconds();
  if (year < 1000) year = year + 1900;
  if (hour < 10) hour = "0" + hour;
  if (min  < 10) min  = "0" + min;
  if (sec  < 10) sec  = "0" + sec;
  time1 = "現在時刻 "+year+"年"+mon+"月"+day+"日("+week+") "+hour+":"+min+":"+sec;
  time2 = hour+":"+min+":"+sec;

  // 下の最後にある time1 を time2 にすると、時分秒のみ表示します。
  document.forms[0].time.value = time1;
  setTimeout('time()', 999);
}
time();
// -->
</script>
</form></td></tr></table>
EOM;
	return($html);
}


function pulldown($nmb) {
	
	$pulldown = '';
	$pulldown .= "<script type=\"text/javascript\">\n<!--\n";
	for ($i=0; $i<=$nmb; $i++) {
		if (!$i) {
			$pulldown .= "function PLDOWN(){\n";
			$pulldown .= "	Sel=document.PULLDOWN.OP.selectedIndex;\n";
			$pulldown .= "	Url=document.PULLDOWN.OP.options[Sel].value;\n";
			$pulldown .= "	top.location.href=Url;\n";
			$pulldown .= "}\n";
		} else {
			$pulldown .= "function PLDOWN$i(){\n";
			$pulldown .= "	Sel=document.PULLDOWN$i.OP$i.selectedIndex;\n";
			$pulldown .= "	Url=document.PULLDOWN$i.OP$i.options[Sel].value;\n";
			$pulldown .= "	top.location.href=Url;\n";
			$pulldown .= "}\n";
		}
	}
	$pulldown .= "// -->\n</script>";
	return $pulldown;
}



// &pulldown_form(ナンバー,リスト)	あらかじめ選択項目を$option_select{"リストの要素"}、ジャンプ先のURLを$option_url{"リストの要素"}に保存してリファレンスを作っておく
// PHP版ではリファレンスは使用しない
function pulldown_form($pull_nmb, $list) {
	global $option_select,$optin_style,$script,$option_url;
	print "<form name=\"PULLDOWN$pull_nmb\" id=\"PULLDOWN$pull_nmb\" action=\"#\" style=\"margin:0;\">\n";
	$sel_str = '';
	$sel_style = '';
	$exst_sel = 0;
	foreach ($list as $_) {
		if (isset($option_select[$_]) && $option_select[$_]) {
			$exst_sel = 1;
		}
	}
	foreach ($list as $_) {
		$sel = '';
		if (! isset($option_select[$_])) {
			$option_select[$_] = '';
		}
		if ($option_select[$_]) {
			$sel = ' selected="selected"';
			if (!$_ || ! isset($optin_style[$_])) {
				$optin_style[$_] = '';
			}
			$sel_style = $optin_style[$_];
			$exst_sel = 1;
		}
		if (! isset($option_url[$_])) {
			$option_url[$_] = '';
		}
		if (! isset($optin_style[$_])) {
			$optin_style[$_] = '';
		}
		if (!$_ && !$exst_sel) {
			$sel_str = $sel_str . "<option selected=\"selected\" value=\"$script" . $option_url[$_] . "\"" . $optin_style[$_] . ">$_</option>\n";
		} else {
			$sel_str = $sel_str . "<option$sel value=\"$script" . $option_url[$_] . "\"" . $optin_style[$_] . ">$_</option>\n";
		}
	}
	$sel_str = "<select name=\"OP$pull_nmb\" onchange=\"PLDOWN$pull_nmb()\"$sel_style>\n" . $sel_str;
	print $sel_str;
	print "</select>\n";
	print "</form>\n";
}


function pulldown_form2($pull_nmb, $list) {
	global $option_select,$optin_style,$script,$option_url,$cat_belong;
	$html = "<form name=\"PULLDOWN$pull_nmb\" id=\"PULLDOWN$pull_nmb\" action=\"#\" style=\"margin:0;\">\n";
	$sel_str = '';
	$sel_style = '';
	foreach ($list as $_) {
		$sel = '';
		if (! isset($option_select[$_])) {
			$option_select[$_] = '';
		}
		if ($option_select[$_]) {
			$sel = ' selected="selected"';
			if (!$_ || ! isset($optin_style[$_])) {
				$optin_style[$_] = '';
			}
			$sel_style = $optin_style[$_];
		}
		if (! isset($option_url[$_])) {
			$option_url[$_] = '';
		}
		if (! isset($optin_style[$_])) {
			$optin_style[$_] = '';
		}
		$add = '';
		if (isset($cat_belong[$_])) {
			$add = '(' . $cat_belong[$_] . ')';
		}
		$sel_str = $sel_str . "<option$sel value=\"$script" . $option_url[$_] . "\"" . $optin_style[$_] . ">$_$add</option>\n";
	}
	$sel_str = "<select name=\"OP$pull_nmb\" onchange=\"PLDOWN$pull_nmb()\"$sel_style>\n" . $sel_str;
	$html .= $sel_str;
	$html .= "</select>\n";
	$html .= "</form>\n";
	return $html;
}


function footer() {
	global $script,$yy_mm_dd,$server_dir,$cgi_name,$version,$debug_mode,$debug,$admin_mode,$synch_dir,$except_ip,$datadir,$access_level,$req;

	$footer = '';
	time_check('footer表示開始');
	if ( req('print') ) {
		$footer .= "<div class=\"notprint\" style=\"text-align:right;margin-right:1em;\">\n";
	} else {
		$footer .= "<div class=\"notprint\" style=\"text-align:right;margin-right:1em;\">\n";
	}
	$epc = filemtime($script);
	$tm = date("Y年m月d日 H:i",$epc);
	$footer .= "$cgi_name&nbsp;<a href=\"$script?mode=history\" style=\"color:inherit;\">version&nbsp;" . $version . "&nbsp;<span style=\"font-size:80%\">(${tm}更新)</span></a>\n";
	$footer .= "&copy;&nbsp;hirayama\n";
	$footer .= "<a href=\"$script?mode=admin\" style=\"color:inherit;\">管理者用</a>";
	$footer .= "</div>\n";
	if ($debug_mode) {
		$footer .= "<div class=\"notprint\" style=\"padding:1em;background-color:#ddffff;color:#000000;\">\n";
		if (isset($debug)) {
			$footer .= $debug;
			$footer .= "</table>\n";
		}
		$keys = array_keys($_REQUEST);
		foreach ($keys as $i) {
			if (req("$i")) {
				$footer .= '$_REQUEST[' . $i . '] = ' . $_REQUEST[$i] . "<br />\n";
			}
		}
		$footer .= "<div>クッキー表示</div>";
		foreach ($_COOKIE as $key=>$val) {
			//echo "{$key}→$val<br />";
			$footer .= "\$_COOKIE[$key]→" . $_COOKIE[$key] . "<br />\n";
		}
		$footer .= "</div>\n";
	}
	return $footer;
}




// 月の最終日を取得(引数　年,月)
function get_last_day($year,$month) {
	global $monthday;
	if ($month == 2) {
		// 閏年かどうか
		if ((!($year % 4) && ($year % 100)) || !($year % 400)) {
			return $monthday[$month - 1] + 1;
		} else {
			return $monthday[$month - 1];
		}
	} else {
		return $monthday[$month - 1];
	}
}


function get_before_after($year,$month) {
	
	$before_year = $after_year = $year;
	$before_month = $month - 1;
	$after_month = $month + 1;
	if ($before_month <= 0) {
		$before_month = $before_month + 12;
		$before_year = $before_year - 1;
	}
	if ($after_month > 12) {
		$after_month = $after_month - 12;
		$after_year = $after_year + 1;
	}
	return array($before_year,$before_month,$after_year,$after_month);
}


function text_color($base_color) {
	if (! isset($base_color) || !$base_color) {
		return('#000000');
	}
	$base_color = preg_replace('/#/','',$base_color);
	$r = substr($base_color,0,2);
	$g = substr($base_color,2,2);
	$b = substr($base_color,4,2);
	$r_hex = hexdec($r);
	$g_hex = hexdec($g);
	$b_hex = hexdec($b);
	$meido = $r_hex * 0.299 + $g_hex * 0.587 + $b_hex * 0.114;
	$meido -= 10;
	
	if ($meido < 128) {
		$txt_color = '#ffffff';
	} else {
		$txt_color = '#000000';
	}
	return $txt_color;
}


function bright_dark($base) {
	if (! $base) { $base = '#dddddd' ; }
	$sa = 5;
	$base = str_replace('#','',$base);
	$r = hexdec(substr($base,0,2));
	$g = hexdec(substr($base,2,2));
	$b = hexdec(substr($base,4,2));
	$r_b = intval($r * 1.2);
	if ($r_b > 255) { $r_b = 255 ; }
	$g_b = intval($g * 1.2);
	if ($g_b > 255) { $g_b = 255 ; }
	$b_b = intval($b * 1.2);
	if ($b_b > 255) { $b_b = 255 ; }
	$r_d = intval($r * 0.95);
	if ($r_d > 255) { $r_d = 255 ; }
	$g_d = intval($g * 0.95);
	if ($g_d > 255) { $g_d = 255 ; }
	$b_d = intval($b * 0.95);
	if ($b_d > 255) { $b_d = 255 ; }
	$r_b = sprintf("%02x",$r_b);
	$g_b = sprintf("%02x",$g_b);
	$b_b = sprintf("%02x",$b_b);
	$r_d = sprintf("%02x",$r_d);
	$g_d = sprintf("%02x",$g_d);
	$b_d = sprintf("%02x",$b_d);
	$bb = '#' . $r_b .$g_b . $b_b;
	$dd = '#' . $r_d .$g_d . $b_d;
	if (! $base) {
		$bb = '#dddddd';
		$dd = '#cccccc';
	}
	return(array($bb,$dd));
}


function redirect($jump) {
	header("Location: $jump", true, 301); exit(); 
}


function txt($data) {
	global $debug_mode;
	$debug_dir = './debug';
	if (! file_exists($debug_dir)) { mkdir($debug_dir); }
	if (isset($debug_mode) && $debug_mode) {
		if (file_exists(join('/',array($debug_dir,'log.log'))) && filesize(join('/',array($debug_dir,'log.log'))) > 5000 * 1024) {
			rename(join('/',array($debug_dir,'log.log')),join('/',array($debug_dir,'log' . time() . '.log')));
		}
		$bt = debug_backtrace();
		$line = $bt[0]['line'];
		$data = date("Y/m/d H:i:s",time()) . ' ' . $line . "行\n" . $data . "\n===================\n";
		file_put_contents(join('/',array($debug_dir,'log.log')), $data, FILE_APPEND | LOCK_EX);
	}
}


function admin() {
	global $script,$crypt_pass,$cookietime,$skin,$rep_width;

	if (req('clear_cookie')) {
		setcookie("admin_pass", '', time() - 60);
	}
	//$tmp = file('./tmpl/new.html');
	$tmp = file('./tmpl/' . $skin);
	$tmpl = join("",$tmp);
	$tmpl = preg_replace('/[\s\S]*<body>\n?[\s]*/','',$tmpl);
	if (! req('pass') || req('logout')) {
		if (isset($_COOKIE['admin_pass'])) {
			$c_pass = $_COOKIE['admin_pass'];
		} else {
			$c_pass = '';
		}
		if (req('logout')) {
			setcookie("cpass", '', time() - 60);
		}
		head();
		$headline = title();
		$ptn0 = '/<div[\s\S]*?[^-](color:[^;"]+)[\s\S]*?>[\s\S]*?!headline!/';
		if (preg_match($ptn0,$tmpl,$matched)) {
			$col = $matched[1];
			$ptn1 = '/([^-])color:[^;"]+/';
			$headline = preg_replace($ptn1,'$1' . $col,$headline);
			if (preg_match('/[^-]color:[^;"]+/',$headline,$matched)) {
			}
		}
		//print title();
		$menu = '';
		$menu .= "<div style=\"text-align:center;margin:1em;\">\n";
		if (req('logout')) {
			$menu .= "ログアウトしました。";
		}
		$menu .= "<form action=\"$script\" method=\"post\">\n";
		$menu .= "<input type=\"hidden\" name=\"mode\" value=\"admin\" />\n";
		$menu .= "パスワード&nbsp;<input type=\"password\" name=\"pass\" value=\"$c_pass\" style=\"width:120px;\" />\n";
		$menu .= "<input type=\"submit\" value=\"ログイン\" />\n";
		$menu .= "<input type=\"submit\" name=\"logout\" value=\"ログアウト\" />\n";
		$menu .= "</form></div>\n";
		$tmpl = str_replace('!headline!',$headline,$tmpl);
		$tmpl = preg_replace('/(<!-- メインカラム開始 -->)[\s\S]*(<!-- メインカラム終了 -->)/','$1' . "\n<div class=\"content\" style=\"margin-bottom:1em;\">\n$menu\n</div>\n" . '$2',$tmpl);
//		$tmpl = str_replace('!menu!',$menu,$tmpl);
		$tmpl = str_replace('!menu!','',$tmpl);
		$tmpl = preg_replace('/<div id="preview"[\s\S]*?<\/div>?/','',$tmpl);
//		$tmpl = preg_replace('/!preview!/','',$tmpl);
		$tmpl = preg_replace('/!preview!/',$menu,$tmpl);
		$tmpl = preg_replace('/<div id="form"[\s\S]*?<\/div>?/','',$tmpl);
		$tmpl = preg_replace('/!form!/','',$tmpl);
		$tmpl = str_replace('!search!','',$tmpl);
		$tmpl = str_replace('!index!','',$tmpl);
		$tmpl = str_replace('!new_link!','',$tmpl);
		$tmpl = preg_replace('/(<div class="editview"[\s\S]*?>)[\s\S]*?!editview![\s\S]*?(<\/div>?)/','',$tmpl);
		$tmpl = str_replace('!footer!',footer(),$tmpl);
		print $tmpl;
		exit();
	}
	if (decrypt(req('pass'), $crypt_pass) === 'no') {
		error("パスワードが認証できません");
	} else {
		setcookie("admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
	}
	if (req('adminpass') === '管理者パスワードを変更') {
		if (strlen(req('new_pass')) < 5) { error("パスワードは5文字以上にしてください。"); }
	}
	if (req('post')) {
		file_put_contents(req('tmpl'),req('cont'),LOCK_EX);
	}

	global $config_list, $script;

	$init_list = file("./init.php");
	$o_init_list = $init_list;
	$new_line_list = array();
	$popup = array();
	$line_count = 0;
	foreach ($init_list as $init_line) {
		$line_flag = 0;
		foreach ($config_list as $cfg) {
			$next = 0;
			if (isset($invalid) && $invalid) {
				foreach ($invalid as $_) {
					if ($cfg === $_) {
						$next = 1;
					}
				}
			}
			$ptn = '/^\$' . $cfg . '( +=|=)+/';
			if ($cfg && preg_match($ptn,$init_line)) {
				if (preg_match('/^\d+$/',req($cfg))) {
					$value = req($cfg);
				} else {
					$val = req($cfg);
					$val = str_replace('&lt;','<',$val);
					$val = str_replace('&gt;','>',$val);
					$val = str_replace('&quot;','"',$val);
					$value = "'" . $val . "'";
				}
				//@tmp = split(/;/,$init_line);
				$tmp = explode(';',$init_line);
				$com = array_pop($tmp);
				$com = str_replace(array("\r\n","\r","\n"), '', $com);
				$popup[$cfg] = $com;
				if (!$next) {
					$init_line = '$' . $cfg . " = " . $value . ";" . $com . "\n";
				}
				$ex_line = $line_count - 1;
				while (preg_match('/^\/\/+/',$init_list[$ex_line])) {
					$memo = $init_list[$ex_line];
					$popup[$cfg] = $memo . $popup[$cfg];
					$ex_line--;
				}
				break;
			}
		}
		if (req('adminpass') === '管理者パスワードを変更' && preg_match('/^\$crypt_pass( +=|=)+/',$init_line)) {
			$crypt_pass = encrypt(req('new_pass'));
			$tmp = explode(';',$init_line);
			$com = array_pop($tmp);
			$init_line = '$crypt_pass = ' . "'" . $crypt_pass . "';" . $com;
		}
		if (req('color_edit') === 'do' && preg_match('/^\$color_list/',$init_line)) {
			$list = array();
			$keys = array_keys($_REQUEST);
			sort($keys);
			foreach ($keys as $_) {
				if (preg_match('/^color\d+/',$_) && req($_)) {
					array_push($list,req($_));
				}
			}
			$init_line = '$color_list = array(';
			$count = 0;
			foreach ($list as $_) {
				if ($count > count($list)) {
					$init_line .= "'$_'";
				} else {
					$init_line .= "'$_',";
				}
				$count++;
			}
			$init_line .= ");\n";
		}
		array_push($new_line_list, $init_line);
		$line_count++;
	}
	if (req('modify') === 'do') {
		file_put_contents('./init.php', $new_line_list, LOCK_EX);
		$value = '修正しました。';
		if (req('adminpass')) {
			$value = 'パスワードを変更しました。';
		}
		$value = urlencode($value);
		if (req('new_pass')) {
			$req['pass'] = req('new_pass');
		} else {
			$req['pass'] = req('pass');
		}
		make_config();
		redirect("$script?mode=admin&pass=" . $req['pass'] . "&location_com=$value\n\n");
		exit();
	}
	if (req('color_edit') === 'do') {
		$new_line_list = array();
		foreach ($o_init_list as $init_line) {
			if (preg_match('/^\$color_list/',$init_line)) {
				$list = array();
				$keys = array_keys($_REQUEST);
				sort($keys);
				foreach ($keys as $_) {
					if (preg_match('/^color\d+/',$_) && req($_)) {
						array_push($list,req($_));
					}
				}
				$init_line = "\$color_list = array(";
				$count = 0;
				foreach ($list as $_) {
					if ($count > count($list)) {
						$init_line .= "'$_'";
					} else {
						$init_line .= "'$_',";
					}
					$count++;
				}
				$init_line .= ");\n";
			}
			array_push($new_line_list, $init_line);
		}
		file_put_contents('./init.php', $new_line_list, LOCK_EX);
		make_config();
		$value = '色リストを修正しました。';
		$value = urlencode($value);
		if ($req['new_pass']) {
			$req['pass'] = $req['new_pass'];
		} else {
			$req['pass'] = req('pass');
		}
		$jump = "$script?mode=admin&pass=" . $req['pass'] . "&location_com=$value\n\n";
		txt("リダイレクトのURL=" . $jump);
		redirect($jump);
		exit();
	}
	$menu = '';
	$menu .= "<div style=\"margin-left:1em;\">\n";
	$menu .= "[<a href=\"$script\">戻る</a>]";
	if (req('location_com')) {
		$menu .= "<div style=\"color:red;\">" . req('location_com') . "</div>\n";
	}
	$menu .= "<form action=\"$script\" method=\"post\">\n";
	$menu .= "<input type=\"hidden\" name=\"mode\" value=\"admin\" />\n<input type=\"hidden\" name=\"pass\" value=\"" . req('pass') . "\" />\n";
	$menu .= "<input type=\"hidden\" name=\"admin\" value=\"設定\" />\n<input type=\"hidden\" name=\"modify\" value=\"do\" />\n";
	$menu .= "<table border=\"1\" cellspacing=\"0\" cellpadding=\"2\" summary=\"設定変更フォーム\" style=\"background-color:#ffffff;\">\n";
	$menu .= "<tr><td colspan=\"3\"><input type=\"submit\" value=\"　修　正　\" />&nbsp;変更する部分のみ修正して「修正」ボタンを押してください。&nbsp;&nbsp;<a href=\"#new_pass\">管理者パスワードを変更する</a></td></tr>\n";
	foreach ($config_list as $_) {
		global $$_;
		$enc = $$_;
		if (req($_) !== '') { $enc = req($_); }
		$enc = str_replace('<','&lt;',$enc);
		$enc = str_replace('>','&gt;',$enc);
		$enc = str_replace('"','&quot;',$enc);
		if (! is_string($enc)) { continue; }
		$length = strlen($enc) + 2;		// 文字列出ないとエラーになるので
		if ($length > 110) { $length = 110; }
		if ($length > 20) {
			$size_op = " size=\"$length\"";
		} else {
			$size_op = '';
		}
		$size_style = $length * 7;
//		if ($size_style > 600) {
//			$size_style = 600
//		}
		if ($size_style < 150) {
			$size_style = 150 . 'px';
		} else {
			$size_style .= 'px';
		}
		$ime_op = " style=\"ime-mode:inactive;width:$size_style;\"";
		if (! isset($popup[$_])) { $popup[$_] = ''; }
		$popup[$_] = str_replace("\n",'<br />',$popup[$_]);
		if ($popup[$_]) {
			$exp = $popup[$_];
		} else {
			$exp = "&nbsp;";
		}
		if ($_ == 'skin') {
			$skin_list = array();
			$tmpdir = opendir('./tmpl');
			while ($file = readdir($tmpdir)) {
				if (preg_match('/\.html$/',$file)) {
					$skin_list[] = $file;
				}
			}
			closedir($tmpdir);
			$opt = '';
			foreach ($skin_list as $skin_name) {
				if ($skin_name == $enc) {
					$opt .= "<option selected=\"selected\" value=\"$skin_name\">$skin_name</option>\n";
				} else {
					$opt .= "<option value=\"$skin_name\">$skin_name</option>\n";
				}
			}
			$select = "<select name=\"$_\">$opt</select>\n";
			$menu .= "<tr><td align=\"right\">\$" . $_ . " = </td><td style=\"width:20%;\">$select</td><td>$exp</td></tr>\n";
		} elseif ($size_op) {
			$menu .= "<tr><td align=\"right\" valign=\"top\">\$" . $_ . "= </td><td colspan=\"2\"><input type=\"text\" name=\"$_\" value=\"$enc\"$size_op$ime_op /><br />$exp</td></tr>\n";
		} elseif (preg_match('/back_color/',$_)) {
			$ime_op = " style=\"ime-mode:inactive;width:$size_style;background-color:$enc;color:" . text_color($enc) . ";\"";
			$menu .= "<tr><td align=\"right\">\$" . $_ . " = </td><td style=\"width:20%;\"><input type=\"text\" name=\"$_\" value=\"$enc\"$size_op$ime_op /></td><td>$exp</td></tr>\n";
		} else {
			$menu .= "<tr><td align=\"right\">\$" . $_ . " = </td><td style=\"width:20%;\"><input type=\"text\" name=\"$_\" value=\"$enc\"$size_op$ime_op /></td><td>$exp</td></tr>\n";
		}
	}
	$menu .= "<tr><td colspan=\"3\"><input type=\"submit\" name=\"adminpass\" value=\"管理者パスワードを変更\" />\n";
	$menu .= "<a name=\"new_pass\">新しいパスワード</a>&nbsp;<input type=\"text\" name=\"new_pass\" style=\"width:120px;\" /></td></tr>\n";

	$menu .= "<tr><td colspan=\"3\">";
	$menu .= "<a href=\"$script?mode=admin&amp;clear_cookie=1\">クッキーをクリア</a>";
	$menu .= "</td></tr>";
	$menu .= "</table>\n</form>\n</div>\n";

//	$plugin_list = array();
//	if (is_dir('./plugin')) {
//		$tmpdir = opendir('./plugin');
//		while ($file = readdir($tmpdir)) {
//			if (preg_match('/\.php$/',$file)) {
//				$plugin_list[] = $file;
//			}
//		}
//		closedir($tmpdir);
//	}
//	$menu .= "<div><table><tr><td colspan=\"2\">インストールされているプラグイン</td>";
//	$menu .= "<td>" . join('<br />',$plugin_list) . "</td></tr>\n";
//	$menu .= "</table></div>\n";

	
	$menu .= "<div style=\"margin:1em;width:100%;\">\n";
	$menu .= "<form action=\"$script\" method=\"post\" style=\"padding:0.5em;border: 1px dotted #000000;width:100%;background-color:#ffffff\">\n";
	$menu .= "<input type=\"hidden\" name=\"mode\" value=\"admin\" />\n<input type=\"hidden\" name=\"pass\" value=\"" . req('pass') . "\" />\n";
	$menu .= "<input type=\"hidden\" name=\"color_edit\" value=\"do\" />\n";
	$menu .= "<input type=\"submit\" value=\"カラーリストを編集\" />";
	$menu .= "<table summary=\"カラーリスト\">\n<tr><td>";
	$count = 0;
	global $color_list;
	foreach ($color_list as $_) {
		$menu .= "<input type=\"text\" name=\"color" . sprintf("%03d",$count) . "\" style=\"margin:2px;width:3em\" value=\"\" />\n";
		$count++;
		$menu .= "<span style=\"white-space:nowrap;\">". intval($count/2) . "<input type=\"text\" name=\"color" . sprintf("%03d",$count) . "\" style=\"margin:2px;background-color:$_;color:" . text_color($_) . ";width:6em\" value=\"$_\" /></span>\n";
		$count++;
	}
	$menu .= "<input type=\"text\" name=\"color" . sprintf("%03d",$count) . "\" style=\"margin:2px;width:3em\" value=\"\" />\n";
	$menu .= "</td></tr></table>\n";
	$menu .= "</form>\n";
	$menu .= "</div>\n";
	head();
	$headline = title();
	$ptn0 = '/<div[\s\S]*?[^-](color:[^;"]+)[\s\S]*?>[\s\S]*?!headline!/';
	if (preg_match($ptn0,$tmpl,$matched)) {
		$col = $matched[1];
		$ptn1 = '/([^-])color:[^;"]+/';
		$headline = preg_replace($ptn1,'$1' . $col,$headline);
		if (preg_match('/[^-]color:[^;"]+/',$headline,$matched)) {
		}
	}
	$tmpl = str_replace('!headline!',$headline,$tmpl);
	$tmpl = str_replace('!menu!',$menu,$tmpl);
	$tmpl = str_replace('!menu!','',$tmpl);
	$tmpl = preg_replace('/<div id="preview"[\s\S]*?<\/div>?/','',$tmpl);
	$tmpl = preg_replace('/!preview!/',$menu,$tmpl);
	$tmpl = preg_replace('/<div id="form"[\s\S]*?<\/div>?/','',$tmpl);
	$tmpl = preg_replace('/!form!/','',$tmpl);
	$tmpl = str_replace('!search!','',$tmpl);
	$tmpl = str_replace('!index!','',$tmpl);
	$tmpl = str_replace('!new_link!','',$tmpl);
	$tmpl = preg_replace('/(<div class="editview"[\s\S]*?>)[\s\S]*?!editview![\s\S]*?(<\/div>?)/','',$tmpl);
	$tmpl = str_replace('!footer!',footer(),$tmpl);
	print $tmpl;
	exit();
}


function create_pass() {
	// $in{'pass'}がTrueならinit.cgiに管理者用パスワードを書き込む
	global $script;
	if (req('pass')) {
		if (strlen(req('pass')) < 5) {
			error("パスワードは5文字以上にしてください。",'back');
		}
		//# init.cgi読み込み
		$init_list = file("./init.php");
		$new_init_list = array();
		foreach ($init_list as $line) {
			$tmp = $line;
			$tmp = str_replace(' ','',$tmp);
			$ptn = '/^\$crypt_pass=\'/';
			if (preg_match($ptn,$tmp)) {		
				// 入力された管理者用パスワードをcryptして$crypt_passに代入する文字列を生成
				$crypt_pass = encrypt(req('pass'));
				$tmp = explode(';',$line);
				$com = array_pop($tmp);
				$new_pass = '$crypt_pass = ' . "'" . $crypt_pass . "';" . $com;
				array_push($new_init_list,$new_pass);
			} else {
				array_push($new_init_list,$line);
			}
		}
		// init.cgi書き込み
		file_put_contents('./init.php', $new_init_list, LOCK_EX);
		
		// 設定画面に移動する
		$value = '設定';
		$value = urlencode($value);
		make_config();
		$jump = "$script?mode=config&pass=" . req('pass') . "\n\n";
		redirect($jump);
		exit();
	}
	head();
	global $script;
	print "<div style=\"margin:1em;\">\n<p>管理者用パスワードを設定してください。</p>\n";
	print "<form action=\"$script\" method=\"post\">\n";
	print "パスワード&nbsp;<input type=\"password\" name=\"pass\" value=\"\" size=\"10\" style=\"width:120px;\" />\n";
	print "<input type=\"submit\" value=\"登録\" />\n";
	print "</form>\n</div>\n";
	footer();
	print "</body>\n</html>\n";
	exit();
}

function make_config() {
	global $config_list, $script;

	$init_list = file("./init.php");
	$o_init_list = $init_list;
	$new_line_list = array();
	$popup = array();
	$line_count = 0;
	foreach ($init_list as $init_line) {
		$line_flag = 0;
		foreach (array_merge(array('crypt_pass','color_list'),$config_list) as $cfg) {
			$next = 0;
			if (isset($invalid) && $invalid) {
				foreach ($invalid as $_) {
					if ($cfg === $_) { $next = 1; }
				}
			}
			$ptn = '/^\$' . $cfg . '( +=|=)+/';
			if ($cfg && preg_match($ptn,$init_line)) {
				if (preg_match('/^\d+$/',req($cfg))) {
					$value = $val = req($cfg);
					$type[$cfg] = '数値';
				} else {
					$val = req($cfg);
					$val = str_replace('&lt;','<',$val);
					$val = str_replace('&gt;','>',$val);
					$val = str_replace('&quot;','"',$val);
					$value = "'" . $val . "'";
					$type[$cfg] = '文字列';
				}
				if ($val == '') {
					eval($init_line);
					if (is_array($$cfg)) {
						$list = array();
						foreach ($$cfg as $_) {
							$list[] = "'" . $_ . "'";
						}
						$str = 'array(' . join(',',$list) . ')';
						$value = $str;
					} else {
						if (preg_match('/^\d+$/',$$cfg)) {
							$value = $$cfg;
						}	else {
							$value = "'" . $$cfg . "'";
						}
					}
				}
				if (!$next) { $config[$cfg] = $value; }
				break;
			}
		}
	}
	$cfg_line = '';
	foreach ($config as $key=>$val) {
		$cfg_line .= "$key<>$val" . "\n";
	}
	file_put_contents('./config.cgi',$cfg_line,LOCK_EX);
}


function reload_config() {
	global $config_list, $script;
	time_check('設定抽出');
	txt(print_r(debug_backtrace(),true));
	$configs = file('./config.cgi',FILE_IGNORE_NEW_LINES);
	foreach ($configs as $line) {
		list($key,$val) = explode('<>',$line);
		$loaded[$key] = $val;
	}
	$init_list = file('./init.php');
	$line_count = 0;
	$new_init_list = array();
	foreach ($init_list as $line) {
		foreach ($loaded as $key=>$val) {
			$ptn = '/^\$' . $key . '( +=|=)+/';
			if (preg_match($ptn,$line)) {
				$value = $val;
				$tmp = explode(';',$line);
				$com = array_pop($tmp);
				$com = str_replace(array("\r\n","\r","\n"), '', $com);
				$popup[$key] = $com;
				$line = '$' . $key . " = " . $value . ";" . $com . "\n";
				$ex_line = $line_count - 1;
				while (preg_match('/^\/\/+/',$init_list[$ex_line])) {
					$memo = $init_list[$ex_line];
					$popup[$key] = $memo . $popup[$key];
					$ex_line--;
				}
				break;
			}
		}
		$new_init_list[] = $line;
		$line_count++;
	}
	file_put_contents('./init.php',$new_init_list,LOCK_EX);
	return 'init.phpの設定を復元しました';
}


function history() {
	global $history,$skin;
	$tmp = file('./tmpl/' . $skin);
	$tmpl = join("",$tmp);
	$tmpl = preg_replace('/[\s\S]*<body>\n?[\s]*/','',$tmpl);
	head();
	$headline = title();
	$ptn0 = '/<div[\s\S]*?[^-](color:[^;"]+)[\s\S]*?>[\s\S]*?!headline!/';
	if (preg_match($ptn0,$tmpl,$matched)) {
		$col = $matched[1];
		$ptn1 = '/([^-])color:[^;"]+/';
		$headline = preg_replace($ptn1,'$1' . $col,$headline);
		if (preg_match('/[^-]color:[^;"]+/',$headline,$matched)) {
		}
	}
	$preview = '';
	$preview .= "<div style=\"margin-top:2em;text-align:center;\">";
	$preview .= "<table style=\"margin:auto;line-height:1.5em\" cellpadding=\"4\" cellspacing=\"0\" summary=\"更新履歴\">";
	$preview .= "<caption>更新履歴</caption>";
	$history = array_reverse($history);
	$count = -1;
	$row = 0;
	foreach ($history as $i) {
		$count++;
		$i = preg_replace('/\t+/',"\t",$i);
		if (preg_match('/^ver\./',$i)) {
			list($ver,$date,$cont) = explode("\t",$i);
			if (isset($history_plus[$count])) {
				$cont .= "<br />" . $history_plus[$count];
			}
		} else {
			$i = preg_replace('/^\t/','',$i);
			$add = 0;
			for ($j = 1;$j<=10;$j++) {
				if (preg_match('/^ver\./',$history[$count+$j])) {
					if (!isset($history_plus[$count+$j])) {
						$history_plus[$count+$j] = '';
					}
					$history_plus[$count+$j] = $i . "<br />" . $history_plus[$count+$j];
					$add = 1;
					break;
				}
			}
			if ($add) { continue; }
		}
		if ($row % 2 == 1) {
			$back = '';
		} else {
			$back = ' style="background-color:#ffeebb;"';
		}
		$preview .= "<tr$back><td style=\"vertical-align:top;\"><strong>$ver</strong></td><td style=\"vertical-align:top;\">$date</td><td style=\"text-align:left;\">$cont</td></tr>\n";
		$row++;
	}
	$preview .= "</table>\n";
	$preview .= "</div>";
	
	$tmpl = str_replace('!headline!',$headline,$tmpl);
	$tmpl = preg_replace('/(<!-- メインカラム開始 -->)[\s\S]*(<!-- メインカラム終了 -->)/','$1' . "\n<div class=\"content\" style=\"margin-bottom:1em;\">\n$preview\n</div>\n" . '$2',$tmpl);
	$tmpl = str_replace('!menu!','',$tmpl);
	$tmpl = preg_replace('/<div id="preview"[\s\S]*?<\/div>?/','',$tmpl);
	$tmpl = preg_replace('/<div[\s\S]*>?!new_link!<\/div>?/','',$tmpl);
	$tmpl = preg_replace('/!preview!/','',$tmpl);
	$tmpl = preg_replace('/<div id="form"[\s\S]*?<\/div>?/','',$tmpl);
	$tmpl = preg_replace('/(<div[^>]+?>)?!form!<[^?]+>?/','',$tmpl);
	$tmpl = str_replace('!search!','',$tmpl);
	$tmpl = str_replace('!index!','',$tmpl);
	$tmpl = str_replace('!new_link!','',$tmpl);
	$tmpl = preg_replace('/(<div class="editview"[\s\S]*?>)[\s\S]*?!editview![\s\S]*?(<\/div>?)/','',$tmpl);
	$tmpl = str_replace('!footer!',footer(),$tmpl);
	print $tmpl;
	exit();
}


function gray($base) {
	$base = preg_replace('/#/','',$base);
	$r = hexdec(substr($base,0,2));
	$g = hexdec(substr($base,2,2));
	$b = hexdec(substr($base,4,2));
	$rgb = intval($r * 0.299  + $g * 0.587 + $b * 0.114) + 40;
	if ($rgb > 255) {
		$rgb = 255;
	}
	$r = sprintf("%02x",$rgb);
	return '#' . $r .$r . $r;
}



function jtruncate($str,$n) {
	if ($n < 2) { return ; }
	if (strlen($str) <= $n) { return $str ; }
	$substr = mb_substr($str,0,intval($n/2),"UTF-8");
	return $substr;
}




function encrypt($inpw) {
	//if (function_exists("password_hash")) {
	if (phpversion() >= 5.5) {
		$encrypt = password_hash($inpw,PASSWORD_DEFAULT);
	} else {
		$encrypt = crypt($inpw,'');
	}
	return($encrypt);
}



function decrypt($inpw, $logpw) {
	//if (function_exists("password_verify")) {
	if (phpversion() >= 5.5) {
		if (password_verify($inpw, $logpw)) {
			$check = "yes";
		} else {
			$check = "no";
		}
	} else {
		if (crypt($inpw, $logpw) === $logpw) {
			$check = "yes";
		} else {
			$check = "no";
		}
	}
	return($check);
}



//$start_m = microtime(); $start = time();
function time_check($pnt) {
	global $start_s,$start_ms;		//スクリプト開始時の秒、マイクロ秒
	global $row_nmb;
	if (! isset($start_s)) {
		$start_s = time(); list($start_ms) = explode(' ',microtime());
	}
	global $last_s,$last_ms,$last_pnt,$checked,$debug;
	if (! isset($last_s)) {
		$last_s = $start_s;$last_ms = $start_ms;
	}
	list($lap_ms) = explode(' ',microtime());
	$lap_s = time();
	$total_s = ($lap_s - $start_s) + ($lap_ms - $start_ms);
	$lap = ($lap_s - $last_s) + ($lap_ms - $last_ms);
	if (! isset($checked) || ! $checked) {
		$debug = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"4\" summary=\"デバッグ用\">\n";
		$checked = 1;
		$row_nmb = 0;
	}
	if (! isset($last_pnt)) {
		$last_pnt = date("Y/m/d H:i:s",$start_s) . '開始';
	}
	$row_col = '';
	if (($row_nmb % 2) == 0) {
		$row_col = " style=\"background-color:#ffffff\"";
	}
	$bt = debug_backtrace();
	$line = $bt[0]['line'];
	if ($lap > 0.1) {
		if ($row_col) {
			$row_col = preg_replace('/(background-color)/','color:red;$1',$row_col);
		} else {
			$row_col = ' style="color:red"';
		}
	}
	$debug .= "<tr$row_col><td><span style=\"font-size:80%\">" . $last_pnt . '</span></td><td>→</td><td><span style="font-size:80%">' . $pnt . '(' . $line . '行)</span></td><td>ラップ</td><td>' . round($lap, 6) . '秒</td><td>(トータル</td><td>' . round($total_s,6) . '秒)</td></tr>' . "\n";
	$row_nmb++;
	$last_s = $lap_s;
	$last_ms = $lap_ms;
	$last_pnt = $pnt;
}

function thumb($url,$width) {
	 
	preg_match('/\.(.{1,4}$)/',$url,$match);
	$ext = $match[1];
	// 元画像のファイルサイズを取得
	list($image_w, $image_h) = getimagesize($url);
	 
	//元画像の比率を計算し、高さを設定
	$proportion = $image_w / $image_h;
	$height = $width / $proportion;
	//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
	if($proportion < 1){
	$height = $width;
	$width = $width * $proportion;
	}
	 
	// サイズを指定して、背景用画像を生成
	$canvas = imagecreatetruecolor($width, $height);
	 
	// ファイル名から、画像インスタンスを生成
	if (in_array($ext,array('gif','GIF'))) {
		$image = imagecreatefromgif($url);
	} elseif (in_array($ext,array('jpg','JPG'))) {
		$image = imagecreatefromjpeg($url);
	} elseif (in_array($ext,array('png','PPG'))) {
		$image = imagecreatefrompng($url);
//	} elseif (in_array($ext,array('bmp','BMP'))) {
//		include "./lib/ImageCreateFromBMP.php";
//		$image = ImageCreateFromBMP($url);
	} else {
		return;
	}
	// 背景画像に、画像をコピーする
	imagecopyresampled($canvas,  // 背景画像
	$image,   // コピー元画像
	0,        // 背景画像の x 座標
	0,       // 背景画像の y 座標
	0,        // コピー元の x 座標
	0,        // コピー元の y 座標
	$width,   // 背景画像の幅
	$height,  // 背景画像の高さ
	$image_w, // コピー元画像ファイルの幅
	$image_h  // コピー元画像ファイルの高さ
	);
	 
	// 画像を出力する
	$thumb_path = preg_replace('/(\..{2,4}$)/','thumb$1',$url);
	
	if (in_array($ext,array('gif','GIF'))) {
		imagegif($canvas,$thumb_path,100);
	} elseif (in_array($ext,array('jpg','JPG'))) {
		imagejpeg($canvas,$thumb_path,100);
	} elseif (in_array($ext,array('png','PNG'))) {
		imagepng($canvas,$thumb_path,3);
//	} elseif (in_array($ext,array('bmp','BMP'))) {
//		imagewbmp($canvas,$thumb_path,100);
	}
//	imagejpeg($canvas,           // 背景画像
//	$thumb_path,    // 出力するファイル名（省略すると画面に表示する）
//	100                // 画像精度（この例だと100%で作成）
//	);
	 
	// メモリを開放する
	imagedestroy($canvas);
}

function error($mes) {
	global $header_flag;
	if (!isset($header_flag) || ! $header_flag) { head(); }
	print "<div style=\"margin:0.5em\">\n";
	print "<h2>エラー</h2>\n";
	print "<div>$mes</div>\n";
	print "<div><a href=\"javascript:history.back();\">戻る</a></div>\n";
	print "</div>\n";
	footer();
	exit();
}


function midashi($comment,$id) {

	$ptn0 = '/(<(h[1234]).*?>(.+?)<\/h[1234]>?)/';
	$midashi_count = 0;
	$midashi = array();
	$midashi_str = '';
	$level = 0;
	$depth = 0;
	while (preg_match($ptn0,$comment,$matched)) {
		$midashi[$midashi_count] = $matched[1];
		$link = "<a href=\"#midashi$id$midashi_count\">" . $matched[3] . "</a>";
		if ($level == 0) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$depth = 1;
				$midashi_str .= "<ul>\n<li>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$level = 3;
				$depth = 1;
				$midashi_str .= "<ul>\n<li>\n<ul>\n<li>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				$midashi_str .= "<ul>\n<li>\n<ul>\n<li>\n<ul>\n<li>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		} elseif ($level == 1) {
			if ($matched[2] == 'h1') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$depth = 1;
				if (preg_match('/<\/li>\s?$/',$midashi_str)) {
					$midashi_str = preg_replace('/<\/li>\s?$/','',$midashi_str);
				} else {
					$midashi_str .= "<li>\n";
				}
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$level = 3;
				$depth = 1;
				if (preg_match('/<\/li>\s?$/',$midashi_str)) {
					$midashi_str = preg_replace('/<\/li>\s?$/','',$midashi_str);
				} else {
					$midashi_str .= "<li>\n";
				}
				$midashi_str .= "<ul>\n<li>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				if (preg_match('/<\/li>\s?$/',$midashi_str)) {
					$midashi_str = preg_replace('/<\/li>\s?$/','',$midashi_str);
				} else {
					$midashi_str .= "<li>\n";
				}
				$midashi_str .= "<ul>\n<li>\n<ul>\n<li>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		} elseif ($level == 2) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "</ul>\n</li>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$level = 3;
				$depth = 1;
				if (preg_match('/<\/li>\s?$/',$midashi_str)) {
					$midashi_str = preg_replace('/<\/li>\s?$/','',$midashi_str);
				} else {
					$midashi_str .= "<li>\n";
				}
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				if (preg_match('/<\/li>\s?$/',$midashi_str)) {
					$midashi_str = preg_replace('/<\/li>\s?$/','',$midashi_str);
				} else {
					$midashi_str .= "<li>\n";
				}
				$midashi_str .= "<ul>\n<li>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} 
		} elseif ($level == 3) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "</ul>\n</li>\n</ul>\n</li>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$midashi_str .= "</ul>\n</li>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				if (preg_match('/<\/li>\s?$/',$midashi_str)) {
					$midashi_str = preg_replace('/<\/li>\s?$/','',$midashi_str);
				} else {
					$midashi_str .= "<li>\n";
				}
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		} elseif ($level == 4) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "</ul>\n</li>\n</ul>\n</li>\n</ul>\n</li>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$midashi_str .= "</ul>\n</li>\n</ul>\n</li>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$midashi_str .= "</ul>\n</li>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		}
		$comment = preg_replace($ptn0,'<midashi' . $midashi_count . '>',$comment,1);
		$midashi_count++;
	}
	for ($i = $level; $i > 0; $i--) {
		if ($i == 1) {
			$midashi_str .= "</ul>\n";
		} else {
			$midashi_str .= "</ul>\n</li>\n";
		}
	}
	if (!$level) {
		$midashi_str = '';
	}
	return(array($midashi_str,$comment,$midashi));
}


function midashi_old($comment,$id) {

	$ptn0 = '/(<(h[1234]).*?>(.+?)<\/h[1234]>?)/';
	$midashi_count = 0;
	$midashi = array();
	$midashi_str = '';
	$level = 0;
	$depth = 0;
	while (preg_match($ptn0,$comment,$matched)) {
		$midashi[$midashi_count] = $matched[1];
		$link = "<a href=\"#midashi$id$midashi_count\">" . $matched[3] . "</a>";
		if ($level == 0) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$depth = 1;
				$midashi_str .= "<ul>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$level = 3;
				$depth = 1;
				$midashi_str .= "<ul>\n<ul>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				$midashi_str .= "<ul>\n<ul>\n<ul>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		} elseif ($level == 1) {
			if ($matched[2] == 'h1') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$depth = 1;
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$level = 3;
				$depth = 1;
				$midashi_str .= "<ul>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				$midashi_str .= "<ul>\n<ul>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		} elseif ($level == 2) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "</ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$level = 3;
				$depth = 1;
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				$midashi_str .= "<ul>\n<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} 
		} elseif ($level == 3) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "</ul>\n</ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$midashi_str .= "</ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$level = 4;
				$depth = 1;
				$midashi_str .= "<ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		} elseif ($level == 4) {
			if ($matched[2] == 'h1') {
				$level = 1;
				$midashi_str .= "</ul>\n</ul>\n</ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h2') {
				$level = 2;
				$midashi_str .= "</ul>\n</ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h3') {
				$midashi_str .= "</ul>\n";
				$midashi_str .= "<li>" . $link . "</li>\n";
			} elseif ($matched[2] == 'h4') {
				$midashi_str .= "<li>" . $link . "</li>\n";
			}
		}
		$comment = preg_replace($ptn0,'<midashi' . $midashi_count . '>',$comment,1);
		$midashi_count++;
	}
	for ($i=$level; $i>=0; $i--) {
		$midashi_str .= "</ul>\n";
	}
	if (!$level) {
		$midashi_str = '';
	}
	return(array($midashi_str,$comment,$midashi));
}


function delete_dir($deldir) {
	$tmpdir = opendir($deldir);
	while ($file = readdir($tmpdir)) {
		if (!preg_match('/^\.{1,2}$/',$file)) {
			if (is_file($deldir . '/' . $file)) {
				unlink($deldir . '/' . $file);
			} elseif (is_dir($deldir . '/' . $file)) {
				delete_dir($deldir . '/' . $file);
			}
		}
	}
	closedir($tmpdir);
	if (rmdir($deldir)) {
		$mes = 'ディレクトリ<strong>' . $deldir . '</strong>を削除しました';
	} else {
		$mes = 'ディレクトリ<strong>' . $deldir . '</strong>を削除できませんでした';
	}
	return $mes;
}



function preview() {
	global $script,$datadir,$category_nmb,$color_list,$name,$yougo,$yougoid,$tag_list,$perm_tag_list,$post_mode,$dpl_list,$req;
	time_check('プレビューボタンによるプレビュー開始');
	$preview_str = '';
	$icat = req('category');
	if (! $icat) {
		if (req('category_l')) {
			$icat = req('category_l');
		}
	}
	$icat = category_list($icat);
	if ($icat) {
		if (isset($category_nmb[$icat])) {
			$show_cat = "<span style=\"border-radius:5px;padding:0 0.4em;margin-bottom:0.3em;font-weight:bold;background-color:" . $color_list[$category_nmb[$icat] % count($color_list)] . ";color:" . text_color($color_list[$category_nmb[$icat] % count($color_list)]) . ";\">" . $icat . "</span>&nbsp;&nbsp;";
		} elseif (strpos($icat,'&&') !== false) {
			$cats = explode('&&',$icat);
			$show_cat = '';
			foreach ($cats as $cat) {
				if (isset($category_nmb[$cat])) {
					$show_cat .= "<span style=\"border-radius:5px;padding:0 0.4em;margin-bottom:0.3em;font-weight:bold;background-color:" . $color_list[$category_nmb[$cat] % count($color_list)] . ";color:" . text_color($color_list[$category_nmb[$cat] % count($color_list)]) . ";\">" . $cat . "</span>&nbsp;&nbsp;";
				} else {
					$show_cat .= "<span style=\"padding:0 0.4em;margin-bottom:0.3em;font-weight:bold;\">" . $cat . "</span>&nbsp;&nbsp;";
				}
			}
		} else {
			$show_cat = "<span style=\"padding:0 0.4em;margin-bottom:0.3em;font-weight:bold;\">" . $icat . "</span>&nbsp;&nbsp;";
		}
	} else {
		$show_cat = '';
	}
	$preview_str .= "<div style=\"text-align:right;\">" . $show_cat . date("Y年m月d日 H:i",time()) . "</div>\n";
	$preview_comment = req('comment');
	if (get_magic_quotes_gpc()) {
		$preview_comment = stripslashes($preview_comment);
	}
	$preview_comment = str_replace('&lt;|&gt;','',$preview_comment);
	$preview_comment = str_replace(array("\r\n","\r","\n"), '/n/', $preview_comment);
	$preview_comment = str_replace('<|>','',$preview_comment);
	if (req('name') && $name != req('name')) {
		$name = req('name');
	}
	$other_name = '';
	if (strpos($name,'&&') !== false) {
		$list = explode('&&',$name);
		$i = 0;
		$name = array_shift($list);
		$other_name = join('&nbsp;&nbsp;',$list);
	}
	if ($other_name) {
		$other_name = '<div>別名：' . $other_name . "</div>\n";
	}
	$preview_str .= "<div class=\"title\">$name</div>\n";
	$preview_str .= $other_name;

	if (is_array($yougo)) {
		$key_list2 = array_keys($yougo);
	} else {
		$key_list2 = array();
	}
	//usort( $key_list2 , create_function( '$a,$b', 'return strlen( $b ) - strlen( $a );' ) );
	usort( $key_list2 , function($a,$b) { return strlen( $b ) - strlen( $a ); } );
	$trans_list = array();
	$trans_count = 0;

	// 置換しない部分をあらかじめ別の文字列に置き換えておき、用語置換終了後元に戻す。
	$ptn0 = '/<(span|div) class="notrans">([^<]+)<\/(span|div)>?/';
	$ntrcount = 0;
	$notrans = array();
	while (preg_match($ptn0,$preview_comment,$matched)) {
		$notrans[$ntrcount] =$matched[2];
		$preview_comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$preview_comment,1);
		$ntrcount++;
	}
	// <a>タグ内も置き換えを避ける
	$ptn0 = '/(<a[^>]*>[^<]+<\/a>?)/';
	while (preg_match($ptn0,$preview_comment,$matched)) {
		$notrans[$ntrcount] =$matched[1];
		$preview_comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$preview_comment,1);
		$ntrcount++;
	}

	// <img>タグ内も置き換えを避ける
	$ptn0 = '/(<img[^>]*>?)/';
	while (preg_match($ptn0,$preview_comment,$matched)) {
		$notrans[$ntrcount] =$matched[1];
		$preview_comment = preg_replace($ptn0,'<notrans' . $ntrcount . '>',$preview_comment,1);
		$ntrcount++;
	}

	// <pre>タグ内のタグは有効化しないことにする
	$ptn = '|(<pre[^>]*?>)([\s\S]*?)(<\/pre>)|';
	$pre = array();
	$count = 0;
	while (preg_match($ptn,$preview_comment,$matched)) {
		$preview_comment = preg_replace($ptn,'[pre' . $count . ']',$preview_comment,1);
		$matched[2] = str_replace('<','&lt;',$matched[2]);
		$matched[2] = str_replace('>','&gt;',$matched[2]);
		$matched[2] = str_replace('[','&#91;',$matched[2]);
		$matched[2] = str_replace(']','&#93;',$matched[2]);
		$pre[$count] = $matched[1] . $matched[2] . $matched[3];
		$count++;
	}
	
	// プラグイン部分置き換え
	$prgcount = 0;
	$plugin = array();
	$ptn0 = '/\[\[([^]]+)\]\]?/';
	while (preg_match($ptn0,$preview_comment,$matched)) {
		$plugin[$prgcount] =$matched[1];
		$preview_comment = preg_replace($ptn0,'<plugin' . $prgcount . '>',$preview_comment,1);
		$prgcount++;
	}

	list($midashi_str,$preview_comment,$midashi) = midashi($preview_comment,req('edit'));
	// 改修メモ 用語置換に引っかからないように、<span style="notrans"></span>で囲まれた部分をいったん別の文字列に置き換え、
	// 用語置換が終わった後元に戻すという処理だが、
	// preg_matchで該当箇所の文字列を取得してさらにpreg_replaceで文字列を置き換えているが、イマイチスマートじゃない。

	foreach ($key_list2 as $key) {
		if ($key == $name) { continue; }
		if (strpos($name,'&&') !== false) {
			$names = explode('&&',$name);
			$contin = 0;
			foreach ($names as $_) {
				if ($key == $_) { $contin = 1;
					break;
				}
			}
			if ($contin) { continue; }
		}
		if (strpos($name,$key) != false) { continue; }
		
		if (file_exists($datadir . '/' . $yougoid[$key] . '.cgi')) {
			list($line) = file($datadir . '/' . $yougoid[$key] . '.cgi');
			list($dum,$dum,$title) = explode('<>',$line);
			list($title) = explode('<||>',$title);
			if (strlen($title) > strlen(jtruncate($title,1000))) {
				$title = jtruncate($title,1000) . '...';
			}
		}
		if (isset($dpl_list[$key]) && count($dpl_list[$key]) > 1) {
			$title = '';
			$com_nmb = 1;
			foreach ($dpl_list[$key] as $_) {
				list($log) = file(join('/',array($datadir,$_ . '.cgi')));
				$tmp = explode('<>',$log);
				$com = $tmp[2];
				list($com) = explode('<||>',$com);
				if (strlen($com) > strlen(jtruncate($com,300))) {
					$com = jtruncate($com,300) . '...';
				}
				$title .= "($com_nmb)" . $com . "|n|------------------------------------------|n|";
				$com_nmb++;
			}
			// とりあえず検索にしておく　後で改修予定
			$url = "./${script}?noform=all";
			$url .= "&amp;title_keyword=" . urlencode($key) . "&amp;search=1";
			if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
		} else {
			if (isset($yougoid[$key])) {
				$url = "./${script}?noform=" . $yougoid[$key] . '&amp;noindex=' . req('noindex');
			} else {
				$url = "./${script}?noindex=" . req('noindex');
			}
			if ($req['sort']) { $url .= "&amp;sort=" . $req['sort']; }
		}
		$title = str_replace('<br />',"|n|",$title);
		$title = str_replace('"','”',$title);
		$title = strip_tags($title);
		$title = $key . '|n|' . $title;
		$title = jtruncate($title,1024);
		$tmp = trans($preview_comment,$key,$trans_count);
		if ($tmp) {
			$preview_comment = $tmp[0];
			$trans_list[$trans_count] = '<a style="color:blue;" href="' . $url . '" title="' . $title . '">' . $tmp[1] . '</a>';
			$trans_count++;
		}
	}
	$trans_count = 0;
	foreach ($trans_list as $trans) {
		$preview_comment = str_replace('<trans' . $trans_count . '>',$trans,$preview_comment);
		$trans_count++;
	}
	if ($notrans) {
		foreach (array_keys($notrans) as $key) {
			$preview_comment = str_replace('<notrans' . $key . '>',$notrans[$key],$preview_comment);
		}
	}
	if ($midashi) {
		foreach (array_keys($midashi) as $key) {
			//$midashi[$key] = preg_replace('/(<h[1234])/','$1 name="midashi' . req('edit') . $key . '" id="midashi' . req('edit') . $key . '"',$midashi[$key]);
			$midashi[$key] = preg_replace('/(<h[1234])/','$1 id="midashi' . req('edit') . $key . '"',$midashi[$key]);
			$preview_comment = str_replace('<midashi' . $key . '>',$midashi[$key],$preview_comment);
		}
	}
	if ($plugin) {
		foreach (array_keys($plugin) as $key) {
			$tmp = explode('(',$plugin[$key]);
			$pipath = './plugin/' . $tmp[0] . '.php';
			if ( ! preg_match('/^[a-zA-Z0-9_]+$/',$tmp[0])) {
				$str = '[[' . $plugin[$key] . ']]';
			} elseif (file_exists($pipath)) {
				require_once $pipath;
				if (chk_plugin($plugin[$key]) != 'error') {
					$code = '$str = ' . $plugin[$key];
					if (!preg_match('/;\s?$/',$code)) {
						$code .= ';';
					}
					if (!preg_match('/\(.*\);\s?$/',$code)) {
						$code = preg_replace('/;\s?$/','();',$code);
					}
					eval ($code);
				} else {
					$str = '[[' . $plugin[$key] . ']]プラグインの記述が間違っています';
				}
			} else {
				$str = '<div style="background-color:#cccccc"><span style="color:red;">plugin error</span>&nbsp;[[' . $plugin[$key] . ']]</div>';
			}
			if (is_array($str)) {
				list($str1,$str2) = $str;
				$preview_comment = str_replace('<plugin' . $key . '>',$str1,$preview_comment) . $str2;
			} else {
				$preview_comment = str_replace('<plugin' . $key . '>',$str,$preview_comment);
			}
			//$preview_comment = str_replace('<plugin' . $key . '>',$str,$preview_comment);
		}
	}
	if (!$post_mode) {
		$ptn = '/&lt;(\/?(' . join('|',$perm_tag_list) . ')(\s+.*?)?)&gt;?/';
		$ptn2 = '<$1>';
		$preview_comment = preg_replace($ptn,$ptn2,$preview_comment);	// 許可タグのみ戻す
	} else {
		$ptn = '/&lt;(\/?(' . join('|',$tag_list) . ')(\s+.*?)?)&gt;?/';
		$ptn2 = '<$1>';
		$preview_comment = preg_replace($ptn,$ptn2,$preview_comment);	// 許可タグのみ戻す
	}
	foreach ($pre as $key=>$val) {
		$preview_comment = str_replace('[pre' . $key . ']',$val,$preview_comment);
	}

	$preview_comment = str_replace('|n|',"\n",$preview_comment);
	$preview_comment = str_replace('/n/',"\n",$preview_comment);

	$preview_comment = str_replace("\r\n","\n",$preview_comment);
	$preview_comment = str_replace("\r","\n",$preview_comment);
	if (req('trans_br')) {
		$preview_comment = str_replace(">\n",">",$preview_comment);
		$preview_comment = str_replace("]]\n","]]",$preview_comment);
		$preview_comment = str_replace("\n","<br />",$preview_comment);
		$preview_comment = str_replace("/n/","",$preview_comment);
	} else {
		$preview_comment = str_replace("\n","",$preview_comment);
	}

	if (isset($midashi_str) && $midashi_str) {
		$count = 0;
		$tmp = "<div class=\"notprint\" style=\"background-color:#ffeef8;padding:0.3em;margin:0.5em;\">
		<div onclick=\"obj=document.getElementById('open" . $count . "').style; obj.display=(obj.display=='none')?'block':'none';\"><a style=\"cursor:pointer;\">アウトライン</a></div>\n";
		$midashi_str = "$tmp<div id=\"open" . $count . "\" style=\"display:none;clear:both;\">$midashi_str</div>\n</div>\n";
		$preview_str .= "<div>$midashi_str$preview_comment</div>\n";
	} else {
		$preview_str .= "<div>$preview_comment</div>\n";
	}
	time_check('プレビューボタンによるプレビュー終了');
	return($preview_str);
}




function nmb_index() {
	global $yougo_log,$count,$page,$req,$return,$url,$script,$current_back_color,$admin_back_color;
	
	$max_pg = 20;
	if ($req['sort'] == 'other') {
		$max_pg = 9;
	}
	if (req('edit')) {
		$nmb = 0;
		foreach ($yougo_log as $line) {
			$tmp = explode('<>',$line);
			if ($tmp[0] == req('edit')) {
				$page = intval($nmb/$return);
			}
			$nmb++;
		}
	}
	$index1 = '';
	$st_pg = 0;
	if (req('st_pg')) {
		$st_pg = req('st_pg');
	}
	$log_total = count($yougo_log);
	if ($log_total > $count + 1) {
		$log_total = $count + 1;
	}
	if ($st_pg + $max_pg <= $page) {
		$st_pg = $page - $max_pg + 1;
	}
	if ($st_pg > 0) {
		$url = "$script?mode=yougo&amp;page=" . ($page - 1) . "&amp;noform=all";
		foreach (array('hide_thum','keyword','category_filter','sort') as $key) {
			$url .= "&amp;$key=" . urlencode(req($key));
		}
		$back = $st_pg - $max_pg;
		if ($back < 0) {
			$back =0;
		}
		$url = preg_replace('/page=(\d+)/','page=' . $back,$url);
		$url .= "&amp;st_pg=" . $back;
		$index1 .= "<a href=\"$url\" style=\"font-size:120%;\"><img src=\"./img/strt.gif\" style=\"position:relative;top:4px;\" alt=\"←\" /></a>";
	}
	for ($i = $st_pg; $i <= intval(($log_total-1)/$return); $i++) {
		if ($i - $st_pg >= $max_pg) { break; }
		$url = "$script?mode=yougo&amp;page=$i&amp;noform=all";
		foreach (array('hide_thum','keyword','category_filter','st_pg') as $key) {
			$url .= "&amp;$key=" . urlencode(req($key));
		}
		$url .= "&amp;sort=" . $req['sort'];
		if ($page == $i) {
			$index1 .= "<a href=\"$url\" style=\"background-color:$current_back_color;\">[" . ($i+1) . "]</a> ";
		} else {
			$index1 .= "<a href=\"$url\">[" . ($i+1) . "]</a> ";
		}
	}
	if ($page < intval(($log_total-1)/$return)) {
		$url = "$script?mode=yougo&amp;page=" . ($page + 1) . "&amp;noform=all";
		foreach (array('hide_thum','keyword','category_filter') as $key) {
			$url .= "&amp;$key=" . urlencode(req($key));
		}
		$url .= "&amp;sort=" . $req['sort'];
		$url .= "&amp;st_pg=" . ($st_pg + 1);
	}
	$last = $st_pg + $max_pg;
	if ($last > intval(($log_total-1)/$return) - $max_pg + 1) {
		$last = intval(($log_total-1)/$return) - $max_pg + 1;
	}
	$url = preg_replace('/page=(\d+)/','page=' . $last,$url);
	$next = preg_replace('/st_pg=(\d+)/','st_pg=' . $last,$url);
	
	// 要調整
	if ($st_pg + $max_pg < intval(($log_total)/$return + 1) ) {
		$index1 .= "<a href=\"$next\" style=\"font-size:120%;\"><img src=\"./img/end.gif\" style=\"position:relative;top:4px;\" alt=\"→\" /></a>";
	}
	return($index1);
}



function dispos_login_file() {
	global $expr;
	if (! is_dir('./login')) { mkdir('./login'); }
	$tmp = opendir('./login');
	while ($file = readdir($tmp)) {
		if (preg_match('/\.cgi$/',$file)) {
			$path = './login/' . $file;
		//	if (filemtime($path) + $expr * 60 < time() || filectime($path) + 3600 < time()) {
			if (filemtime($path) + $expr * 60 < time()) {
				unlink($path);		// 10分以上古いログインファイルは削除
			}
		}
	}
	closedir($tmp);
}

// 時間ログはエポック関数ではなく、日付文字列で保存するよう修正
function time_str($tm = '') {
	$d = date_create($tm);
	$time_str = date_format($d, "Y/m/d H:i:s");
	return $time_str;
}

// date2("Y/m/d H:i:s",$tm)のように使用	$tmはエポック関数でも日付文字列でもOK
function date2($format,$tm) {
	if (preg_match('/^\d+$/',$tm)) {
		$tm = $tm - 0;
	}
	if (gettype($tm) == 'integer') {
		$tstr = date("Y/m/d H:i:s",$tm);
		$d = date_create($tstr);
	} else {
		$d = date_create($tm);
	}
	return date_format($d, $format);
}

// $str内の$keyを<trans数>に置き換え、置き換えた文字列と置換した文字列のリストを返す。
function trans($str,$key,$count) {
	$pre = '';
	$aft = '';
	if (preg_match("/^[a-zA-Z]/", $key)) {
		$pre = '[^a-zA-Z]|\b';
		//$pre = '?![a-zA-Z]';
	} elseif (preg_match("/^\d/", $key)) {
		$pre = '[^\d]|\b';
	} 
	if (preg_match("/[a-zA-Z]$/", $key)) {
		$aft = '?![a-zA-Z-]';
	} elseif (preg_match("/\d$/", $key)) {
		$aft = '?![\d]';
	}
	$ptn4 = '{(' . $pre . ')(' . $key . ')(' . $aft . ')}i';
	if (preg_match($ptn4,$str,$matched)) {
		if (! isset($matched[3])) {
			$matched[3] = '';
		}
		return array(preg_replace($ptn4,$matched[1] . '<trans' . $count . '>' . $matched[3],$str,1),$matched[2]);
	} else {
		return;
	}
}

function chk_plugin($plugin) {
	$err = '';
	if (preg_match('/\(([^)]*)\);?\s*$/',$plugin,$match)) {
		$arg = $match[1];
		$arg_list = explode(',',$arg);
		foreach ($arg_list as $arg) {
			if ($arg && !preg_match('/^\d+$/',$arg) && !preg_match('/^\'(.*)\'$/',$arg,$mat)) {
				$err = 1;
			} elseif (!$arg) {
				$err = 1;
			}
		}
	} elseif (preg_match('/\(.*[^)]?$/',$plugin)) {
		$err = 2;
	}
	if ($err) {
		return 'error';
	} else {
		return $plugin;
	}
}

function counter($id) {
	global $datadir, $count_seq;
	if (!file_exists($datadir . '/counter')) { mkdir($datadir . '/counter'); }
	if ($count_seq) {
		file_put_contents($datadir . '/counter/' . $id . '.cgi','1',FILE_APPEND | LOCK_EX);
		//file_put_contents($datadir . '/counter/' . $id . '_ip.cgi',time_str('') . '<>' . $_SERVER['REMOTE_ADDR'] . "\n",FILE_APPEND | LOCK_EX);
	} else {
		$ip = '';
		$log = array();
		if (file_exists($datadir . '/counter/' . $id . '_ip.cgi')) {
			$log = file($datadir . '/counter/' . $id . '_ip.cgi',FILE_IGNORE_NEW_LINES);
			$line = end($log);
			list($tm,$ip) = explode('<>',$line);
		}
		if (!$ip || $ip != $_SERVER['REMOTE_ADDR']) {
			file_put_contents($datadir . '/counter/' . $id . '.cgi','1',FILE_APPEND | LOCK_EX);
		}
		if ($ip != $_SERVER['REMOTE_ADDR']) {
			if ($log && count($log) > 10) {
				$log = array_slice($log,-10,10);
				file_put_contents($datadir . '/counter/' . $id . '_ip.cgi',join("\n",$log) . "\n", LOCK_EX);
			}
			file_put_contents($datadir . '/counter/' . $id . '_ip.cgi',time_str('') . '<>' . $_SERVER['REMOTE_ADDR'] . "\n",FILE_APPEND | LOCK_EX);
		}
	}
}

function article_id() {
	global $id;
	//if (! isset($id)) {
//	/*	デバッグ用
	$logs = debug_backtrace();
	$str = '';
	$str .= "\$id=$id";
	foreach ($logs as $log) {
		$base = basename($log['file']);
		$str .= "  file=" . $base;
		$str .= "  line=" . $log['line'];
		$str .= "  function=" . $log['function'];
	}
	$str .= "\n";
//	*/
	if (! $id) {
		if (req('noform')) {
			$id = req('noform');
		} elseif (req('edit')) {
			$id = req('edit');
		}
	}
	if ($id == 'all') { $id = ''; }
	return $id;
}


function article_dir($id) {
	global $script,$datadir;
	if ($id) {
		$id_dir = join('/',array($datadir,$id));
		return $id_dir;
	}
}

function tag_convert($html,$tag_list = array()) {
	global $perm_tag_list,$post_mode;
	if (!$tag_list) { global $tag_list; }
	$html = str_replace("<","&lt;",$html);
	$html = str_replace(">","&gt;",$html);
	if (!$post_mode && !req('plugin')) {
		$ptn = '/&lt;(\/?(' . join('|',$perm_tag_list) . ')(\s+.*?)?)&gt;?/';
		$ptn2 = '<$1>';
		$html = preg_replace($ptn,$ptn2,$html);
	} else {
		$ptn = '/&lt;(\/?(' . join('|',$tag_list) . ')(\s+.*?)?)&gt;?/';
		$ptn2 = '<$1>';
		$html = preg_replace($ptn,$ptn2,$html);
	}
	return($html);
}

function week_name($year,$month,$day) {
	$week_name = array('日','月','火','水','木','金','土');
	return $week_name[getweek($day,$year,$month)];
}

function get_holiday($year,$month,$day) {
	$holiday = holiday($year,$month,$day);
	$holiday = mb_convert_encoding($holiday,'utf-8','euc-jp');
	return $holiday;
}

function script_link($hash = array()) {
	global $script;
	$str = $script;
	$first = 1;
	foreach ($hash as $key=>$val) {
		if ($first) {
			$str .= "?$key=$val";
		} else {
			$str .= "&amp;$key=$val";
		}
		$first = 0;
	}
	return $str;
}

function auto_link($str) {
	$patterns = array("/(https?|ftp)(:\/\/[[:alnum:]\+\$\;\?\.%,!#~*\/:@&=_-]+)/i");
	$replacements = array("<a href=\"\\1\\2\">\\1\\2</a>");
	$ret = preg_replace($patterns, $replacements, $str);
	return $ret;
}

function script_form($hash = array(), $jump = '') {
	global $script;
	$str = "<form action=\"$script#$jump\" method=\"post\" style=\"margin:0\">\n";
	foreach ($hash as $key=>$val) {
		$str .= "<input type=\"hidden\" name=\"$key\" value=\"$val\" />\n";
	}
	return $str;
}

function script_form_file($hash = array(), $jump = '', $id = '') {
	global $script;
	if ($id) { $id = " id=\"$id\""; }
	$str = "<form$id action=\"$script#$jump\" method=\"post\" style=\"margin:0\" enctype=\"multipart/form-data\">\n";
	foreach ($hash as $key=>$val) {
		$str .= "<input type=\"hidden\" name=\"$key\" value=\"$val\" />\n";
	}
	return $str;
}

function dir_size($dir) {
	$handle = opendir($dir);
	$mas = 0;
	while ($file = readdir($handle)) {
		if ($file != '..' && $file != '.' && !is_dir($dir.'/'.$file)) {
			$mas += filesize($dir.'/'.$file);
		} else if (is_dir($dir.'/'.$file) && $file != '..' && $file != '.') {
			$mas += dir_size($dir.'/'.$file);
		}
	}
	return $mas;
}

function size_format($size) {
	if ($size < 1024) {
		return number_format($size) . 'byte';
	} elseif ($size < 1024 * 1024) {
		return number_format(intval($size / 1024)) . 'KB';
	} elseif ($size < 1024 * 1024 * 1024) {
		return number_format(intval($size / 1024 / 1024)) . 'MB';
	} elseif ($size < 1024 * 1024 * 1024 * 1024) {
		return number_format(intval($size / 1024 / 1024 /1024)) . 'GB';
	} else {
		return number_format(intval($size / 1024 / 1024 /1024 /1024)) . 'TB';
	}
}

function download() {
	$file = req('file');
	$file_name = req('name');
	$file_name = str_replace(' ','_',$file_name);
	if (file_exists($file)) {
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		if (req('name')) {
			header('Content-Disposition: attachment; filename='. $file_name);
		} else {
			header('Content-Disposition: attachment; filename='.basename($file));
		}
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($file));
		readfile($file);
		$count_file = $file . '.count';
		file_put_contents($count_file,'1',FILE_APPEND | LOCK_EX);
		exit;
	}
}


function pdf_preview() {
	$y = substr(req('pdf_preview'),0,4);
	$m = substr(req('pdf_preview'),4,2);
	$d = substr(req('pdf_preview'),6,2);
	if ($_SERVER["HTTP_HOST"] == 'www.rkb-cg.com') {
		$url = "http://" . 'guest:rkbcg@' . $_SERVER["HTTP_HOST"] . $_SERVER["SCRIPT_NAME"] . "?preview=$y$m$d";
	} else {
		$url = "http://" . $_SERVER["HTTP_HOST"] . $_SERVER["SCRIPT_NAME"] . "?preview=$y$m$d";
	}
	mpdf_preview($url,'');
}


function mpdf_preview($url,$file) {
	require_once('./mpdf/mpdf.php');
	$html = curl_get_contents($url);		// こっちの方が早いという説もあるが
//	$html = file_get_contents($url);
//	$html = mb_convert_encoding($html,"SJIS-win","EUC-JP");		// なぜかEUC-JPからUTF-8に直接変換すると「﨑」などが文字化けするので、いったんSJIS-winに変換する。
//	$html = mb_convert_encoding($html,"UTF-8","SJIS-win");
	$mpdf = new mpdf('ja+aCJK');
	$mpdf->WriteHTML($html);
	if ($file) {
		$mpdf->Output($file,'F');
	} else {
		$mpdf->Output();
	}
}


function curl_get_contents( $url, $timeout = 60 ){
    $ch = curl_init();
    curl_setopt( $ch, CURLOPT_URL, $url );
    curl_setopt( $ch, CURLOPT_HEADER, false );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
    curl_setopt( $ch, CURLOPT_TIMEOUT, $timeout );
    $result = curl_exec( $ch );
    curl_close( $ch );
    return $result;
}

?>